package org.eclipse.lsat.machine.teditor.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.lsat.machine.teditor.services.MachineGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalMachineParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_ID", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'PassiveResource'", "'EventResource'", "'Resource'", "'Machine'", "'PathAnnotations'", "'{'", "'}'", "'import'", "'PeripheralType'", "'Actions'", "'SetPoints'", "'Axes'", "'Conversion'", "'['", "']'", "'moves'", "','", "'('", "')'", "':'", "'Profiles'", "'AxisPositions'", "'SymbolicPositions'", "'Distances'", "'Paths'", "'.'", "'-->'", "'profiles'", "'profile'", "'@'", "'<->'", "'FullMesh'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__38=38;
    public static final int T__17=17;
    public static final int T__39=39;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=4;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__40=40;
    public static final int T__41=41;
    public static final int T__20=20;
    public static final int T__42=42;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalMachineParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMachineParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMachineParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMachine.g"; }


    	private MachineGrammarAccess grammarAccess;

    	public void setGrammarAccess(MachineGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleMachine"
    // InternalMachine.g:61:1: entryRuleMachine : ruleMachine EOF ;
    public final void entryRuleMachine() throws RecognitionException {
        try {
            // InternalMachine.g:62:1: ( ruleMachine EOF )
            // InternalMachine.g:63:1: ruleMachine EOF
            {
             before(grammarAccess.getMachineRule()); 
            pushFollow(FOLLOW_1);
            ruleMachine();

            state._fsp--;

             after(grammarAccess.getMachineRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleMachine"


    // $ANTLR start "ruleMachine"
    // InternalMachine.g:70:1: ruleMachine : ( ( rule__Machine__Group__0 ) ) ;
    public final void ruleMachine() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:74:2: ( ( ( rule__Machine__Group__0 ) ) )
            // InternalMachine.g:75:2: ( ( rule__Machine__Group__0 ) )
            {
            // InternalMachine.g:75:2: ( ( rule__Machine__Group__0 ) )
            // InternalMachine.g:76:3: ( rule__Machine__Group__0 )
            {
             before(grammarAccess.getMachineAccess().getGroup()); 
            // InternalMachine.g:77:3: ( rule__Machine__Group__0 )
            // InternalMachine.g:77:4: rule__Machine__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getMachineAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleMachine"


    // $ANTLR start "entryRuleImport"
    // InternalMachine.g:86:1: entryRuleImport : ruleImport EOF ;
    public final void entryRuleImport() throws RecognitionException {
        try {
            // InternalMachine.g:87:1: ( ruleImport EOF )
            // InternalMachine.g:88:1: ruleImport EOF
            {
             before(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getImportRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalMachine.g:95:1: ruleImport : ( ( rule__Import__Group__0 ) ) ;
    public final void ruleImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:99:2: ( ( ( rule__Import__Group__0 ) ) )
            // InternalMachine.g:100:2: ( ( rule__Import__Group__0 ) )
            {
            // InternalMachine.g:100:2: ( ( rule__Import__Group__0 ) )
            // InternalMachine.g:101:3: ( rule__Import__Group__0 )
            {
             before(grammarAccess.getImportAccess().getGroup()); 
            // InternalMachine.g:102:3: ( rule__Import__Group__0 )
            // InternalMachine.g:102:4: rule__Import__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRulePathAnnotation"
    // InternalMachine.g:111:1: entryRulePathAnnotation : rulePathAnnotation EOF ;
    public final void entryRulePathAnnotation() throws RecognitionException {
        try {
            // InternalMachine.g:112:1: ( rulePathAnnotation EOF )
            // InternalMachine.g:113:1: rulePathAnnotation EOF
            {
             before(grammarAccess.getPathAnnotationRule()); 
            pushFollow(FOLLOW_1);
            rulePathAnnotation();

            state._fsp--;

             after(grammarAccess.getPathAnnotationRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePathAnnotation"


    // $ANTLR start "rulePathAnnotation"
    // InternalMachine.g:120:1: rulePathAnnotation : ( ( rule__PathAnnotation__Group__0 ) ) ;
    public final void rulePathAnnotation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:124:2: ( ( ( rule__PathAnnotation__Group__0 ) ) )
            // InternalMachine.g:125:2: ( ( rule__PathAnnotation__Group__0 ) )
            {
            // InternalMachine.g:125:2: ( ( rule__PathAnnotation__Group__0 ) )
            // InternalMachine.g:126:3: ( rule__PathAnnotation__Group__0 )
            {
             before(grammarAccess.getPathAnnotationAccess().getGroup()); 
            // InternalMachine.g:127:3: ( rule__PathAnnotation__Group__0 )
            // InternalMachine.g:127:4: rule__PathAnnotation__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPathAnnotationAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePathAnnotation"


    // $ANTLR start "entryRulePeripheralType"
    // InternalMachine.g:136:1: entryRulePeripheralType : rulePeripheralType EOF ;
    public final void entryRulePeripheralType() throws RecognitionException {
        try {
            // InternalMachine.g:137:1: ( rulePeripheralType EOF )
            // InternalMachine.g:138:1: rulePeripheralType EOF
            {
             before(grammarAccess.getPeripheralTypeRule()); 
            pushFollow(FOLLOW_1);
            rulePeripheralType();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePeripheralType"


    // $ANTLR start "rulePeripheralType"
    // InternalMachine.g:145:1: rulePeripheralType : ( ( rule__PeripheralType__Group__0 ) ) ;
    public final void rulePeripheralType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:149:2: ( ( ( rule__PeripheralType__Group__0 ) ) )
            // InternalMachine.g:150:2: ( ( rule__PeripheralType__Group__0 ) )
            {
            // InternalMachine.g:150:2: ( ( rule__PeripheralType__Group__0 ) )
            // InternalMachine.g:151:3: ( rule__PeripheralType__Group__0 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup()); 
            // InternalMachine.g:152:3: ( rule__PeripheralType__Group__0 )
            // InternalMachine.g:152:4: rule__PeripheralType__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePeripheralType"


    // $ANTLR start "entryRuleActionType"
    // InternalMachine.g:161:1: entryRuleActionType : ruleActionType EOF ;
    public final void entryRuleActionType() throws RecognitionException {
        try {
            // InternalMachine.g:162:1: ( ruleActionType EOF )
            // InternalMachine.g:163:1: ruleActionType EOF
            {
             before(grammarAccess.getActionTypeRule()); 
            pushFollow(FOLLOW_1);
            ruleActionType();

            state._fsp--;

             after(grammarAccess.getActionTypeRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleActionType"


    // $ANTLR start "ruleActionType"
    // InternalMachine.g:170:1: ruleActionType : ( ( rule__ActionType__Group__0 ) ) ;
    public final void ruleActionType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:174:2: ( ( ( rule__ActionType__Group__0 ) ) )
            // InternalMachine.g:175:2: ( ( rule__ActionType__Group__0 ) )
            {
            // InternalMachine.g:175:2: ( ( rule__ActionType__Group__0 ) )
            // InternalMachine.g:176:3: ( rule__ActionType__Group__0 )
            {
             before(grammarAccess.getActionTypeAccess().getGroup()); 
            // InternalMachine.g:177:3: ( rule__ActionType__Group__0 )
            // InternalMachine.g:177:4: rule__ActionType__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getActionTypeAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleActionType"


    // $ANTLR start "entryRuleSetPoint"
    // InternalMachine.g:186:1: entryRuleSetPoint : ruleSetPoint EOF ;
    public final void entryRuleSetPoint() throws RecognitionException {
        try {
            // InternalMachine.g:187:1: ( ruleSetPoint EOF )
            // InternalMachine.g:188:1: ruleSetPoint EOF
            {
             before(grammarAccess.getSetPointRule()); 
            pushFollow(FOLLOW_1);
            ruleSetPoint();

            state._fsp--;

             after(grammarAccess.getSetPointRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSetPoint"


    // $ANTLR start "ruleSetPoint"
    // InternalMachine.g:195:1: ruleSetPoint : ( ( rule__SetPoint__Group__0 ) ) ;
    public final void ruleSetPoint() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:199:2: ( ( ( rule__SetPoint__Group__0 ) ) )
            // InternalMachine.g:200:2: ( ( rule__SetPoint__Group__0 ) )
            {
            // InternalMachine.g:200:2: ( ( rule__SetPoint__Group__0 ) )
            // InternalMachine.g:201:3: ( rule__SetPoint__Group__0 )
            {
             before(grammarAccess.getSetPointAccess().getGroup()); 
            // InternalMachine.g:202:3: ( rule__SetPoint__Group__0 )
            // InternalMachine.g:202:4: rule__SetPoint__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSetPoint"


    // $ANTLR start "entryRuleAxis"
    // InternalMachine.g:211:1: entryRuleAxis : ruleAxis EOF ;
    public final void entryRuleAxis() throws RecognitionException {
        try {
            // InternalMachine.g:212:1: ( ruleAxis EOF )
            // InternalMachine.g:213:1: ruleAxis EOF
            {
             before(grammarAccess.getAxisRule()); 
            pushFollow(FOLLOW_1);
            ruleAxis();

            state._fsp--;

             after(grammarAccess.getAxisRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxis"


    // $ANTLR start "ruleAxis"
    // InternalMachine.g:220:1: ruleAxis : ( ( rule__Axis__Group__0 ) ) ;
    public final void ruleAxis() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:224:2: ( ( ( rule__Axis__Group__0 ) ) )
            // InternalMachine.g:225:2: ( ( rule__Axis__Group__0 ) )
            {
            // InternalMachine.g:225:2: ( ( rule__Axis__Group__0 ) )
            // InternalMachine.g:226:3: ( rule__Axis__Group__0 )
            {
             before(grammarAccess.getAxisAccess().getGroup()); 
            // InternalMachine.g:227:3: ( rule__Axis__Group__0 )
            // InternalMachine.g:227:4: rule__Axis__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxis"


    // $ANTLR start "entryRuleResourceItem"
    // InternalMachine.g:236:1: entryRuleResourceItem : ruleResourceItem EOF ;
    public final void entryRuleResourceItem() throws RecognitionException {
        try {
            // InternalMachine.g:237:1: ( ruleResourceItem EOF )
            // InternalMachine.g:238:1: ruleResourceItem EOF
            {
             before(grammarAccess.getResourceItemRule()); 
            pushFollow(FOLLOW_1);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceItemRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleResourceItem"


    // $ANTLR start "ruleResourceItem"
    // InternalMachine.g:245:1: ruleResourceItem : ( ( rule__ResourceItem__Group__0 ) ) ;
    public final void ruleResourceItem() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:249:2: ( ( ( rule__ResourceItem__Group__0 ) ) )
            // InternalMachine.g:250:2: ( ( rule__ResourceItem__Group__0 ) )
            {
            // InternalMachine.g:250:2: ( ( rule__ResourceItem__Group__0 ) )
            // InternalMachine.g:251:3: ( rule__ResourceItem__Group__0 )
            {
             before(grammarAccess.getResourceItemAccess().getGroup()); 
            // InternalMachine.g:252:3: ( rule__ResourceItem__Group__0 )
            // InternalMachine.g:252:4: rule__ResourceItem__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getResourceItemAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResourceItem"


    // $ANTLR start "entryRuleResource"
    // InternalMachine.g:261:1: entryRuleResource : ruleResource EOF ;
    public final void entryRuleResource() throws RecognitionException {
        try {
            // InternalMachine.g:262:1: ( ruleResource EOF )
            // InternalMachine.g:263:1: ruleResource EOF
            {
             before(grammarAccess.getResourceRule()); 
            pushFollow(FOLLOW_1);
            ruleResource();

            state._fsp--;

             after(grammarAccess.getResourceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleResource"


    // $ANTLR start "ruleResource"
    // InternalMachine.g:270:1: ruleResource : ( ( rule__Resource__Group__0 ) ) ;
    public final void ruleResource() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:274:2: ( ( ( rule__Resource__Group__0 ) ) )
            // InternalMachine.g:275:2: ( ( rule__Resource__Group__0 ) )
            {
            // InternalMachine.g:275:2: ( ( rule__Resource__Group__0 ) )
            // InternalMachine.g:276:3: ( rule__Resource__Group__0 )
            {
             before(grammarAccess.getResourceAccess().getGroup()); 
            // InternalMachine.g:277:3: ( rule__Resource__Group__0 )
            // InternalMachine.g:277:4: rule__Resource__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResource"


    // $ANTLR start "entryRulePeripheral"
    // InternalMachine.g:286:1: entryRulePeripheral : rulePeripheral EOF ;
    public final void entryRulePeripheral() throws RecognitionException {
        try {
            // InternalMachine.g:287:1: ( rulePeripheral EOF )
            // InternalMachine.g:288:1: rulePeripheral EOF
            {
             before(grammarAccess.getPeripheralRule()); 
            pushFollow(FOLLOW_1);
            rulePeripheral();

            state._fsp--;

             after(grammarAccess.getPeripheralRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePeripheral"


    // $ANTLR start "rulePeripheral"
    // InternalMachine.g:295:1: rulePeripheral : ( ( rule__Peripheral__Group__0 ) ) ;
    public final void rulePeripheral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:299:2: ( ( ( rule__Peripheral__Group__0 ) ) )
            // InternalMachine.g:300:2: ( ( rule__Peripheral__Group__0 ) )
            {
            // InternalMachine.g:300:2: ( ( rule__Peripheral__Group__0 ) )
            // InternalMachine.g:301:3: ( rule__Peripheral__Group__0 )
            {
             before(grammarAccess.getPeripheralAccess().getGroup()); 
            // InternalMachine.g:302:3: ( rule__Peripheral__Group__0 )
            // InternalMachine.g:302:4: rule__Peripheral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePeripheral"


    // $ANTLR start "entryRuleDistance"
    // InternalMachine.g:311:1: entryRuleDistance : ruleDistance EOF ;
    public final void entryRuleDistance() throws RecognitionException {
        try {
            // InternalMachine.g:312:1: ( ruleDistance EOF )
            // InternalMachine.g:313:1: ruleDistance EOF
            {
             before(grammarAccess.getDistanceRule()); 
            pushFollow(FOLLOW_1);
            ruleDistance();

            state._fsp--;

             after(grammarAccess.getDistanceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleDistance"


    // $ANTLR start "ruleDistance"
    // InternalMachine.g:320:1: ruleDistance : ( ( rule__Distance__Group__0 ) ) ;
    public final void ruleDistance() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:324:2: ( ( ( rule__Distance__Group__0 ) ) )
            // InternalMachine.g:325:2: ( ( rule__Distance__Group__0 ) )
            {
            // InternalMachine.g:325:2: ( ( rule__Distance__Group__0 ) )
            // InternalMachine.g:326:3: ( rule__Distance__Group__0 )
            {
             before(grammarAccess.getDistanceAccess().getGroup()); 
            // InternalMachine.g:327:3: ( rule__Distance__Group__0 )
            // InternalMachine.g:327:4: rule__Distance__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleDistance"


    // $ANTLR start "entryRuleAxisPositionsMapEntry"
    // InternalMachine.g:336:1: entryRuleAxisPositionsMapEntry : ruleAxisPositionsMapEntry EOF ;
    public final void entryRuleAxisPositionsMapEntry() throws RecognitionException {
        try {
            // InternalMachine.g:337:1: ( ruleAxisPositionsMapEntry EOF )
            // InternalMachine.g:338:1: ruleAxisPositionsMapEntry EOF
            {
             before(grammarAccess.getAxisPositionsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            ruleAxisPositionsMapEntry();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxisPositionsMapEntry"


    // $ANTLR start "ruleAxisPositionsMapEntry"
    // InternalMachine.g:345:1: ruleAxisPositionsMapEntry : ( ( rule__AxisPositionsMapEntry__Group__0 ) ) ;
    public final void ruleAxisPositionsMapEntry() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:349:2: ( ( ( rule__AxisPositionsMapEntry__Group__0 ) ) )
            // InternalMachine.g:350:2: ( ( rule__AxisPositionsMapEntry__Group__0 ) )
            {
            // InternalMachine.g:350:2: ( ( rule__AxisPositionsMapEntry__Group__0 ) )
            // InternalMachine.g:351:3: ( rule__AxisPositionsMapEntry__Group__0 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup()); 
            // InternalMachine.g:352:3: ( rule__AxisPositionsMapEntry__Group__0 )
            // InternalMachine.g:352:4: rule__AxisPositionsMapEntry__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxisPositionsMapEntry"


    // $ANTLR start "entryRulePosition"
    // InternalMachine.g:361:1: entryRulePosition : rulePosition EOF ;
    public final void entryRulePosition() throws RecognitionException {
        try {
            // InternalMachine.g:362:1: ( rulePosition EOF )
            // InternalMachine.g:363:1: rulePosition EOF
            {
             before(grammarAccess.getPositionRule()); 
            pushFollow(FOLLOW_1);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getPositionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePosition"


    // $ANTLR start "rulePosition"
    // InternalMachine.g:370:1: rulePosition : ( ( rule__Position__Group__0 ) ) ;
    public final void rulePosition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:374:2: ( ( ( rule__Position__Group__0 ) ) )
            // InternalMachine.g:375:2: ( ( rule__Position__Group__0 ) )
            {
            // InternalMachine.g:375:2: ( ( rule__Position__Group__0 ) )
            // InternalMachine.g:376:3: ( rule__Position__Group__0 )
            {
             before(grammarAccess.getPositionAccess().getGroup()); 
            // InternalMachine.g:377:3: ( rule__Position__Group__0 )
            // InternalMachine.g:377:4: rule__Position__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Position__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPositionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePosition"


    // $ANTLR start "entryRuleSymbolicPosition"
    // InternalMachine.g:386:1: entryRuleSymbolicPosition : ruleSymbolicPosition EOF ;
    public final void entryRuleSymbolicPosition() throws RecognitionException {
        try {
            // InternalMachine.g:387:1: ( ruleSymbolicPosition EOF )
            // InternalMachine.g:388:1: ruleSymbolicPosition EOF
            {
             before(grammarAccess.getSymbolicPositionRule()); 
            pushFollow(FOLLOW_1);
            ruleSymbolicPosition();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSymbolicPosition"


    // $ANTLR start "ruleSymbolicPosition"
    // InternalMachine.g:395:1: ruleSymbolicPosition : ( ( rule__SymbolicPosition__Group__0 ) ) ;
    public final void ruleSymbolicPosition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:399:2: ( ( ( rule__SymbolicPosition__Group__0 ) ) )
            // InternalMachine.g:400:2: ( ( rule__SymbolicPosition__Group__0 ) )
            {
            // InternalMachine.g:400:2: ( ( rule__SymbolicPosition__Group__0 ) )
            // InternalMachine.g:401:3: ( rule__SymbolicPosition__Group__0 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup()); 
            // InternalMachine.g:402:3: ( rule__SymbolicPosition__Group__0 )
            // InternalMachine.g:402:4: rule__SymbolicPosition__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSymbolicPosition"


    // $ANTLR start "entryRuleAxisPositionMapEntry"
    // InternalMachine.g:411:1: entryRuleAxisPositionMapEntry : ruleAxisPositionMapEntry EOF ;
    public final void entryRuleAxisPositionMapEntry() throws RecognitionException {
        try {
            // InternalMachine.g:412:1: ( ruleAxisPositionMapEntry EOF )
            // InternalMachine.g:413:1: ruleAxisPositionMapEntry EOF
            {
             before(grammarAccess.getAxisPositionMapEntryRule()); 
            pushFollow(FOLLOW_1);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getAxisPositionMapEntryRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxisPositionMapEntry"


    // $ANTLR start "ruleAxisPositionMapEntry"
    // InternalMachine.g:420:1: ruleAxisPositionMapEntry : ( ( rule__AxisPositionMapEntry__Group__0 ) ) ;
    public final void ruleAxisPositionMapEntry() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:424:2: ( ( ( rule__AxisPositionMapEntry__Group__0 ) ) )
            // InternalMachine.g:425:2: ( ( rule__AxisPositionMapEntry__Group__0 ) )
            {
            // InternalMachine.g:425:2: ( ( rule__AxisPositionMapEntry__Group__0 ) )
            // InternalMachine.g:426:3: ( rule__AxisPositionMapEntry__Group__0 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getGroup()); 
            // InternalMachine.g:427:3: ( rule__AxisPositionMapEntry__Group__0 )
            // InternalMachine.g:427:4: rule__AxisPositionMapEntry__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxisPositionMapEntry"


    // $ANTLR start "entryRuleProfile"
    // InternalMachine.g:436:1: entryRuleProfile : ruleProfile EOF ;
    public final void entryRuleProfile() throws RecognitionException {
        try {
            // InternalMachine.g:437:1: ( ruleProfile EOF )
            // InternalMachine.g:438:1: ruleProfile EOF
            {
             before(grammarAccess.getProfileRule()); 
            pushFollow(FOLLOW_1);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getProfileRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleProfile"


    // $ANTLR start "ruleProfile"
    // InternalMachine.g:445:1: ruleProfile : ( ( rule__Profile__Group__0 ) ) ;
    public final void ruleProfile() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:449:2: ( ( ( rule__Profile__Group__0 ) ) )
            // InternalMachine.g:450:2: ( ( rule__Profile__Group__0 ) )
            {
            // InternalMachine.g:450:2: ( ( rule__Profile__Group__0 ) )
            // InternalMachine.g:451:3: ( rule__Profile__Group__0 )
            {
             before(grammarAccess.getProfileAccess().getGroup()); 
            // InternalMachine.g:452:3: ( rule__Profile__Group__0 )
            // InternalMachine.g:452:4: rule__Profile__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Profile__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getProfileAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleProfile"


    // $ANTLR start "entryRulePath"
    // InternalMachine.g:461:1: entryRulePath : rulePath EOF ;
    public final void entryRulePath() throws RecognitionException {
        try {
            // InternalMachine.g:462:1: ( rulePath EOF )
            // InternalMachine.g:463:1: rulePath EOF
            {
             before(grammarAccess.getPathRule()); 
            pushFollow(FOLLOW_1);
            rulePath();

            state._fsp--;

             after(grammarAccess.getPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePath"


    // $ANTLR start "rulePath"
    // InternalMachine.g:470:1: rulePath : ( ( rule__Path__Alternatives ) ) ;
    public final void rulePath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:474:2: ( ( ( rule__Path__Alternatives ) ) )
            // InternalMachine.g:475:2: ( ( rule__Path__Alternatives ) )
            {
            // InternalMachine.g:475:2: ( ( rule__Path__Alternatives ) )
            // InternalMachine.g:476:3: ( rule__Path__Alternatives )
            {
             before(grammarAccess.getPathAccess().getAlternatives()); 
            // InternalMachine.g:477:3: ( rule__Path__Alternatives )
            // InternalMachine.g:477:4: rule__Path__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Path__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getPathAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePath"


    // $ANTLR start "entryRuleUnidirectionalPath"
    // InternalMachine.g:486:1: entryRuleUnidirectionalPath : ruleUnidirectionalPath EOF ;
    public final void entryRuleUnidirectionalPath() throws RecognitionException {
        try {
            // InternalMachine.g:487:1: ( ruleUnidirectionalPath EOF )
            // InternalMachine.g:488:1: ruleUnidirectionalPath EOF
            {
             before(grammarAccess.getUnidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            ruleUnidirectionalPath();

            state._fsp--;

             after(grammarAccess.getUnidirectionalPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleUnidirectionalPath"


    // $ANTLR start "ruleUnidirectionalPath"
    // InternalMachine.g:495:1: ruleUnidirectionalPath : ( ( rule__UnidirectionalPath__Group__0 ) ) ;
    public final void ruleUnidirectionalPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:499:2: ( ( ( rule__UnidirectionalPath__Group__0 ) ) )
            // InternalMachine.g:500:2: ( ( rule__UnidirectionalPath__Group__0 ) )
            {
            // InternalMachine.g:500:2: ( ( rule__UnidirectionalPath__Group__0 ) )
            // InternalMachine.g:501:3: ( rule__UnidirectionalPath__Group__0 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup()); 
            // InternalMachine.g:502:3: ( rule__UnidirectionalPath__Group__0 )
            // InternalMachine.g:502:4: rule__UnidirectionalPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleUnidirectionalPath"


    // $ANTLR start "entryRuleBidirectionalPath"
    // InternalMachine.g:511:1: entryRuleBidirectionalPath : ruleBidirectionalPath EOF ;
    public final void entryRuleBidirectionalPath() throws RecognitionException {
        try {
            // InternalMachine.g:512:1: ( ruleBidirectionalPath EOF )
            // InternalMachine.g:513:1: ruleBidirectionalPath EOF
            {
             before(grammarAccess.getBidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            ruleBidirectionalPath();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleBidirectionalPath"


    // $ANTLR start "ruleBidirectionalPath"
    // InternalMachine.g:520:1: ruleBidirectionalPath : ( ( rule__BidirectionalPath__Group__0 ) ) ;
    public final void ruleBidirectionalPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:524:2: ( ( ( rule__BidirectionalPath__Group__0 ) ) )
            // InternalMachine.g:525:2: ( ( rule__BidirectionalPath__Group__0 ) )
            {
            // InternalMachine.g:525:2: ( ( rule__BidirectionalPath__Group__0 ) )
            // InternalMachine.g:526:3: ( rule__BidirectionalPath__Group__0 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup()); 
            // InternalMachine.g:527:3: ( rule__BidirectionalPath__Group__0 )
            // InternalMachine.g:527:4: rule__BidirectionalPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleBidirectionalPath"


    // $ANTLR start "entryRuleFullMeshPath"
    // InternalMachine.g:536:1: entryRuleFullMeshPath : ruleFullMeshPath EOF ;
    public final void entryRuleFullMeshPath() throws RecognitionException {
        try {
            // InternalMachine.g:537:1: ( ruleFullMeshPath EOF )
            // InternalMachine.g:538:1: ruleFullMeshPath EOF
            {
             before(grammarAccess.getFullMeshPathRule()); 
            pushFollow(FOLLOW_1);
            ruleFullMeshPath();

            state._fsp--;

             after(grammarAccess.getFullMeshPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFullMeshPath"


    // $ANTLR start "ruleFullMeshPath"
    // InternalMachine.g:545:1: ruleFullMeshPath : ( ( rule__FullMeshPath__Group__0 ) ) ;
    public final void ruleFullMeshPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:549:2: ( ( ( rule__FullMeshPath__Group__0 ) ) )
            // InternalMachine.g:550:2: ( ( rule__FullMeshPath__Group__0 ) )
            {
            // InternalMachine.g:550:2: ( ( rule__FullMeshPath__Group__0 ) )
            // InternalMachine.g:551:3: ( rule__FullMeshPath__Group__0 )
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup()); 
            // InternalMachine.g:552:3: ( rule__FullMeshPath__Group__0 )
            // InternalMachine.g:552:4: rule__FullMeshPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFullMeshPath"


    // $ANTLR start "entryRulePathTargetReference"
    // InternalMachine.g:561:1: entryRulePathTargetReference : rulePathTargetReference EOF ;
    public final void entryRulePathTargetReference() throws RecognitionException {
        try {
            // InternalMachine.g:562:1: ( rulePathTargetReference EOF )
            // InternalMachine.g:563:1: rulePathTargetReference EOF
            {
             before(grammarAccess.getPathTargetReferenceRule()); 
            pushFollow(FOLLOW_1);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getPathTargetReferenceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePathTargetReference"


    // $ANTLR start "rulePathTargetReference"
    // InternalMachine.g:570:1: rulePathTargetReference : ( ( rule__PathTargetReference__Group__0 ) ) ;
    public final void rulePathTargetReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:574:2: ( ( ( rule__PathTargetReference__Group__0 ) ) )
            // InternalMachine.g:575:2: ( ( rule__PathTargetReference__Group__0 ) )
            {
            // InternalMachine.g:575:2: ( ( rule__PathTargetReference__Group__0 ) )
            // InternalMachine.g:576:3: ( rule__PathTargetReference__Group__0 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup()); 
            // InternalMachine.g:577:3: ( rule__PathTargetReference__Group__0 )
            // InternalMachine.g:577:4: rule__PathTargetReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePathTargetReference"


    // $ANTLR start "entryRuleIID"
    // InternalMachine.g:586:1: entryRuleIID : ruleIID EOF ;
    public final void entryRuleIID() throws RecognitionException {
        try {
            // InternalMachine.g:587:1: ( ruleIID EOF )
            // InternalMachine.g:588:1: ruleIID EOF
            {
             before(grammarAccess.getIIDRule()); 
            pushFollow(FOLLOW_1);
            ruleIID();

            state._fsp--;

             after(grammarAccess.getIIDRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalMachine.g:595:1: ruleIID : ( ( rule__IID__Alternatives ) ) ;
    public final void ruleIID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:599:2: ( ( ( rule__IID__Alternatives ) ) )
            // InternalMachine.g:600:2: ( ( rule__IID__Alternatives ) )
            {
            // InternalMachine.g:600:2: ( ( rule__IID__Alternatives ) )
            // InternalMachine.g:601:3: ( rule__IID__Alternatives )
            {
             before(grammarAccess.getIIDAccess().getAlternatives()); 
            // InternalMachine.g:602:3: ( rule__IID__Alternatives )
            // InternalMachine.g:602:4: rule__IID__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__IID__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getIIDAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleIID"


    // $ANTLR start "ruleResourceType"
    // InternalMachine.g:611:1: ruleResourceType : ( ( rule__ResourceType__Alternatives ) ) ;
    public final void ruleResourceType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:615:1: ( ( ( rule__ResourceType__Alternatives ) ) )
            // InternalMachine.g:616:2: ( ( rule__ResourceType__Alternatives ) )
            {
            // InternalMachine.g:616:2: ( ( rule__ResourceType__Alternatives ) )
            // InternalMachine.g:617:3: ( rule__ResourceType__Alternatives )
            {
             before(grammarAccess.getResourceTypeAccess().getAlternatives()); 
            // InternalMachine.g:618:3: ( rule__ResourceType__Alternatives )
            // InternalMachine.g:618:4: rule__ResourceType__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__ResourceType__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getResourceTypeAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResourceType"


    // $ANTLR start "rule__Machine__Alternatives_4"
    // InternalMachine.g:626:1: rule__Machine__Alternatives_4 : ( ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) ) | ( ( rule__Machine__ResourcesAssignment_4_1 ) ) );
    public final void rule__Machine__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:630:1: ( ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) ) | ( ( rule__Machine__ResourcesAssignment_4_1 ) ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==19) ) {
                alt1=1;
            }
            else if ( ((LA1_0>=11 && LA1_0<=13)) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // InternalMachine.g:631:2: ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) )
                    {
                    // InternalMachine.g:631:2: ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) )
                    // InternalMachine.g:632:3: ( rule__Machine__PeripheralTypesAssignment_4_0 )
                    {
                     before(grammarAccess.getMachineAccess().getPeripheralTypesAssignment_4_0()); 
                    // InternalMachine.g:633:3: ( rule__Machine__PeripheralTypesAssignment_4_0 )
                    // InternalMachine.g:633:4: rule__Machine__PeripheralTypesAssignment_4_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__PeripheralTypesAssignment_4_0();

                    state._fsp--;


                    }

                     after(grammarAccess.getMachineAccess().getPeripheralTypesAssignment_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:637:2: ( ( rule__Machine__ResourcesAssignment_4_1 ) )
                    {
                    // InternalMachine.g:637:2: ( ( rule__Machine__ResourcesAssignment_4_1 ) )
                    // InternalMachine.g:638:3: ( rule__Machine__ResourcesAssignment_4_1 )
                    {
                     before(grammarAccess.getMachineAccess().getResourcesAssignment_4_1()); 
                    // InternalMachine.g:639:3: ( rule__Machine__ResourcesAssignment_4_1 )
                    // InternalMachine.g:639:4: rule__Machine__ResourcesAssignment_4_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__ResourcesAssignment_4_1();

                    state._fsp--;


                    }

                     after(grammarAccess.getMachineAccess().getResourcesAssignment_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Alternatives_4"


    // $ANTLR start "rule__Path__Alternatives"
    // InternalMachine.g:647:1: rule__Path__Alternatives : ( ( ruleUnidirectionalPath ) | ( ruleBidirectionalPath ) | ( ruleFullMeshPath ) );
    public final void rule__Path__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:651:1: ( ( ruleUnidirectionalPath ) | ( ruleBidirectionalPath ) | ( ruleFullMeshPath ) )
            int alt2=3;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==RULE_ID) ) {
                int LA2_1 = input.LA(2);

                if ( (LA2_1==24||LA2_1==41) ) {
                    alt2=2;
                }
                else if ( (LA2_1==37) ) {
                    alt2=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 2, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA2_0==42) ) {
                alt2=3;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // InternalMachine.g:652:2: ( ruleUnidirectionalPath )
                    {
                    // InternalMachine.g:652:2: ( ruleUnidirectionalPath )
                    // InternalMachine.g:653:3: ruleUnidirectionalPath
                    {
                     before(grammarAccess.getPathAccess().getUnidirectionalPathParserRuleCall_0()); 
                    pushFollow(FOLLOW_2);
                    ruleUnidirectionalPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getUnidirectionalPathParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:658:2: ( ruleBidirectionalPath )
                    {
                    // InternalMachine.g:658:2: ( ruleBidirectionalPath )
                    // InternalMachine.g:659:3: ruleBidirectionalPath
                    {
                     before(grammarAccess.getPathAccess().getBidirectionalPathParserRuleCall_1()); 
                    pushFollow(FOLLOW_2);
                    ruleBidirectionalPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getBidirectionalPathParserRuleCall_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMachine.g:664:2: ( ruleFullMeshPath )
                    {
                    // InternalMachine.g:664:2: ( ruleFullMeshPath )
                    // InternalMachine.g:665:3: ruleFullMeshPath
                    {
                     before(grammarAccess.getPathAccess().getFullMeshPathParserRuleCall_2()); 
                    pushFollow(FOLLOW_2);
                    ruleFullMeshPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getFullMeshPathParserRuleCall_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Path__Alternatives"


    // $ANTLR start "rule__UnidirectionalPath__Alternatives_4"
    // InternalMachine.g:674:1: rule__UnidirectionalPath__Alternatives_4 : ( ( ( rule__UnidirectionalPath__Group_4_0__0 ) ) | ( ( rule__UnidirectionalPath__Group_4_1__0 ) ) );
    public final void rule__UnidirectionalPath__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:678:1: ( ( ( rule__UnidirectionalPath__Group_4_0__0 ) ) | ( ( rule__UnidirectionalPath__Group_4_1__0 ) ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==38) ) {
                alt3=1;
            }
            else if ( (LA3_0==39) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // InternalMachine.g:679:2: ( ( rule__UnidirectionalPath__Group_4_0__0 ) )
                    {
                    // InternalMachine.g:679:2: ( ( rule__UnidirectionalPath__Group_4_0__0 ) )
                    // InternalMachine.g:680:3: ( rule__UnidirectionalPath__Group_4_0__0 )
                    {
                     before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0()); 
                    // InternalMachine.g:681:3: ( rule__UnidirectionalPath__Group_4_0__0 )
                    // InternalMachine.g:681:4: rule__UnidirectionalPath__Group_4_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__UnidirectionalPath__Group_4_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:685:2: ( ( rule__UnidirectionalPath__Group_4_1__0 ) )
                    {
                    // InternalMachine.g:685:2: ( ( rule__UnidirectionalPath__Group_4_1__0 ) )
                    // InternalMachine.g:686:3: ( rule__UnidirectionalPath__Group_4_1__0 )
                    {
                     before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_1()); 
                    // InternalMachine.g:687:3: ( rule__UnidirectionalPath__Group_4_1__0 )
                    // InternalMachine.g:687:4: rule__UnidirectionalPath__Group_4_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__UnidirectionalPath__Group_4_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Alternatives_4"


    // $ANTLR start "rule__BidirectionalPath__Alternatives_4"
    // InternalMachine.g:695:1: rule__BidirectionalPath__Alternatives_4 : ( ( ( rule__BidirectionalPath__Group_4_0__0 ) ) | ( ( rule__BidirectionalPath__Group_4_1__0 ) ) );
    public final void rule__BidirectionalPath__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:699:1: ( ( ( rule__BidirectionalPath__Group_4_0__0 ) ) | ( ( rule__BidirectionalPath__Group_4_1__0 ) ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==38) ) {
                alt4=1;
            }
            else if ( (LA4_0==39) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // InternalMachine.g:700:2: ( ( rule__BidirectionalPath__Group_4_0__0 ) )
                    {
                    // InternalMachine.g:700:2: ( ( rule__BidirectionalPath__Group_4_0__0 ) )
                    // InternalMachine.g:701:3: ( rule__BidirectionalPath__Group_4_0__0 )
                    {
                     before(grammarAccess.getBidirectionalPathAccess().getGroup_4_0()); 
                    // InternalMachine.g:702:3: ( rule__BidirectionalPath__Group_4_0__0 )
                    // InternalMachine.g:702:4: rule__BidirectionalPath__Group_4_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__BidirectionalPath__Group_4_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getBidirectionalPathAccess().getGroup_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:706:2: ( ( rule__BidirectionalPath__Group_4_1__0 ) )
                    {
                    // InternalMachine.g:706:2: ( ( rule__BidirectionalPath__Group_4_1__0 ) )
                    // InternalMachine.g:707:3: ( rule__BidirectionalPath__Group_4_1__0 )
                    {
                     before(grammarAccess.getBidirectionalPathAccess().getGroup_4_1()); 
                    // InternalMachine.g:708:3: ( rule__BidirectionalPath__Group_4_1__0 )
                    // InternalMachine.g:708:4: rule__BidirectionalPath__Group_4_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__BidirectionalPath__Group_4_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getBidirectionalPathAccess().getGroup_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Alternatives_4"


    // $ANTLR start "rule__FullMeshPath__Alternatives_3"
    // InternalMachine.g:716:1: rule__FullMeshPath__Alternatives_3 : ( ( ( rule__FullMeshPath__Group_3_0__0 ) ) | ( ( rule__FullMeshPath__Group_3_1__0 ) ) );
    public final void rule__FullMeshPath__Alternatives_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:720:1: ( ( ( rule__FullMeshPath__Group_3_0__0 ) ) | ( ( rule__FullMeshPath__Group_3_1__0 ) ) )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==38) ) {
                alt5=1;
            }
            else if ( (LA5_0==39) ) {
                alt5=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // InternalMachine.g:721:2: ( ( rule__FullMeshPath__Group_3_0__0 ) )
                    {
                    // InternalMachine.g:721:2: ( ( rule__FullMeshPath__Group_3_0__0 ) )
                    // InternalMachine.g:722:3: ( rule__FullMeshPath__Group_3_0__0 )
                    {
                     before(grammarAccess.getFullMeshPathAccess().getGroup_3_0()); 
                    // InternalMachine.g:723:3: ( rule__FullMeshPath__Group_3_0__0 )
                    // InternalMachine.g:723:4: rule__FullMeshPath__Group_3_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__FullMeshPath__Group_3_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getFullMeshPathAccess().getGroup_3_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:727:2: ( ( rule__FullMeshPath__Group_3_1__0 ) )
                    {
                    // InternalMachine.g:727:2: ( ( rule__FullMeshPath__Group_3_1__0 ) )
                    // InternalMachine.g:728:3: ( rule__FullMeshPath__Group_3_1__0 )
                    {
                     before(grammarAccess.getFullMeshPathAccess().getGroup_3_1()); 
                    // InternalMachine.g:729:3: ( rule__FullMeshPath__Group_3_1__0 )
                    // InternalMachine.g:729:4: rule__FullMeshPath__Group_3_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__FullMeshPath__Group_3_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getFullMeshPathAccess().getGroup_3_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Alternatives_3"


    // $ANTLR start "rule__IID__Alternatives"
    // InternalMachine.g:737:1: rule__IID__Alternatives : ( ( RULE_INT ) | ( RULE_ID ) );
    public final void rule__IID__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:741:1: ( ( RULE_INT ) | ( RULE_ID ) )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==RULE_INT) ) {
                alt6=1;
            }
            else if ( (LA6_0==RULE_ID) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // InternalMachine.g:742:2: ( RULE_INT )
                    {
                    // InternalMachine.g:742:2: ( RULE_INT )
                    // InternalMachine.g:743:3: RULE_INT
                    {
                     before(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); 
                    match(input,RULE_INT,FOLLOW_2); 
                     after(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:748:2: ( RULE_ID )
                    {
                    // InternalMachine.g:748:2: ( RULE_ID )
                    // InternalMachine.g:749:3: RULE_ID
                    {
                     before(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); 
                    match(input,RULE_ID,FOLLOW_2); 
                     after(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__IID__Alternatives"


    // $ANTLR start "rule__ResourceType__Alternatives"
    // InternalMachine.g:758:1: rule__ResourceType__Alternatives : ( ( ( 'PassiveResource' ) ) | ( ( 'EventResource' ) ) | ( ( 'Resource' ) ) );
    public final void rule__ResourceType__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:762:1: ( ( ( 'PassiveResource' ) ) | ( ( 'EventResource' ) ) | ( ( 'Resource' ) ) )
            int alt7=3;
            switch ( input.LA(1) ) {
            case 11:
                {
                alt7=1;
                }
                break;
            case 12:
                {
                alt7=2;
                }
                break;
            case 13:
                {
                alt7=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 7, 0, input);

                throw nvae;
            }

            switch (alt7) {
                case 1 :
                    // InternalMachine.g:763:2: ( ( 'PassiveResource' ) )
                    {
                    // InternalMachine.g:763:2: ( ( 'PassiveResource' ) )
                    // InternalMachine.g:764:3: ( 'PassiveResource' )
                    {
                     before(grammarAccess.getResourceTypeAccess().getPASSIVEEnumLiteralDeclaration_0()); 
                    // InternalMachine.g:765:3: ( 'PassiveResource' )
                    // InternalMachine.g:765:4: 'PassiveResource'
                    {
                    match(input,11,FOLLOW_2); 

                    }

                     after(grammarAccess.getResourceTypeAccess().getPASSIVEEnumLiteralDeclaration_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:769:2: ( ( 'EventResource' ) )
                    {
                    // InternalMachine.g:769:2: ( ( 'EventResource' ) )
                    // InternalMachine.g:770:3: ( 'EventResource' )
                    {
                     before(grammarAccess.getResourceTypeAccess().getEVENTEnumLiteralDeclaration_1()); 
                    // InternalMachine.g:771:3: ( 'EventResource' )
                    // InternalMachine.g:771:4: 'EventResource'
                    {
                    match(input,12,FOLLOW_2); 

                    }

                     after(grammarAccess.getResourceTypeAccess().getEVENTEnumLiteralDeclaration_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMachine.g:775:2: ( ( 'Resource' ) )
                    {
                    // InternalMachine.g:775:2: ( ( 'Resource' ) )
                    // InternalMachine.g:776:3: ( 'Resource' )
                    {
                     before(grammarAccess.getResourceTypeAccess().getREGULAREnumLiteralDeclaration_2()); 
                    // InternalMachine.g:777:3: ( 'Resource' )
                    // InternalMachine.g:777:4: 'Resource'
                    {
                    match(input,13,FOLLOW_2); 

                    }

                     after(grammarAccess.getResourceTypeAccess().getREGULAREnumLiteralDeclaration_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceType__Alternatives"


    // $ANTLR start "rule__Machine__Group__0"
    // InternalMachine.g:785:1: rule__Machine__Group__0 : rule__Machine__Group__0__Impl rule__Machine__Group__1 ;
    public final void rule__Machine__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:789:1: ( rule__Machine__Group__0__Impl rule__Machine__Group__1 )
            // InternalMachine.g:790:2: rule__Machine__Group__0__Impl rule__Machine__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__0"


    // $ANTLR start "rule__Machine__Group__0__Impl"
    // InternalMachine.g:797:1: rule__Machine__Group__0__Impl : ( () ) ;
    public final void rule__Machine__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:801:1: ( ( () ) )
            // InternalMachine.g:802:1: ( () )
            {
            // InternalMachine.g:802:1: ( () )
            // InternalMachine.g:803:2: ()
            {
             before(grammarAccess.getMachineAccess().getMachineAction_0()); 
            // InternalMachine.g:804:2: ()
            // InternalMachine.g:804:3: 
            {
            }

             after(grammarAccess.getMachineAccess().getMachineAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__0__Impl"


    // $ANTLR start "rule__Machine__Group__1"
    // InternalMachine.g:812:1: rule__Machine__Group__1 : rule__Machine__Group__1__Impl rule__Machine__Group__2 ;
    public final void rule__Machine__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:816:1: ( rule__Machine__Group__1__Impl rule__Machine__Group__2 )
            // InternalMachine.g:817:2: rule__Machine__Group__1__Impl rule__Machine__Group__2
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__1"


    // $ANTLR start "rule__Machine__Group__1__Impl"
    // InternalMachine.g:824:1: rule__Machine__Group__1__Impl : ( ( rule__Machine__ImportsAssignment_1 )* ) ;
    public final void rule__Machine__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:828:1: ( ( ( rule__Machine__ImportsAssignment_1 )* ) )
            // InternalMachine.g:829:1: ( ( rule__Machine__ImportsAssignment_1 )* )
            {
            // InternalMachine.g:829:1: ( ( rule__Machine__ImportsAssignment_1 )* )
            // InternalMachine.g:830:2: ( rule__Machine__ImportsAssignment_1 )*
            {
             before(grammarAccess.getMachineAccess().getImportsAssignment_1()); 
            // InternalMachine.g:831:2: ( rule__Machine__ImportsAssignment_1 )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==18) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // InternalMachine.g:831:3: rule__Machine__ImportsAssignment_1
            	    {
            	    pushFollow(FOLLOW_4);
            	    rule__Machine__ImportsAssignment_1();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getImportsAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__1__Impl"


    // $ANTLR start "rule__Machine__Group__2"
    // InternalMachine.g:839:1: rule__Machine__Group__2 : rule__Machine__Group__2__Impl rule__Machine__Group__3 ;
    public final void rule__Machine__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:843:1: ( rule__Machine__Group__2__Impl rule__Machine__Group__3 )
            // InternalMachine.g:844:2: rule__Machine__Group__2__Impl rule__Machine__Group__3
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__2"


    // $ANTLR start "rule__Machine__Group__2__Impl"
    // InternalMachine.g:851:1: rule__Machine__Group__2__Impl : ( ( rule__Machine__Group_2__0 )? ) ;
    public final void rule__Machine__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:855:1: ( ( ( rule__Machine__Group_2__0 )? ) )
            // InternalMachine.g:856:1: ( ( rule__Machine__Group_2__0 )? )
            {
            // InternalMachine.g:856:1: ( ( rule__Machine__Group_2__0 )? )
            // InternalMachine.g:857:2: ( rule__Machine__Group_2__0 )?
            {
             before(grammarAccess.getMachineAccess().getGroup_2()); 
            // InternalMachine.g:858:2: ( rule__Machine__Group_2__0 )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==14) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalMachine.g:858:3: rule__Machine__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getMachineAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__2__Impl"


    // $ANTLR start "rule__Machine__Group__3"
    // InternalMachine.g:866:1: rule__Machine__Group__3 : rule__Machine__Group__3__Impl rule__Machine__Group__4 ;
    public final void rule__Machine__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:870:1: ( rule__Machine__Group__3__Impl rule__Machine__Group__4 )
            // InternalMachine.g:871:2: rule__Machine__Group__3__Impl rule__Machine__Group__4
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__3"


    // $ANTLR start "rule__Machine__Group__3__Impl"
    // InternalMachine.g:878:1: rule__Machine__Group__3__Impl : ( ( rule__Machine__Group_3__0 )? ) ;
    public final void rule__Machine__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:882:1: ( ( ( rule__Machine__Group_3__0 )? ) )
            // InternalMachine.g:883:1: ( ( rule__Machine__Group_3__0 )? )
            {
            // InternalMachine.g:883:1: ( ( rule__Machine__Group_3__0 )? )
            // InternalMachine.g:884:2: ( rule__Machine__Group_3__0 )?
            {
             before(grammarAccess.getMachineAccess().getGroup_3()); 
            // InternalMachine.g:885:2: ( rule__Machine__Group_3__0 )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==15) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // InternalMachine.g:885:3: rule__Machine__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getMachineAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__3__Impl"


    // $ANTLR start "rule__Machine__Group__4"
    // InternalMachine.g:893:1: rule__Machine__Group__4 : rule__Machine__Group__4__Impl ;
    public final void rule__Machine__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:897:1: ( rule__Machine__Group__4__Impl )
            // InternalMachine.g:898:2: rule__Machine__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__4"


    // $ANTLR start "rule__Machine__Group__4__Impl"
    // InternalMachine.g:904:1: rule__Machine__Group__4__Impl : ( ( rule__Machine__Alternatives_4 )* ) ;
    public final void rule__Machine__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:908:1: ( ( ( rule__Machine__Alternatives_4 )* ) )
            // InternalMachine.g:909:1: ( ( rule__Machine__Alternatives_4 )* )
            {
            // InternalMachine.g:909:1: ( ( rule__Machine__Alternatives_4 )* )
            // InternalMachine.g:910:2: ( rule__Machine__Alternatives_4 )*
            {
             before(grammarAccess.getMachineAccess().getAlternatives_4()); 
            // InternalMachine.g:911:2: ( rule__Machine__Alternatives_4 )*
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( ((LA11_0>=11 && LA11_0<=13)||LA11_0==19) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // InternalMachine.g:911:3: rule__Machine__Alternatives_4
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__Machine__Alternatives_4();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__4__Impl"


    // $ANTLR start "rule__Machine__Group_2__0"
    // InternalMachine.g:920:1: rule__Machine__Group_2__0 : rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1 ;
    public final void rule__Machine__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:924:1: ( rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1 )
            // InternalMachine.g:925:2: rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Machine__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__0"


    // $ANTLR start "rule__Machine__Group_2__0__Impl"
    // InternalMachine.g:932:1: rule__Machine__Group_2__0__Impl : ( 'Machine' ) ;
    public final void rule__Machine__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:936:1: ( ( 'Machine' ) )
            // InternalMachine.g:937:1: ( 'Machine' )
            {
            // InternalMachine.g:937:1: ( 'Machine' )
            // InternalMachine.g:938:2: 'Machine'
            {
             before(grammarAccess.getMachineAccess().getMachineKeyword_2_0()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getMachineKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__0__Impl"


    // $ANTLR start "rule__Machine__Group_2__1"
    // InternalMachine.g:947:1: rule__Machine__Group_2__1 : rule__Machine__Group_2__1__Impl ;
    public final void rule__Machine__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:951:1: ( rule__Machine__Group_2__1__Impl )
            // InternalMachine.g:952:2: rule__Machine__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__1"


    // $ANTLR start "rule__Machine__Group_2__1__Impl"
    // InternalMachine.g:958:1: rule__Machine__Group_2__1__Impl : ( ( rule__Machine__TypeAssignment_2_1 ) ) ;
    public final void rule__Machine__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:962:1: ( ( ( rule__Machine__TypeAssignment_2_1 ) ) )
            // InternalMachine.g:963:1: ( ( rule__Machine__TypeAssignment_2_1 ) )
            {
            // InternalMachine.g:963:1: ( ( rule__Machine__TypeAssignment_2_1 ) )
            // InternalMachine.g:964:2: ( rule__Machine__TypeAssignment_2_1 )
            {
             before(grammarAccess.getMachineAccess().getTypeAssignment_2_1()); 
            // InternalMachine.g:965:2: ( rule__Machine__TypeAssignment_2_1 )
            // InternalMachine.g:965:3: rule__Machine__TypeAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Machine__TypeAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getMachineAccess().getTypeAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__1__Impl"


    // $ANTLR start "rule__Machine__Group_3__0"
    // InternalMachine.g:974:1: rule__Machine__Group_3__0 : rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1 ;
    public final void rule__Machine__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:978:1: ( rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1 )
            // InternalMachine.g:979:2: rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1
            {
            pushFollow(FOLLOW_7);
            rule__Machine__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__0"


    // $ANTLR start "rule__Machine__Group_3__0__Impl"
    // InternalMachine.g:986:1: rule__Machine__Group_3__0__Impl : ( 'PathAnnotations' ) ;
    public final void rule__Machine__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:990:1: ( ( 'PathAnnotations' ) )
            // InternalMachine.g:991:1: ( 'PathAnnotations' )
            {
            // InternalMachine.g:991:1: ( 'PathAnnotations' )
            // InternalMachine.g:992:2: 'PathAnnotations'
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__0__Impl"


    // $ANTLR start "rule__Machine__Group_3__1"
    // InternalMachine.g:1001:1: rule__Machine__Group_3__1 : rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2 ;
    public final void rule__Machine__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1005:1: ( rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2 )
            // InternalMachine.g:1006:2: rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2
            {
            pushFollow(FOLLOW_8);
            rule__Machine__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__1"


    // $ANTLR start "rule__Machine__Group_3__1__Impl"
    // InternalMachine.g:1013:1: rule__Machine__Group_3__1__Impl : ( '{' ) ;
    public final void rule__Machine__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1017:1: ( ( '{' ) )
            // InternalMachine.g:1018:1: ( '{' )
            {
            // InternalMachine.g:1018:1: ( '{' )
            // InternalMachine.g:1019:2: '{'
            {
             before(grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__1__Impl"


    // $ANTLR start "rule__Machine__Group_3__2"
    // InternalMachine.g:1028:1: rule__Machine__Group_3__2 : rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3 ;
    public final void rule__Machine__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1032:1: ( rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3 )
            // InternalMachine.g:1033:2: rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3
            {
            pushFollow(FOLLOW_8);
            rule__Machine__Group_3__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__2"


    // $ANTLR start "rule__Machine__Group_3__2__Impl"
    // InternalMachine.g:1040:1: rule__Machine__Group_3__2__Impl : ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* ) ;
    public final void rule__Machine__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1044:1: ( ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* ) )
            // InternalMachine.g:1045:1: ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* )
            {
            // InternalMachine.g:1045:1: ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* )
            // InternalMachine.g:1046:2: ( rule__Machine__PathAnnotationsAssignment_3_2 )*
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsAssignment_3_2()); 
            // InternalMachine.g:1047:2: ( rule__Machine__PathAnnotationsAssignment_3_2 )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==RULE_ID) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // InternalMachine.g:1047:3: rule__Machine__PathAnnotationsAssignment_3_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Machine__PathAnnotationsAssignment_3_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getPathAnnotationsAssignment_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__2__Impl"


    // $ANTLR start "rule__Machine__Group_3__3"
    // InternalMachine.g:1055:1: rule__Machine__Group_3__3 : rule__Machine__Group_3__3__Impl ;
    public final void rule__Machine__Group_3__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1059:1: ( rule__Machine__Group_3__3__Impl )
            // InternalMachine.g:1060:2: rule__Machine__Group_3__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__3"


    // $ANTLR start "rule__Machine__Group_3__3__Impl"
    // InternalMachine.g:1066:1: rule__Machine__Group_3__3__Impl : ( '}' ) ;
    public final void rule__Machine__Group_3__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1070:1: ( ( '}' ) )
            // InternalMachine.g:1071:1: ( '}' )
            {
            // InternalMachine.g:1071:1: ( '}' )
            // InternalMachine.g:1072:2: '}'
            {
             before(grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__3__Impl"


    // $ANTLR start "rule__Import__Group__0"
    // InternalMachine.g:1082:1: rule__Import__Group__0 : rule__Import__Group__0__Impl rule__Import__Group__1 ;
    public final void rule__Import__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1086:1: ( rule__Import__Group__0__Impl rule__Import__Group__1 )
            // InternalMachine.g:1087:2: rule__Import__Group__0__Impl rule__Import__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__Import__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Import__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0"


    // $ANTLR start "rule__Import__Group__0__Impl"
    // InternalMachine.g:1094:1: rule__Import__Group__0__Impl : ( 'import' ) ;
    public final void rule__Import__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1098:1: ( ( 'import' ) )
            // InternalMachine.g:1099:1: ( 'import' )
            {
            // InternalMachine.g:1099:1: ( 'import' )
            // InternalMachine.g:1100:2: 'import'
            {
             before(grammarAccess.getImportAccess().getImportKeyword_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0__Impl"


    // $ANTLR start "rule__Import__Group__1"
    // InternalMachine.g:1109:1: rule__Import__Group__1 : rule__Import__Group__1__Impl ;
    public final void rule__Import__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1113:1: ( rule__Import__Group__1__Impl )
            // InternalMachine.g:1114:2: rule__Import__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1"


    // $ANTLR start "rule__Import__Group__1__Impl"
    // InternalMachine.g:1120:1: rule__Import__Group__1__Impl : ( ( rule__Import__ImportURIAssignment_1 ) ) ;
    public final void rule__Import__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1124:1: ( ( ( rule__Import__ImportURIAssignment_1 ) ) )
            // InternalMachine.g:1125:1: ( ( rule__Import__ImportURIAssignment_1 ) )
            {
            // InternalMachine.g:1125:1: ( ( rule__Import__ImportURIAssignment_1 ) )
            // InternalMachine.g:1126:2: ( rule__Import__ImportURIAssignment_1 )
            {
             before(grammarAccess.getImportAccess().getImportURIAssignment_1()); 
            // InternalMachine.g:1127:2: ( rule__Import__ImportURIAssignment_1 )
            // InternalMachine.g:1127:3: rule__Import__ImportURIAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Import__ImportURIAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getImportURIAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1__Impl"


    // $ANTLR start "rule__PathAnnotation__Group__0"
    // InternalMachine.g:1136:1: rule__PathAnnotation__Group__0 : rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1 ;
    public final void rule__PathAnnotation__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1140:1: ( rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1 )
            // InternalMachine.g:1141:2: rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PathAnnotation__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__0"


    // $ANTLR start "rule__PathAnnotation__Group__0__Impl"
    // InternalMachine.g:1148:1: rule__PathAnnotation__Group__0__Impl : ( () ) ;
    public final void rule__PathAnnotation__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1152:1: ( ( () ) )
            // InternalMachine.g:1153:1: ( () )
            {
            // InternalMachine.g:1153:1: ( () )
            // InternalMachine.g:1154:2: ()
            {
             before(grammarAccess.getPathAnnotationAccess().getPathAnnotationAction_0()); 
            // InternalMachine.g:1155:2: ()
            // InternalMachine.g:1155:3: 
            {
            }

             after(grammarAccess.getPathAnnotationAccess().getPathAnnotationAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__0__Impl"


    // $ANTLR start "rule__PathAnnotation__Group__1"
    // InternalMachine.g:1163:1: rule__PathAnnotation__Group__1 : rule__PathAnnotation__Group__1__Impl ;
    public final void rule__PathAnnotation__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1167:1: ( rule__PathAnnotation__Group__1__Impl )
            // InternalMachine.g:1168:2: rule__PathAnnotation__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__1"


    // $ANTLR start "rule__PathAnnotation__Group__1__Impl"
    // InternalMachine.g:1174:1: rule__PathAnnotation__Group__1__Impl : ( ( rule__PathAnnotation__NameAssignment_1 ) ) ;
    public final void rule__PathAnnotation__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1178:1: ( ( ( rule__PathAnnotation__NameAssignment_1 ) ) )
            // InternalMachine.g:1179:1: ( ( rule__PathAnnotation__NameAssignment_1 ) )
            {
            // InternalMachine.g:1179:1: ( ( rule__PathAnnotation__NameAssignment_1 ) )
            // InternalMachine.g:1180:2: ( rule__PathAnnotation__NameAssignment_1 )
            {
             before(grammarAccess.getPathAnnotationAccess().getNameAssignment_1()); 
            // InternalMachine.g:1181:2: ( rule__PathAnnotation__NameAssignment_1 )
            // InternalMachine.g:1181:3: rule__PathAnnotation__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPathAnnotationAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group__0"
    // InternalMachine.g:1190:1: rule__PeripheralType__Group__0 : rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1 ;
    public final void rule__PeripheralType__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1194:1: ( rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1 )
            // InternalMachine.g:1195:2: rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1
            {
            pushFollow(FOLLOW_11);
            rule__PeripheralType__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__0"


    // $ANTLR start "rule__PeripheralType__Group__0__Impl"
    // InternalMachine.g:1202:1: rule__PeripheralType__Group__0__Impl : ( () ) ;
    public final void rule__PeripheralType__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1206:1: ( ( () ) )
            // InternalMachine.g:1207:1: ( () )
            {
            // InternalMachine.g:1207:1: ( () )
            // InternalMachine.g:1208:2: ()
            {
             before(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeAction_0()); 
            // InternalMachine.g:1209:2: ()
            // InternalMachine.g:1209:3: 
            {
            }

             after(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group__1"
    // InternalMachine.g:1217:1: rule__PeripheralType__Group__1 : rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2 ;
    public final void rule__PeripheralType__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1221:1: ( rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2 )
            // InternalMachine.g:1222:2: rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__PeripheralType__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__1"


    // $ANTLR start "rule__PeripheralType__Group__1__Impl"
    // InternalMachine.g:1229:1: rule__PeripheralType__Group__1__Impl : ( 'PeripheralType' ) ;
    public final void rule__PeripheralType__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1233:1: ( ( 'PeripheralType' ) )
            // InternalMachine.g:1234:1: ( 'PeripheralType' )
            {
            // InternalMachine.g:1234:1: ( 'PeripheralType' )
            // InternalMachine.g:1235:2: 'PeripheralType'
            {
             before(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeKeyword_1()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group__2"
    // InternalMachine.g:1244:1: rule__PeripheralType__Group__2 : rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3 ;
    public final void rule__PeripheralType__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1248:1: ( rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3 )
            // InternalMachine.g:1249:2: rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__2"


    // $ANTLR start "rule__PeripheralType__Group__2__Impl"
    // InternalMachine.g:1256:1: rule__PeripheralType__Group__2__Impl : ( ( rule__PeripheralType__NameAssignment_2 ) ) ;
    public final void rule__PeripheralType__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1260:1: ( ( ( rule__PeripheralType__NameAssignment_2 ) ) )
            // InternalMachine.g:1261:1: ( ( rule__PeripheralType__NameAssignment_2 ) )
            {
            // InternalMachine.g:1261:1: ( ( rule__PeripheralType__NameAssignment_2 ) )
            // InternalMachine.g:1262:2: ( rule__PeripheralType__NameAssignment_2 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getNameAssignment_2()); 
            // InternalMachine.g:1263:2: ( rule__PeripheralType__NameAssignment_2 )
            // InternalMachine.g:1263:3: rule__PeripheralType__NameAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__NameAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getNameAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group__3"
    // InternalMachine.g:1271:1: rule__PeripheralType__Group__3 : rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4 ;
    public final void rule__PeripheralType__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1275:1: ( rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4 )
            // InternalMachine.g:1276:2: rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__3"


    // $ANTLR start "rule__PeripheralType__Group__3__Impl"
    // InternalMachine.g:1283:1: rule__PeripheralType__Group__3__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1287:1: ( ( '{' ) )
            // InternalMachine.g:1288:1: ( '{' )
            {
            // InternalMachine.g:1288:1: ( '{' )
            // InternalMachine.g:1289:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group__4"
    // InternalMachine.g:1298:1: rule__PeripheralType__Group__4 : rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5 ;
    public final void rule__PeripheralType__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1302:1: ( rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5 )
            // InternalMachine.g:1303:2: rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__4"


    // $ANTLR start "rule__PeripheralType__Group__4__Impl"
    // InternalMachine.g:1310:1: rule__PeripheralType__Group__4__Impl : ( ( rule__PeripheralType__Group_4__0 )? ) ;
    public final void rule__PeripheralType__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1314:1: ( ( ( rule__PeripheralType__Group_4__0 )? ) )
            // InternalMachine.g:1315:1: ( ( rule__PeripheralType__Group_4__0 )? )
            {
            // InternalMachine.g:1315:1: ( ( rule__PeripheralType__Group_4__0 )? )
            // InternalMachine.g:1316:2: ( rule__PeripheralType__Group_4__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_4()); 
            // InternalMachine.g:1317:2: ( rule__PeripheralType__Group_4__0 )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==20) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // InternalMachine.g:1317:3: rule__PeripheralType__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_4__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__4__Impl"


    // $ANTLR start "rule__PeripheralType__Group__5"
    // InternalMachine.g:1325:1: rule__PeripheralType__Group__5 : rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6 ;
    public final void rule__PeripheralType__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1329:1: ( rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6 )
            // InternalMachine.g:1330:2: rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__5"


    // $ANTLR start "rule__PeripheralType__Group__5__Impl"
    // InternalMachine.g:1337:1: rule__PeripheralType__Group__5__Impl : ( ( rule__PeripheralType__Group_5__0 )? ) ;
    public final void rule__PeripheralType__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1341:1: ( ( ( rule__PeripheralType__Group_5__0 )? ) )
            // InternalMachine.g:1342:1: ( ( rule__PeripheralType__Group_5__0 )? )
            {
            // InternalMachine.g:1342:1: ( ( rule__PeripheralType__Group_5__0 )? )
            // InternalMachine.g:1343:2: ( rule__PeripheralType__Group_5__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_5()); 
            // InternalMachine.g:1344:2: ( rule__PeripheralType__Group_5__0 )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==21) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // InternalMachine.g:1344:3: rule__PeripheralType__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_5__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__5__Impl"


    // $ANTLR start "rule__PeripheralType__Group__6"
    // InternalMachine.g:1352:1: rule__PeripheralType__Group__6 : rule__PeripheralType__Group__6__Impl ;
    public final void rule__PeripheralType__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1356:1: ( rule__PeripheralType__Group__6__Impl )
            // InternalMachine.g:1357:2: rule__PeripheralType__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__6"


    // $ANTLR start "rule__PeripheralType__Group__6__Impl"
    // InternalMachine.g:1363:1: rule__PeripheralType__Group__6__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1367:1: ( ( '}' ) )
            // InternalMachine.g:1368:1: ( '}' )
            {
            // InternalMachine.g:1368:1: ( '}' )
            // InternalMachine.g:1369:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_6()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__6__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__0"
    // InternalMachine.g:1379:1: rule__PeripheralType__Group_4__0 : rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1 ;
    public final void rule__PeripheralType__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1383:1: ( rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1 )
            // InternalMachine.g:1384:2: rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__0"


    // $ANTLR start "rule__PeripheralType__Group_4__0__Impl"
    // InternalMachine.g:1391:1: rule__PeripheralType__Group_4__0__Impl : ( 'Actions' ) ;
    public final void rule__PeripheralType__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1395:1: ( ( 'Actions' ) )
            // InternalMachine.g:1396:1: ( 'Actions' )
            {
            // InternalMachine.g:1396:1: ( 'Actions' )
            // InternalMachine.g:1397:2: 'Actions'
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0()); 
            match(input,20,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__1"
    // InternalMachine.g:1406:1: rule__PeripheralType__Group_4__1 : rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2 ;
    public final void rule__PeripheralType__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1410:1: ( rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2 )
            // InternalMachine.g:1411:2: rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_4__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__1"


    // $ANTLR start "rule__PeripheralType__Group_4__1__Impl"
    // InternalMachine.g:1418:1: rule__PeripheralType__Group_4__1__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1422:1: ( ( '{' ) )
            // InternalMachine.g:1423:1: ( '{' )
            {
            // InternalMachine.g:1423:1: ( '{' )
            // InternalMachine.g:1424:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__2"
    // InternalMachine.g:1433:1: rule__PeripheralType__Group_4__2 : rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3 ;
    public final void rule__PeripheralType__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1437:1: ( rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3 )
            // InternalMachine.g:1438:2: rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_4__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__2"


    // $ANTLR start "rule__PeripheralType__Group_4__2__Impl"
    // InternalMachine.g:1445:1: rule__PeripheralType__Group_4__2__Impl : ( ( rule__PeripheralType__ActionsAssignment_4_2 )* ) ;
    public final void rule__PeripheralType__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1449:1: ( ( ( rule__PeripheralType__ActionsAssignment_4_2 )* ) )
            // InternalMachine.g:1450:1: ( ( rule__PeripheralType__ActionsAssignment_4_2 )* )
            {
            // InternalMachine.g:1450:1: ( ( rule__PeripheralType__ActionsAssignment_4_2 )* )
            // InternalMachine.g:1451:2: ( rule__PeripheralType__ActionsAssignment_4_2 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsAssignment_4_2()); 
            // InternalMachine.g:1452:2: ( rule__PeripheralType__ActionsAssignment_4_2 )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==RULE_ID) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // InternalMachine.g:1452:3: rule__PeripheralType__ActionsAssignment_4_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__ActionsAssignment_4_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getActionsAssignment_4_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__3"
    // InternalMachine.g:1460:1: rule__PeripheralType__Group_4__3 : rule__PeripheralType__Group_4__3__Impl ;
    public final void rule__PeripheralType__Group_4__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1464:1: ( rule__PeripheralType__Group_4__3__Impl )
            // InternalMachine.g:1465:2: rule__PeripheralType__Group_4__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__3"


    // $ANTLR start "rule__PeripheralType__Group_4__3__Impl"
    // InternalMachine.g:1471:1: rule__PeripheralType__Group_4__3__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_4__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1475:1: ( ( '}' ) )
            // InternalMachine.g:1476:1: ( '}' )
            {
            // InternalMachine.g:1476:1: ( '}' )
            // InternalMachine.g:1477:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__0"
    // InternalMachine.g:1487:1: rule__PeripheralType__Group_5__0 : rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1 ;
    public final void rule__PeripheralType__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1491:1: ( rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1 )
            // InternalMachine.g:1492:2: rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__0"


    // $ANTLR start "rule__PeripheralType__Group_5__0__Impl"
    // InternalMachine.g:1499:1: rule__PeripheralType__Group_5__0__Impl : ( 'SetPoints' ) ;
    public final void rule__PeripheralType__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1503:1: ( ( 'SetPoints' ) )
            // InternalMachine.g:1504:1: ( 'SetPoints' )
            {
            // InternalMachine.g:1504:1: ( 'SetPoints' )
            // InternalMachine.g:1505:2: 'SetPoints'
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__1"
    // InternalMachine.g:1514:1: rule__PeripheralType__Group_5__1 : rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2 ;
    public final void rule__PeripheralType__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1518:1: ( rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2 )
            // InternalMachine.g:1519:2: rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__1"


    // $ANTLR start "rule__PeripheralType__Group_5__1__Impl"
    // InternalMachine.g:1526:1: rule__PeripheralType__Group_5__1__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1530:1: ( ( '{' ) )
            // InternalMachine.g:1531:1: ( '{' )
            {
            // InternalMachine.g:1531:1: ( '{' )
            // InternalMachine.g:1532:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__2"
    // InternalMachine.g:1541:1: rule__PeripheralType__Group_5__2 : rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3 ;
    public final void rule__PeripheralType__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1545:1: ( rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3 )
            // InternalMachine.g:1546:2: rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__2"


    // $ANTLR start "rule__PeripheralType__Group_5__2__Impl"
    // InternalMachine.g:1553:1: rule__PeripheralType__Group_5__2__Impl : ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* ) ;
    public final void rule__PeripheralType__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1557:1: ( ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* ) )
            // InternalMachine.g:1558:1: ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* )
            {
            // InternalMachine.g:1558:1: ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* )
            // InternalMachine.g:1559:2: ( rule__PeripheralType__SetPointsAssignment_5_2 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsAssignment_5_2()); 
            // InternalMachine.g:1560:2: ( rule__PeripheralType__SetPointsAssignment_5_2 )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==RULE_ID) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // InternalMachine.g:1560:3: rule__PeripheralType__SetPointsAssignment_5_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__SetPointsAssignment_5_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getSetPointsAssignment_5_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__3"
    // InternalMachine.g:1568:1: rule__PeripheralType__Group_5__3 : rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4 ;
    public final void rule__PeripheralType__Group_5__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1572:1: ( rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4 )
            // InternalMachine.g:1573:2: rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4
            {
            pushFollow(FOLLOW_13);
            rule__PeripheralType__Group_5__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__3"


    // $ANTLR start "rule__PeripheralType__Group_5__3__Impl"
    // InternalMachine.g:1580:1: rule__PeripheralType__Group_5__3__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_5__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1584:1: ( ( '}' ) )
            // InternalMachine.g:1585:1: ( '}' )
            {
            // InternalMachine.g:1585:1: ( '}' )
            // InternalMachine.g:1586:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__4"
    // InternalMachine.g:1595:1: rule__PeripheralType__Group_5__4 : rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5 ;
    public final void rule__PeripheralType__Group_5__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1599:1: ( rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5 )
            // InternalMachine.g:1600:2: rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_5__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__4"


    // $ANTLR start "rule__PeripheralType__Group_5__4__Impl"
    // InternalMachine.g:1607:1: rule__PeripheralType__Group_5__4__Impl : ( 'Axes' ) ;
    public final void rule__PeripheralType__Group_5__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1611:1: ( ( 'Axes' ) )
            // InternalMachine.g:1612:1: ( 'Axes' )
            {
            // InternalMachine.g:1612:1: ( 'Axes' )
            // InternalMachine.g:1613:2: 'Axes'
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__4__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__5"
    // InternalMachine.g:1622:1: rule__PeripheralType__Group_5__5 : rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6 ;
    public final void rule__PeripheralType__Group_5__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1626:1: ( rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6 )
            // InternalMachine.g:1627:2: rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__5"


    // $ANTLR start "rule__PeripheralType__Group_5__5__Impl"
    // InternalMachine.g:1634:1: rule__PeripheralType__Group_5__5__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_5__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1638:1: ( ( '{' ) )
            // InternalMachine.g:1639:1: ( '{' )
            {
            // InternalMachine.g:1639:1: ( '{' )
            // InternalMachine.g:1640:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__5__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__6"
    // InternalMachine.g:1649:1: rule__PeripheralType__Group_5__6 : rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7 ;
    public final void rule__PeripheralType__Group_5__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1653:1: ( rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7 )
            // InternalMachine.g:1654:2: rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__6"


    // $ANTLR start "rule__PeripheralType__Group_5__6__Impl"
    // InternalMachine.g:1661:1: rule__PeripheralType__Group_5__6__Impl : ( ( rule__PeripheralType__AxesAssignment_5_6 )* ) ;
    public final void rule__PeripheralType__Group_5__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1665:1: ( ( ( rule__PeripheralType__AxesAssignment_5_6 )* ) )
            // InternalMachine.g:1666:1: ( ( rule__PeripheralType__AxesAssignment_5_6 )* )
            {
            // InternalMachine.g:1666:1: ( ( rule__PeripheralType__AxesAssignment_5_6 )* )
            // InternalMachine.g:1667:2: ( rule__PeripheralType__AxesAssignment_5_6 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesAssignment_5_6()); 
            // InternalMachine.g:1668:2: ( rule__PeripheralType__AxesAssignment_5_6 )*
            loop17:
            do {
                int alt17=2;
                int LA17_0 = input.LA(1);

                if ( (LA17_0==RULE_ID) ) {
                    alt17=1;
                }


                switch (alt17) {
            	case 1 :
            	    // InternalMachine.g:1668:3: rule__PeripheralType__AxesAssignment_5_6
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__AxesAssignment_5_6();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop17;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getAxesAssignment_5_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__6__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__7"
    // InternalMachine.g:1676:1: rule__PeripheralType__Group_5__7 : rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8 ;
    public final void rule__PeripheralType__Group_5__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1680:1: ( rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8 )
            // InternalMachine.g:1681:2: rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8
            {
            pushFollow(FOLLOW_14);
            rule__PeripheralType__Group_5__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__7"


    // $ANTLR start "rule__PeripheralType__Group_5__7__Impl"
    // InternalMachine.g:1688:1: rule__PeripheralType__Group_5__7__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_5__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1692:1: ( ( '}' ) )
            // InternalMachine.g:1693:1: ( '}' )
            {
            // InternalMachine.g:1693:1: ( '}' )
            // InternalMachine.g:1694:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__7__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__8"
    // InternalMachine.g:1703:1: rule__PeripheralType__Group_5__8 : rule__PeripheralType__Group_5__8__Impl ;
    public final void rule__PeripheralType__Group_5__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1707:1: ( rule__PeripheralType__Group_5__8__Impl )
            // InternalMachine.g:1708:2: rule__PeripheralType__Group_5__8__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__8__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__8"


    // $ANTLR start "rule__PeripheralType__Group_5__8__Impl"
    // InternalMachine.g:1714:1: rule__PeripheralType__Group_5__8__Impl : ( ( rule__PeripheralType__Group_5_8__0 )? ) ;
    public final void rule__PeripheralType__Group_5__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1718:1: ( ( ( rule__PeripheralType__Group_5_8__0 )? ) )
            // InternalMachine.g:1719:1: ( ( rule__PeripheralType__Group_5_8__0 )? )
            {
            // InternalMachine.g:1719:1: ( ( rule__PeripheralType__Group_5_8__0 )? )
            // InternalMachine.g:1720:2: ( rule__PeripheralType__Group_5_8__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_5_8()); 
            // InternalMachine.g:1721:2: ( rule__PeripheralType__Group_5_8__0 )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==23) ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // InternalMachine.g:1721:3: rule__PeripheralType__Group_5_8__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_5_8__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_5_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__8__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5_8__0"
    // InternalMachine.g:1730:1: rule__PeripheralType__Group_5_8__0 : rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1 ;
    public final void rule__PeripheralType__Group_5_8__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1734:1: ( rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1 )
            // InternalMachine.g:1735:2: rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1
            {
            pushFollow(FOLLOW_10);
            rule__PeripheralType__Group_5_8__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5_8__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__0"


    // $ANTLR start "rule__PeripheralType__Group_5_8__0__Impl"
    // InternalMachine.g:1742:1: rule__PeripheralType__Group_5_8__0__Impl : ( 'Conversion' ) ;
    public final void rule__PeripheralType__Group_5_8__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1746:1: ( ( 'Conversion' ) )
            // InternalMachine.g:1747:1: ( 'Conversion' )
            {
            // InternalMachine.g:1747:1: ( 'Conversion' )
            // InternalMachine.g:1748:2: 'Conversion'
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionKeyword_5_8_0()); 
            match(input,23,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getConversionKeyword_5_8_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5_8__1"
    // InternalMachine.g:1757:1: rule__PeripheralType__Group_5_8__1 : rule__PeripheralType__Group_5_8__1__Impl ;
    public final void rule__PeripheralType__Group_5_8__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1761:1: ( rule__PeripheralType__Group_5_8__1__Impl )
            // InternalMachine.g:1762:2: rule__PeripheralType__Group_5_8__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5_8__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__1"


    // $ANTLR start "rule__PeripheralType__Group_5_8__1__Impl"
    // InternalMachine.g:1768:1: rule__PeripheralType__Group_5_8__1__Impl : ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) ) ;
    public final void rule__PeripheralType__Group_5_8__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1772:1: ( ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) ) )
            // InternalMachine.g:1773:1: ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) )
            {
            // InternalMachine.g:1773:1: ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) )
            // InternalMachine.g:1774:2: ( rule__PeripheralType__ConversionAssignment_5_8_1 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionAssignment_5_8_1()); 
            // InternalMachine.g:1775:2: ( rule__PeripheralType__ConversionAssignment_5_8_1 )
            // InternalMachine.g:1775:3: rule__PeripheralType__ConversionAssignment_5_8_1
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__ConversionAssignment_5_8_1();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getConversionAssignment_5_8_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__1__Impl"


    // $ANTLR start "rule__ActionType__Group__0"
    // InternalMachine.g:1784:1: rule__ActionType__Group__0 : rule__ActionType__Group__0__Impl rule__ActionType__Group__1 ;
    public final void rule__ActionType__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1788:1: ( rule__ActionType__Group__0__Impl rule__ActionType__Group__1 )
            // InternalMachine.g:1789:2: rule__ActionType__Group__0__Impl rule__ActionType__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__ActionType__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ActionType__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__0"


    // $ANTLR start "rule__ActionType__Group__0__Impl"
    // InternalMachine.g:1796:1: rule__ActionType__Group__0__Impl : ( () ) ;
    public final void rule__ActionType__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1800:1: ( ( () ) )
            // InternalMachine.g:1801:1: ( () )
            {
            // InternalMachine.g:1801:1: ( () )
            // InternalMachine.g:1802:2: ()
            {
             before(grammarAccess.getActionTypeAccess().getActionTypeAction_0()); 
            // InternalMachine.g:1803:2: ()
            // InternalMachine.g:1803:3: 
            {
            }

             after(grammarAccess.getActionTypeAccess().getActionTypeAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__0__Impl"


    // $ANTLR start "rule__ActionType__Group__1"
    // InternalMachine.g:1811:1: rule__ActionType__Group__1 : rule__ActionType__Group__1__Impl ;
    public final void rule__ActionType__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1815:1: ( rule__ActionType__Group__1__Impl )
            // InternalMachine.g:1816:2: rule__ActionType__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__1"


    // $ANTLR start "rule__ActionType__Group__1__Impl"
    // InternalMachine.g:1822:1: rule__ActionType__Group__1__Impl : ( ( rule__ActionType__NameAssignment_1 ) ) ;
    public final void rule__ActionType__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1826:1: ( ( ( rule__ActionType__NameAssignment_1 ) ) )
            // InternalMachine.g:1827:1: ( ( rule__ActionType__NameAssignment_1 ) )
            {
            // InternalMachine.g:1827:1: ( ( rule__ActionType__NameAssignment_1 ) )
            // InternalMachine.g:1828:2: ( rule__ActionType__NameAssignment_1 )
            {
             before(grammarAccess.getActionTypeAccess().getNameAssignment_1()); 
            // InternalMachine.g:1829:2: ( rule__ActionType__NameAssignment_1 )
            // InternalMachine.g:1829:3: rule__ActionType__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getActionTypeAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__1__Impl"


    // $ANTLR start "rule__SetPoint__Group__0"
    // InternalMachine.g:1838:1: rule__SetPoint__Group__0 : rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1 ;
    public final void rule__SetPoint__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1842:1: ( rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1 )
            // InternalMachine.g:1843:2: rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__SetPoint__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__0"


    // $ANTLR start "rule__SetPoint__Group__0__Impl"
    // InternalMachine.g:1850:1: rule__SetPoint__Group__0__Impl : ( () ) ;
    public final void rule__SetPoint__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1854:1: ( ( () ) )
            // InternalMachine.g:1855:1: ( () )
            {
            // InternalMachine.g:1855:1: ( () )
            // InternalMachine.g:1856:2: ()
            {
             before(grammarAccess.getSetPointAccess().getSetPointAction_0()); 
            // InternalMachine.g:1857:2: ()
            // InternalMachine.g:1857:3: 
            {
            }

             after(grammarAccess.getSetPointAccess().getSetPointAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__0__Impl"


    // $ANTLR start "rule__SetPoint__Group__1"
    // InternalMachine.g:1865:1: rule__SetPoint__Group__1 : rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2 ;
    public final void rule__SetPoint__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1869:1: ( rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2 )
            // InternalMachine.g:1870:2: rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__SetPoint__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__1"


    // $ANTLR start "rule__SetPoint__Group__1__Impl"
    // InternalMachine.g:1877:1: rule__SetPoint__Group__1__Impl : ( ( rule__SetPoint__NameAssignment_1 ) ) ;
    public final void rule__SetPoint__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1881:1: ( ( ( rule__SetPoint__NameAssignment_1 ) ) )
            // InternalMachine.g:1882:1: ( ( rule__SetPoint__NameAssignment_1 ) )
            {
            // InternalMachine.g:1882:1: ( ( rule__SetPoint__NameAssignment_1 ) )
            // InternalMachine.g:1883:2: ( rule__SetPoint__NameAssignment_1 )
            {
             before(grammarAccess.getSetPointAccess().getNameAssignment_1()); 
            // InternalMachine.g:1884:2: ( rule__SetPoint__NameAssignment_1 )
            // InternalMachine.g:1884:3: rule__SetPoint__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__1__Impl"


    // $ANTLR start "rule__SetPoint__Group__2"
    // InternalMachine.g:1892:1: rule__SetPoint__Group__2 : rule__SetPoint__Group__2__Impl ;
    public final void rule__SetPoint__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1896:1: ( rule__SetPoint__Group__2__Impl )
            // InternalMachine.g:1897:2: rule__SetPoint__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__2"


    // $ANTLR start "rule__SetPoint__Group__2__Impl"
    // InternalMachine.g:1903:1: rule__SetPoint__Group__2__Impl : ( ( rule__SetPoint__Group_2__0 )? ) ;
    public final void rule__SetPoint__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1907:1: ( ( ( rule__SetPoint__Group_2__0 )? ) )
            // InternalMachine.g:1908:1: ( ( rule__SetPoint__Group_2__0 )? )
            {
            // InternalMachine.g:1908:1: ( ( rule__SetPoint__Group_2__0 )? )
            // InternalMachine.g:1909:2: ( rule__SetPoint__Group_2__0 )?
            {
             before(grammarAccess.getSetPointAccess().getGroup_2()); 
            // InternalMachine.g:1910:2: ( rule__SetPoint__Group_2__0 )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==24) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // InternalMachine.g:1910:3: rule__SetPoint__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__SetPoint__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getSetPointAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__2__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__0"
    // InternalMachine.g:1919:1: rule__SetPoint__Group_2__0 : rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1 ;
    public final void rule__SetPoint__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1923:1: ( rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1 )
            // InternalMachine.g:1924:2: rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SetPoint__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__0"


    // $ANTLR start "rule__SetPoint__Group_2__0__Impl"
    // InternalMachine.g:1931:1: rule__SetPoint__Group_2__0__Impl : ( '[' ) ;
    public final void rule__SetPoint__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1935:1: ( ( '[' ) )
            // InternalMachine.g:1936:1: ( '[' )
            {
            // InternalMachine.g:1936:1: ( '[' )
            // InternalMachine.g:1937:2: '['
            {
             before(grammarAccess.getSetPointAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__0__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__1"
    // InternalMachine.g:1946:1: rule__SetPoint__Group_2__1 : rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2 ;
    public final void rule__SetPoint__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1950:1: ( rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2 )
            // InternalMachine.g:1951:2: rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2
            {
            pushFollow(FOLLOW_16);
            rule__SetPoint__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__1"


    // $ANTLR start "rule__SetPoint__Group_2__1__Impl"
    // InternalMachine.g:1958:1: rule__SetPoint__Group_2__1__Impl : ( ( rule__SetPoint__UnitAssignment_2_1 ) ) ;
    public final void rule__SetPoint__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1962:1: ( ( ( rule__SetPoint__UnitAssignment_2_1 ) ) )
            // InternalMachine.g:1963:1: ( ( rule__SetPoint__UnitAssignment_2_1 ) )
            {
            // InternalMachine.g:1963:1: ( ( rule__SetPoint__UnitAssignment_2_1 ) )
            // InternalMachine.g:1964:2: ( rule__SetPoint__UnitAssignment_2_1 )
            {
             before(grammarAccess.getSetPointAccess().getUnitAssignment_2_1()); 
            // InternalMachine.g:1965:2: ( rule__SetPoint__UnitAssignment_2_1 )
            // InternalMachine.g:1965:3: rule__SetPoint__UnitAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__UnitAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getUnitAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__1__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__2"
    // InternalMachine.g:1973:1: rule__SetPoint__Group_2__2 : rule__SetPoint__Group_2__2__Impl ;
    public final void rule__SetPoint__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1977:1: ( rule__SetPoint__Group_2__2__Impl )
            // InternalMachine.g:1978:2: rule__SetPoint__Group_2__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__2"


    // $ANTLR start "rule__SetPoint__Group_2__2__Impl"
    // InternalMachine.g:1984:1: rule__SetPoint__Group_2__2__Impl : ( ']' ) ;
    public final void rule__SetPoint__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1988:1: ( ( ']' ) )
            // InternalMachine.g:1989:1: ( ']' )
            {
            // InternalMachine.g:1989:1: ( ']' )
            // InternalMachine.g:1990:2: ']'
            {
             before(grammarAccess.getSetPointAccess().getRightSquareBracketKeyword_2_2()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getRightSquareBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__2__Impl"


    // $ANTLR start "rule__Axis__Group__0"
    // InternalMachine.g:2000:1: rule__Axis__Group__0 : rule__Axis__Group__0__Impl rule__Axis__Group__1 ;
    public final void rule__Axis__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2004:1: ( rule__Axis__Group__0__Impl rule__Axis__Group__1 )
            // InternalMachine.g:2005:2: rule__Axis__Group__0__Impl rule__Axis__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__0"


    // $ANTLR start "rule__Axis__Group__0__Impl"
    // InternalMachine.g:2012:1: rule__Axis__Group__0__Impl : ( () ) ;
    public final void rule__Axis__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2016:1: ( ( () ) )
            // InternalMachine.g:2017:1: ( () )
            {
            // InternalMachine.g:2017:1: ( () )
            // InternalMachine.g:2018:2: ()
            {
             before(grammarAccess.getAxisAccess().getAxisAction_0()); 
            // InternalMachine.g:2019:2: ()
            // InternalMachine.g:2019:3: 
            {
            }

             after(grammarAccess.getAxisAccess().getAxisAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__0__Impl"


    // $ANTLR start "rule__Axis__Group__1"
    // InternalMachine.g:2027:1: rule__Axis__Group__1 : rule__Axis__Group__1__Impl rule__Axis__Group__2 ;
    public final void rule__Axis__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2031:1: ( rule__Axis__Group__1__Impl rule__Axis__Group__2 )
            // InternalMachine.g:2032:2: rule__Axis__Group__1__Impl rule__Axis__Group__2
            {
            pushFollow(FOLLOW_17);
            rule__Axis__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__1"


    // $ANTLR start "rule__Axis__Group__1__Impl"
    // InternalMachine.g:2039:1: rule__Axis__Group__1__Impl : ( ( rule__Axis__NameAssignment_1 ) ) ;
    public final void rule__Axis__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2043:1: ( ( ( rule__Axis__NameAssignment_1 ) ) )
            // InternalMachine.g:2044:1: ( ( rule__Axis__NameAssignment_1 ) )
            {
            // InternalMachine.g:2044:1: ( ( rule__Axis__NameAssignment_1 ) )
            // InternalMachine.g:2045:2: ( rule__Axis__NameAssignment_1 )
            {
             before(grammarAccess.getAxisAccess().getNameAssignment_1()); 
            // InternalMachine.g:2046:2: ( rule__Axis__NameAssignment_1 )
            // InternalMachine.g:2046:3: rule__Axis__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__1__Impl"


    // $ANTLR start "rule__Axis__Group__2"
    // InternalMachine.g:2054:1: rule__Axis__Group__2 : rule__Axis__Group__2__Impl rule__Axis__Group__3 ;
    public final void rule__Axis__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2058:1: ( rule__Axis__Group__2__Impl rule__Axis__Group__3 )
            // InternalMachine.g:2059:2: rule__Axis__Group__2__Impl rule__Axis__Group__3
            {
            pushFollow(FOLLOW_17);
            rule__Axis__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__2"


    // $ANTLR start "rule__Axis__Group__2__Impl"
    // InternalMachine.g:2066:1: rule__Axis__Group__2__Impl : ( ( rule__Axis__Group_2__0 )? ) ;
    public final void rule__Axis__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2070:1: ( ( ( rule__Axis__Group_2__0 )? ) )
            // InternalMachine.g:2071:1: ( ( rule__Axis__Group_2__0 )? )
            {
            // InternalMachine.g:2071:1: ( ( rule__Axis__Group_2__0 )? )
            // InternalMachine.g:2072:2: ( rule__Axis__Group_2__0 )?
            {
             before(grammarAccess.getAxisAccess().getGroup_2()); 
            // InternalMachine.g:2073:2: ( rule__Axis__Group_2__0 )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==24) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // InternalMachine.g:2073:3: rule__Axis__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Axis__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__2__Impl"


    // $ANTLR start "rule__Axis__Group__3"
    // InternalMachine.g:2081:1: rule__Axis__Group__3 : rule__Axis__Group__3__Impl ;
    public final void rule__Axis__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2085:1: ( rule__Axis__Group__3__Impl )
            // InternalMachine.g:2086:2: rule__Axis__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__3"


    // $ANTLR start "rule__Axis__Group__3__Impl"
    // InternalMachine.g:2092:1: rule__Axis__Group__3__Impl : ( ( rule__Axis__Group_3__0 )? ) ;
    public final void rule__Axis__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2096:1: ( ( ( rule__Axis__Group_3__0 )? ) )
            // InternalMachine.g:2097:1: ( ( rule__Axis__Group_3__0 )? )
            {
            // InternalMachine.g:2097:1: ( ( rule__Axis__Group_3__0 )? )
            // InternalMachine.g:2098:2: ( rule__Axis__Group_3__0 )?
            {
             before(grammarAccess.getAxisAccess().getGroup_3()); 
            // InternalMachine.g:2099:2: ( rule__Axis__Group_3__0 )?
            int alt21=2;
            int LA21_0 = input.LA(1);

            if ( (LA21_0==26) ) {
                alt21=1;
            }
            switch (alt21) {
                case 1 :
                    // InternalMachine.g:2099:3: rule__Axis__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Axis__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__3__Impl"


    // $ANTLR start "rule__Axis__Group_2__0"
    // InternalMachine.g:2108:1: rule__Axis__Group_2__0 : rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1 ;
    public final void rule__Axis__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2112:1: ( rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1 )
            // InternalMachine.g:2113:2: rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__0"


    // $ANTLR start "rule__Axis__Group_2__0__Impl"
    // InternalMachine.g:2120:1: rule__Axis__Group_2__0__Impl : ( '[' ) ;
    public final void rule__Axis__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2124:1: ( ( '[' ) )
            // InternalMachine.g:2125:1: ( '[' )
            {
            // InternalMachine.g:2125:1: ( '[' )
            // InternalMachine.g:2126:2: '['
            {
             before(grammarAccess.getAxisAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__0__Impl"


    // $ANTLR start "rule__Axis__Group_2__1"
    // InternalMachine.g:2135:1: rule__Axis__Group_2__1 : rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2 ;
    public final void rule__Axis__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2139:1: ( rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2 )
            // InternalMachine.g:2140:2: rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2
            {
            pushFollow(FOLLOW_16);
            rule__Axis__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__1"


    // $ANTLR start "rule__Axis__Group_2__1__Impl"
    // InternalMachine.g:2147:1: rule__Axis__Group_2__1__Impl : ( ( rule__Axis__UnitAssignment_2_1 ) ) ;
    public final void rule__Axis__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2151:1: ( ( ( rule__Axis__UnitAssignment_2_1 ) ) )
            // InternalMachine.g:2152:1: ( ( rule__Axis__UnitAssignment_2_1 ) )
            {
            // InternalMachine.g:2152:1: ( ( rule__Axis__UnitAssignment_2_1 ) )
            // InternalMachine.g:2153:2: ( rule__Axis__UnitAssignment_2_1 )
            {
             before(grammarAccess.getAxisAccess().getUnitAssignment_2_1()); 
            // InternalMachine.g:2154:2: ( rule__Axis__UnitAssignment_2_1 )
            // InternalMachine.g:2154:3: rule__Axis__UnitAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__UnitAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getUnitAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__1__Impl"


    // $ANTLR start "rule__Axis__Group_2__2"
    // InternalMachine.g:2162:1: rule__Axis__Group_2__2 : rule__Axis__Group_2__2__Impl ;
    public final void rule__Axis__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2166:1: ( rule__Axis__Group_2__2__Impl )
            // InternalMachine.g:2167:2: rule__Axis__Group_2__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__2"


    // $ANTLR start "rule__Axis__Group_2__2__Impl"
    // InternalMachine.g:2173:1: rule__Axis__Group_2__2__Impl : ( ']' ) ;
    public final void rule__Axis__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2177:1: ( ( ']' ) )
            // InternalMachine.g:2178:1: ( ']' )
            {
            // InternalMachine.g:2178:1: ( ']' )
            // InternalMachine.g:2179:2: ']'
            {
             before(grammarAccess.getAxisAccess().getRightSquareBracketKeyword_2_2()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getRightSquareBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__2__Impl"


    // $ANTLR start "rule__Axis__Group_3__0"
    // InternalMachine.g:2189:1: rule__Axis__Group_3__0 : rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1 ;
    public final void rule__Axis__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2193:1: ( rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1 )
            // InternalMachine.g:2194:2: rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__0"


    // $ANTLR start "rule__Axis__Group_3__0__Impl"
    // InternalMachine.g:2201:1: rule__Axis__Group_3__0__Impl : ( 'moves' ) ;
    public final void rule__Axis__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2205:1: ( ( 'moves' ) )
            // InternalMachine.g:2206:1: ( 'moves' )
            {
            // InternalMachine.g:2206:1: ( 'moves' )
            // InternalMachine.g:2207:2: 'moves'
            {
             before(grammarAccess.getAxisAccess().getMovesKeyword_3_0()); 
            match(input,26,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getMovesKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__0__Impl"


    // $ANTLR start "rule__Axis__Group_3__1"
    // InternalMachine.g:2216:1: rule__Axis__Group_3__1 : rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2 ;
    public final void rule__Axis__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2220:1: ( rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2 )
            // InternalMachine.g:2221:2: rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2
            {
            pushFollow(FOLLOW_18);
            rule__Axis__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__1"


    // $ANTLR start "rule__Axis__Group_3__1__Impl"
    // InternalMachine.g:2228:1: rule__Axis__Group_3__1__Impl : ( ( rule__Axis__SetPointsAssignment_3_1 ) ) ;
    public final void rule__Axis__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2232:1: ( ( ( rule__Axis__SetPointsAssignment_3_1 ) ) )
            // InternalMachine.g:2233:1: ( ( rule__Axis__SetPointsAssignment_3_1 ) )
            {
            // InternalMachine.g:2233:1: ( ( rule__Axis__SetPointsAssignment_3_1 ) )
            // InternalMachine.g:2234:2: ( rule__Axis__SetPointsAssignment_3_1 )
            {
             before(grammarAccess.getAxisAccess().getSetPointsAssignment_3_1()); 
            // InternalMachine.g:2235:2: ( rule__Axis__SetPointsAssignment_3_1 )
            // InternalMachine.g:2235:3: rule__Axis__SetPointsAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__SetPointsAssignment_3_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getSetPointsAssignment_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__1__Impl"


    // $ANTLR start "rule__Axis__Group_3__2"
    // InternalMachine.g:2243:1: rule__Axis__Group_3__2 : rule__Axis__Group_3__2__Impl ;
    public final void rule__Axis__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2247:1: ( rule__Axis__Group_3__2__Impl )
            // InternalMachine.g:2248:2: rule__Axis__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__2"


    // $ANTLR start "rule__Axis__Group_3__2__Impl"
    // InternalMachine.g:2254:1: rule__Axis__Group_3__2__Impl : ( ( rule__Axis__Group_3_2__0 )* ) ;
    public final void rule__Axis__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2258:1: ( ( ( rule__Axis__Group_3_2__0 )* ) )
            // InternalMachine.g:2259:1: ( ( rule__Axis__Group_3_2__0 )* )
            {
            // InternalMachine.g:2259:1: ( ( rule__Axis__Group_3_2__0 )* )
            // InternalMachine.g:2260:2: ( rule__Axis__Group_3_2__0 )*
            {
             before(grammarAccess.getAxisAccess().getGroup_3_2()); 
            // InternalMachine.g:2261:2: ( rule__Axis__Group_3_2__0 )*
            loop22:
            do {
                int alt22=2;
                int LA22_0 = input.LA(1);

                if ( (LA22_0==27) ) {
                    alt22=1;
                }


                switch (alt22) {
            	case 1 :
            	    // InternalMachine.g:2261:3: rule__Axis__Group_3_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Axis__Group_3_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop22;
                }
            } while (true);

             after(grammarAccess.getAxisAccess().getGroup_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__2__Impl"


    // $ANTLR start "rule__Axis__Group_3_2__0"
    // InternalMachine.g:2270:1: rule__Axis__Group_3_2__0 : rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1 ;
    public final void rule__Axis__Group_3_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2274:1: ( rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1 )
            // InternalMachine.g:2275:2: rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_3_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__0"


    // $ANTLR start "rule__Axis__Group_3_2__0__Impl"
    // InternalMachine.g:2282:1: rule__Axis__Group_3_2__0__Impl : ( ',' ) ;
    public final void rule__Axis__Group_3_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2286:1: ( ( ',' ) )
            // InternalMachine.g:2287:1: ( ',' )
            {
            // InternalMachine.g:2287:1: ( ',' )
            // InternalMachine.g:2288:2: ','
            {
             before(grammarAccess.getAxisAccess().getCommaKeyword_3_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getCommaKeyword_3_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__0__Impl"


    // $ANTLR start "rule__Axis__Group_3_2__1"
    // InternalMachine.g:2297:1: rule__Axis__Group_3_2__1 : rule__Axis__Group_3_2__1__Impl ;
    public final void rule__Axis__Group_3_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2301:1: ( rule__Axis__Group_3_2__1__Impl )
            // InternalMachine.g:2302:2: rule__Axis__Group_3_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_3_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__1"


    // $ANTLR start "rule__Axis__Group_3_2__1__Impl"
    // InternalMachine.g:2308:1: rule__Axis__Group_3_2__1__Impl : ( ( rule__Axis__SetPointsAssignment_3_2_1 ) ) ;
    public final void rule__Axis__Group_3_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2312:1: ( ( ( rule__Axis__SetPointsAssignment_3_2_1 ) ) )
            // InternalMachine.g:2313:1: ( ( rule__Axis__SetPointsAssignment_3_2_1 ) )
            {
            // InternalMachine.g:2313:1: ( ( rule__Axis__SetPointsAssignment_3_2_1 ) )
            // InternalMachine.g:2314:2: ( rule__Axis__SetPointsAssignment_3_2_1 )
            {
             before(grammarAccess.getAxisAccess().getSetPointsAssignment_3_2_1()); 
            // InternalMachine.g:2315:2: ( rule__Axis__SetPointsAssignment_3_2_1 )
            // InternalMachine.g:2315:3: rule__Axis__SetPointsAssignment_3_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__SetPointsAssignment_3_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getSetPointsAssignment_3_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__1__Impl"


    // $ANTLR start "rule__ResourceItem__Group__0"
    // InternalMachine.g:2324:1: rule__ResourceItem__Group__0 : rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1 ;
    public final void rule__ResourceItem__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2328:1: ( rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1 )
            // InternalMachine.g:2329:2: rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1
            {
            pushFollow(FOLLOW_20);
            rule__ResourceItem__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__0"


    // $ANTLR start "rule__ResourceItem__Group__0__Impl"
    // InternalMachine.g:2336:1: rule__ResourceItem__Group__0__Impl : ( () ) ;
    public final void rule__ResourceItem__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2340:1: ( ( () ) )
            // InternalMachine.g:2341:1: ( () )
            {
            // InternalMachine.g:2341:1: ( () )
            // InternalMachine.g:2342:2: ()
            {
             before(grammarAccess.getResourceItemAccess().getResourceItemAction_0()); 
            // InternalMachine.g:2343:2: ()
            // InternalMachine.g:2343:3: 
            {
            }

             after(grammarAccess.getResourceItemAccess().getResourceItemAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__0__Impl"


    // $ANTLR start "rule__ResourceItem__Group__1"
    // InternalMachine.g:2351:1: rule__ResourceItem__Group__1 : rule__ResourceItem__Group__1__Impl ;
    public final void rule__ResourceItem__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2355:1: ( rule__ResourceItem__Group__1__Impl )
            // InternalMachine.g:2356:2: rule__ResourceItem__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__1"


    // $ANTLR start "rule__ResourceItem__Group__1__Impl"
    // InternalMachine.g:2362:1: rule__ResourceItem__Group__1__Impl : ( ( rule__ResourceItem__NameAssignment_1 ) ) ;
    public final void rule__ResourceItem__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2366:1: ( ( ( rule__ResourceItem__NameAssignment_1 ) ) )
            // InternalMachine.g:2367:1: ( ( rule__ResourceItem__NameAssignment_1 ) )
            {
            // InternalMachine.g:2367:1: ( ( rule__ResourceItem__NameAssignment_1 ) )
            // InternalMachine.g:2368:2: ( rule__ResourceItem__NameAssignment_1 )
            {
             before(grammarAccess.getResourceItemAccess().getNameAssignment_1()); 
            // InternalMachine.g:2369:2: ( rule__ResourceItem__NameAssignment_1 )
            // InternalMachine.g:2369:3: rule__ResourceItem__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceItemAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__1__Impl"


    // $ANTLR start "rule__Resource__Group__0"
    // InternalMachine.g:2378:1: rule__Resource__Group__0 : rule__Resource__Group__0__Impl rule__Resource__Group__1 ;
    public final void rule__Resource__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2382:1: ( rule__Resource__Group__0__Impl rule__Resource__Group__1 )
            // InternalMachine.g:2383:2: rule__Resource__Group__0__Impl rule__Resource__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Resource__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__0"


    // $ANTLR start "rule__Resource__Group__0__Impl"
    // InternalMachine.g:2390:1: rule__Resource__Group__0__Impl : ( ( rule__Resource__ResourceTypeAssignment_0 ) ) ;
    public final void rule__Resource__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2394:1: ( ( ( rule__Resource__ResourceTypeAssignment_0 ) ) )
            // InternalMachine.g:2395:1: ( ( rule__Resource__ResourceTypeAssignment_0 ) )
            {
            // InternalMachine.g:2395:1: ( ( rule__Resource__ResourceTypeAssignment_0 ) )
            // InternalMachine.g:2396:2: ( rule__Resource__ResourceTypeAssignment_0 )
            {
             before(grammarAccess.getResourceAccess().getResourceTypeAssignment_0()); 
            // InternalMachine.g:2397:2: ( rule__Resource__ResourceTypeAssignment_0 )
            // InternalMachine.g:2397:3: rule__Resource__ResourceTypeAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Resource__ResourceTypeAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getResourceTypeAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__0__Impl"


    // $ANTLR start "rule__Resource__Group__1"
    // InternalMachine.g:2405:1: rule__Resource__Group__1 : rule__Resource__Group__1__Impl rule__Resource__Group__2 ;
    public final void rule__Resource__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2409:1: ( rule__Resource__Group__1__Impl rule__Resource__Group__2 )
            // InternalMachine.g:2410:2: rule__Resource__Group__1__Impl rule__Resource__Group__2
            {
            pushFollow(FOLLOW_21);
            rule__Resource__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__1"


    // $ANTLR start "rule__Resource__Group__1__Impl"
    // InternalMachine.g:2417:1: rule__Resource__Group__1__Impl : ( ( rule__Resource__NameAssignment_1 ) ) ;
    public final void rule__Resource__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2421:1: ( ( ( rule__Resource__NameAssignment_1 ) ) )
            // InternalMachine.g:2422:1: ( ( rule__Resource__NameAssignment_1 ) )
            {
            // InternalMachine.g:2422:1: ( ( rule__Resource__NameAssignment_1 ) )
            // InternalMachine.g:2423:2: ( rule__Resource__NameAssignment_1 )
            {
             before(grammarAccess.getResourceAccess().getNameAssignment_1()); 
            // InternalMachine.g:2424:2: ( rule__Resource__NameAssignment_1 )
            // InternalMachine.g:2424:3: rule__Resource__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__1__Impl"


    // $ANTLR start "rule__Resource__Group__2"
    // InternalMachine.g:2432:1: rule__Resource__Group__2 : rule__Resource__Group__2__Impl rule__Resource__Group__3 ;
    public final void rule__Resource__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2436:1: ( rule__Resource__Group__2__Impl rule__Resource__Group__3 )
            // InternalMachine.g:2437:2: rule__Resource__Group__2__Impl rule__Resource__Group__3
            {
            pushFollow(FOLLOW_21);
            rule__Resource__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__2"


    // $ANTLR start "rule__Resource__Group__2__Impl"
    // InternalMachine.g:2444:1: rule__Resource__Group__2__Impl : ( ( rule__Resource__Group_2__0 )? ) ;
    public final void rule__Resource__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2448:1: ( ( ( rule__Resource__Group_2__0 )? ) )
            // InternalMachine.g:2449:1: ( ( rule__Resource__Group_2__0 )? )
            {
            // InternalMachine.g:2449:1: ( ( rule__Resource__Group_2__0 )? )
            // InternalMachine.g:2450:2: ( rule__Resource__Group_2__0 )?
            {
             before(grammarAccess.getResourceAccess().getGroup_2()); 
            // InternalMachine.g:2451:2: ( rule__Resource__Group_2__0 )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( (LA23_0==28) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // InternalMachine.g:2451:3: rule__Resource__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Resource__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getResourceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__2__Impl"


    // $ANTLR start "rule__Resource__Group__3"
    // InternalMachine.g:2459:1: rule__Resource__Group__3 : rule__Resource__Group__3__Impl rule__Resource__Group__4 ;
    public final void rule__Resource__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2463:1: ( rule__Resource__Group__3__Impl rule__Resource__Group__4 )
            // InternalMachine.g:2464:2: rule__Resource__Group__3__Impl rule__Resource__Group__4
            {
            pushFollow(FOLLOW_8);
            rule__Resource__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__3"


    // $ANTLR start "rule__Resource__Group__3__Impl"
    // InternalMachine.g:2471:1: rule__Resource__Group__3__Impl : ( '{' ) ;
    public final void rule__Resource__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2475:1: ( ( '{' ) )
            // InternalMachine.g:2476:1: ( '{' )
            {
            // InternalMachine.g:2476:1: ( '{' )
            // InternalMachine.g:2477:2: '{'
            {
             before(grammarAccess.getResourceAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__3__Impl"


    // $ANTLR start "rule__Resource__Group__4"
    // InternalMachine.g:2486:1: rule__Resource__Group__4 : rule__Resource__Group__4__Impl rule__Resource__Group__5 ;
    public final void rule__Resource__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2490:1: ( rule__Resource__Group__4__Impl rule__Resource__Group__5 )
            // InternalMachine.g:2491:2: rule__Resource__Group__4__Impl rule__Resource__Group__5
            {
            pushFollow(FOLLOW_8);
            rule__Resource__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__4"


    // $ANTLR start "rule__Resource__Group__4__Impl"
    // InternalMachine.g:2498:1: rule__Resource__Group__4__Impl : ( ( rule__Resource__PeripheralsAssignment_4 )* ) ;
    public final void rule__Resource__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2502:1: ( ( ( rule__Resource__PeripheralsAssignment_4 )* ) )
            // InternalMachine.g:2503:1: ( ( rule__Resource__PeripheralsAssignment_4 )* )
            {
            // InternalMachine.g:2503:1: ( ( rule__Resource__PeripheralsAssignment_4 )* )
            // InternalMachine.g:2504:2: ( rule__Resource__PeripheralsAssignment_4 )*
            {
             before(grammarAccess.getResourceAccess().getPeripheralsAssignment_4()); 
            // InternalMachine.g:2505:2: ( rule__Resource__PeripheralsAssignment_4 )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==RULE_ID) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // InternalMachine.g:2505:3: rule__Resource__PeripheralsAssignment_4
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Resource__PeripheralsAssignment_4();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);

             after(grammarAccess.getResourceAccess().getPeripheralsAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__4__Impl"


    // $ANTLR start "rule__Resource__Group__5"
    // InternalMachine.g:2513:1: rule__Resource__Group__5 : rule__Resource__Group__5__Impl ;
    public final void rule__Resource__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2517:1: ( rule__Resource__Group__5__Impl )
            // InternalMachine.g:2518:2: rule__Resource__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__5"


    // $ANTLR start "rule__Resource__Group__5__Impl"
    // InternalMachine.g:2524:1: rule__Resource__Group__5__Impl : ( '}' ) ;
    public final void rule__Resource__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2528:1: ( ( '}' ) )
            // InternalMachine.g:2529:1: ( '}' )
            {
            // InternalMachine.g:2529:1: ( '}' )
            // InternalMachine.g:2530:2: '}'
            {
             before(grammarAccess.getResourceAccess().getRightCurlyBracketKeyword_5()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__5__Impl"


    // $ANTLR start "rule__Resource__Group_2__0"
    // InternalMachine.g:2540:1: rule__Resource__Group_2__0 : rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1 ;
    public final void rule__Resource__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2544:1: ( rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1 )
            // InternalMachine.g:2545:2: rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1
            {
            pushFollow(FOLLOW_20);
            rule__Resource__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__0"


    // $ANTLR start "rule__Resource__Group_2__0__Impl"
    // InternalMachine.g:2552:1: rule__Resource__Group_2__0__Impl : ( '(' ) ;
    public final void rule__Resource__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2556:1: ( ( '(' ) )
            // InternalMachine.g:2557:1: ( '(' )
            {
            // InternalMachine.g:2557:1: ( '(' )
            // InternalMachine.g:2558:2: '('
            {
             before(grammarAccess.getResourceAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,28,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__0__Impl"


    // $ANTLR start "rule__Resource__Group_2__1"
    // InternalMachine.g:2567:1: rule__Resource__Group_2__1 : rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2 ;
    public final void rule__Resource__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2571:1: ( rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2 )
            // InternalMachine.g:2572:2: rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__Resource__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__1"


    // $ANTLR start "rule__Resource__Group_2__1__Impl"
    // InternalMachine.g:2579:1: rule__Resource__Group_2__1__Impl : ( ( rule__Resource__ItemsAssignment_2_1 ) ) ;
    public final void rule__Resource__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2583:1: ( ( ( rule__Resource__ItemsAssignment_2_1 ) ) )
            // InternalMachine.g:2584:1: ( ( rule__Resource__ItemsAssignment_2_1 ) )
            {
            // InternalMachine.g:2584:1: ( ( rule__Resource__ItemsAssignment_2_1 ) )
            // InternalMachine.g:2585:2: ( rule__Resource__ItemsAssignment_2_1 )
            {
             before(grammarAccess.getResourceAccess().getItemsAssignment_2_1()); 
            // InternalMachine.g:2586:2: ( rule__Resource__ItemsAssignment_2_1 )
            // InternalMachine.g:2586:3: rule__Resource__ItemsAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__ItemsAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getItemsAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__1__Impl"


    // $ANTLR start "rule__Resource__Group_2__2"
    // InternalMachine.g:2594:1: rule__Resource__Group_2__2 : rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3 ;
    public final void rule__Resource__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2598:1: ( rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3 )
            // InternalMachine.g:2599:2: rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__Resource__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__2"


    // $ANTLR start "rule__Resource__Group_2__2__Impl"
    // InternalMachine.g:2606:1: rule__Resource__Group_2__2__Impl : ( ( rule__Resource__Group_2_2__0 )* ) ;
    public final void rule__Resource__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2610:1: ( ( ( rule__Resource__Group_2_2__0 )* ) )
            // InternalMachine.g:2611:1: ( ( rule__Resource__Group_2_2__0 )* )
            {
            // InternalMachine.g:2611:1: ( ( rule__Resource__Group_2_2__0 )* )
            // InternalMachine.g:2612:2: ( rule__Resource__Group_2_2__0 )*
            {
             before(grammarAccess.getResourceAccess().getGroup_2_2()); 
            // InternalMachine.g:2613:2: ( rule__Resource__Group_2_2__0 )*
            loop25:
            do {
                int alt25=2;
                int LA25_0 = input.LA(1);

                if ( (LA25_0==27) ) {
                    alt25=1;
                }


                switch (alt25) {
            	case 1 :
            	    // InternalMachine.g:2613:3: rule__Resource__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Resource__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop25;
                }
            } while (true);

             after(grammarAccess.getResourceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__2__Impl"


    // $ANTLR start "rule__Resource__Group_2__3"
    // InternalMachine.g:2621:1: rule__Resource__Group_2__3 : rule__Resource__Group_2__3__Impl ;
    public final void rule__Resource__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2625:1: ( rule__Resource__Group_2__3__Impl )
            // InternalMachine.g:2626:2: rule__Resource__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__3"


    // $ANTLR start "rule__Resource__Group_2__3__Impl"
    // InternalMachine.g:2632:1: rule__Resource__Group_2__3__Impl : ( ')' ) ;
    public final void rule__Resource__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2636:1: ( ( ')' ) )
            // InternalMachine.g:2637:1: ( ')' )
            {
            // InternalMachine.g:2637:1: ( ')' )
            // InternalMachine.g:2638:2: ')'
            {
             before(grammarAccess.getResourceAccess().getRightParenthesisKeyword_2_3()); 
            match(input,29,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__3__Impl"


    // $ANTLR start "rule__Resource__Group_2_2__0"
    // InternalMachine.g:2648:1: rule__Resource__Group_2_2__0 : rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1 ;
    public final void rule__Resource__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2652:1: ( rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1 )
            // InternalMachine.g:2653:2: rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1
            {
            pushFollow(FOLLOW_20);
            rule__Resource__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__0"


    // $ANTLR start "rule__Resource__Group_2_2__0__Impl"
    // InternalMachine.g:2660:1: rule__Resource__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__Resource__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2664:1: ( ( ',' ) )
            // InternalMachine.g:2665:1: ( ',' )
            {
            // InternalMachine.g:2665:1: ( ',' )
            // InternalMachine.g:2666:2: ','
            {
             before(grammarAccess.getResourceAccess().getCommaKeyword_2_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__0__Impl"


    // $ANTLR start "rule__Resource__Group_2_2__1"
    // InternalMachine.g:2675:1: rule__Resource__Group_2_2__1 : rule__Resource__Group_2_2__1__Impl ;
    public final void rule__Resource__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2679:1: ( rule__Resource__Group_2_2__1__Impl )
            // InternalMachine.g:2680:2: rule__Resource__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__1"


    // $ANTLR start "rule__Resource__Group_2_2__1__Impl"
    // InternalMachine.g:2686:1: rule__Resource__Group_2_2__1__Impl : ( ( rule__Resource__ItemsAssignment_2_2_1 ) ) ;
    public final void rule__Resource__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2690:1: ( ( ( rule__Resource__ItemsAssignment_2_2_1 ) ) )
            // InternalMachine.g:2691:1: ( ( rule__Resource__ItemsAssignment_2_2_1 ) )
            {
            // InternalMachine.g:2691:1: ( ( rule__Resource__ItemsAssignment_2_2_1 ) )
            // InternalMachine.g:2692:2: ( rule__Resource__ItemsAssignment_2_2_1 )
            {
             before(grammarAccess.getResourceAccess().getItemsAssignment_2_2_1()); 
            // InternalMachine.g:2693:2: ( rule__Resource__ItemsAssignment_2_2_1 )
            // InternalMachine.g:2693:3: rule__Resource__ItemsAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__ItemsAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getItemsAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__1__Impl"


    // $ANTLR start "rule__Peripheral__Group__0"
    // InternalMachine.g:2702:1: rule__Peripheral__Group__0 : rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1 ;
    public final void rule__Peripheral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2706:1: ( rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1 )
            // InternalMachine.g:2707:2: rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1
            {
            pushFollow(FOLLOW_23);
            rule__Peripheral__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__0"


    // $ANTLR start "rule__Peripheral__Group__0__Impl"
    // InternalMachine.g:2714:1: rule__Peripheral__Group__0__Impl : ( ( rule__Peripheral__NameAssignment_0 ) ) ;
    public final void rule__Peripheral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2718:1: ( ( ( rule__Peripheral__NameAssignment_0 ) ) )
            // InternalMachine.g:2719:1: ( ( rule__Peripheral__NameAssignment_0 ) )
            {
            // InternalMachine.g:2719:1: ( ( rule__Peripheral__NameAssignment_0 ) )
            // InternalMachine.g:2720:2: ( rule__Peripheral__NameAssignment_0 )
            {
             before(grammarAccess.getPeripheralAccess().getNameAssignment_0()); 
            // InternalMachine.g:2721:2: ( rule__Peripheral__NameAssignment_0 )
            // InternalMachine.g:2721:3: rule__Peripheral__NameAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__0__Impl"


    // $ANTLR start "rule__Peripheral__Group__1"
    // InternalMachine.g:2729:1: rule__Peripheral__Group__1 : rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2 ;
    public final void rule__Peripheral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2733:1: ( rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2 )
            // InternalMachine.g:2734:2: rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__1"


    // $ANTLR start "rule__Peripheral__Group__1__Impl"
    // InternalMachine.g:2741:1: rule__Peripheral__Group__1__Impl : ( ':' ) ;
    public final void rule__Peripheral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2745:1: ( ( ':' ) )
            // InternalMachine.g:2746:1: ( ':' )
            {
            // InternalMachine.g:2746:1: ( ':' )
            // InternalMachine.g:2747:2: ':'
            {
             before(grammarAccess.getPeripheralAccess().getColonKeyword_1()); 
            match(input,30,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getColonKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__1__Impl"


    // $ANTLR start "rule__Peripheral__Group__2"
    // InternalMachine.g:2756:1: rule__Peripheral__Group__2 : rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3 ;
    public final void rule__Peripheral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2760:1: ( rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3 )
            // InternalMachine.g:2761:2: rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__2"


    // $ANTLR start "rule__Peripheral__Group__2__Impl"
    // InternalMachine.g:2768:1: rule__Peripheral__Group__2__Impl : ( ( rule__Peripheral__TypeAssignment_2 ) ) ;
    public final void rule__Peripheral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2772:1: ( ( ( rule__Peripheral__TypeAssignment_2 ) ) )
            // InternalMachine.g:2773:1: ( ( rule__Peripheral__TypeAssignment_2 ) )
            {
            // InternalMachine.g:2773:1: ( ( rule__Peripheral__TypeAssignment_2 ) )
            // InternalMachine.g:2774:2: ( rule__Peripheral__TypeAssignment_2 )
            {
             before(grammarAccess.getPeripheralAccess().getTypeAssignment_2()); 
            // InternalMachine.g:2775:2: ( rule__Peripheral__TypeAssignment_2 )
            // InternalMachine.g:2775:3: rule__Peripheral__TypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__TypeAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getTypeAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__2__Impl"


    // $ANTLR start "rule__Peripheral__Group__3"
    // InternalMachine.g:2783:1: rule__Peripheral__Group__3 : rule__Peripheral__Group__3__Impl ;
    public final void rule__Peripheral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2787:1: ( rule__Peripheral__Group__3__Impl )
            // InternalMachine.g:2788:2: rule__Peripheral__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__3"


    // $ANTLR start "rule__Peripheral__Group__3__Impl"
    // InternalMachine.g:2794:1: rule__Peripheral__Group__3__Impl : ( ( rule__Peripheral__Group_3__0 )? ) ;
    public final void rule__Peripheral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2798:1: ( ( ( rule__Peripheral__Group_3__0 )? ) )
            // InternalMachine.g:2799:1: ( ( rule__Peripheral__Group_3__0 )? )
            {
            // InternalMachine.g:2799:1: ( ( rule__Peripheral__Group_3__0 )? )
            // InternalMachine.g:2800:2: ( rule__Peripheral__Group_3__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3()); 
            // InternalMachine.g:2801:2: ( rule__Peripheral__Group_3__0 )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==16) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // InternalMachine.g:2801:3: rule__Peripheral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__0"
    // InternalMachine.g:2810:1: rule__Peripheral__Group_3__0 : rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1 ;
    public final void rule__Peripheral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2814:1: ( rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1 )
            // InternalMachine.g:2815:2: rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1
            {
            pushFollow(FOLLOW_24);
            rule__Peripheral__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__0"


    // $ANTLR start "rule__Peripheral__Group_3__0__Impl"
    // InternalMachine.g:2822:1: rule__Peripheral__Group_3__0__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2826:1: ( ( '{' ) )
            // InternalMachine.g:2827:1: ( '{' )
            {
            // InternalMachine.g:2827:1: ( '{' )
            // InternalMachine.g:2828:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__1"
    // InternalMachine.g:2837:1: rule__Peripheral__Group_3__1 : rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2 ;
    public final void rule__Peripheral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2841:1: ( rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2 )
            // InternalMachine.g:2842:2: rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2
            {
            pushFollow(FOLLOW_24);
            rule__Peripheral__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__1"


    // $ANTLR start "rule__Peripheral__Group_3__1__Impl"
    // InternalMachine.g:2849:1: rule__Peripheral__Group_3__1__Impl : ( ( rule__Peripheral__Group_3_1__0 )? ) ;
    public final void rule__Peripheral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2853:1: ( ( ( rule__Peripheral__Group_3_1__0 )? ) )
            // InternalMachine.g:2854:1: ( ( rule__Peripheral__Group_3_1__0 )? )
            {
            // InternalMachine.g:2854:1: ( ( rule__Peripheral__Group_3_1__0 )? )
            // InternalMachine.g:2855:2: ( rule__Peripheral__Group_3_1__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1()); 
            // InternalMachine.g:2856:2: ( rule__Peripheral__Group_3_1__0 )?
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( ((LA27_0>=31 && LA27_0<=33)) ) {
                alt27=1;
            }
            switch (alt27) {
                case 1 :
                    // InternalMachine.g:2856:3: rule__Peripheral__Group_3_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__2"
    // InternalMachine.g:2864:1: rule__Peripheral__Group_3__2 : rule__Peripheral__Group_3__2__Impl ;
    public final void rule__Peripheral__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2868:1: ( rule__Peripheral__Group_3__2__Impl )
            // InternalMachine.g:2869:2: rule__Peripheral__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__2"


    // $ANTLR start "rule__Peripheral__Group_3__2__Impl"
    // InternalMachine.g:2875:1: rule__Peripheral__Group_3__2__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2879:1: ( ( '}' ) )
            // InternalMachine.g:2880:1: ( '}' )
            {
            // InternalMachine.g:2880:1: ( '}' )
            // InternalMachine.g:2881:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__0"
    // InternalMachine.g:2891:1: rule__Peripheral__Group_3_1__0 : rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1 ;
    public final void rule__Peripheral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2895:1: ( rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1 )
            // InternalMachine.g:2896:2: rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1
            {
            pushFollow(FOLLOW_25);
            rule__Peripheral__Group_3_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__0"


    // $ANTLR start "rule__Peripheral__Group_3_1__0__Impl"
    // InternalMachine.g:2903:1: rule__Peripheral__Group_3_1__0__Impl : ( ( rule__Peripheral__Group_3_1_0__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2907:1: ( ( ( rule__Peripheral__Group_3_1_0__0 )? ) )
            // InternalMachine.g:2908:1: ( ( rule__Peripheral__Group_3_1_0__0 )? )
            {
            // InternalMachine.g:2908:1: ( ( rule__Peripheral__Group_3_1_0__0 )? )
            // InternalMachine.g:2909:2: ( rule__Peripheral__Group_3_1_0__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_0()); 
            // InternalMachine.g:2910:2: ( rule__Peripheral__Group_3_1_0__0 )?
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==32) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // InternalMachine.g:2910:3: rule__Peripheral__Group_3_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_0__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__1"
    // InternalMachine.g:2918:1: rule__Peripheral__Group_3_1__1 : rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2 ;
    public final void rule__Peripheral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2922:1: ( rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2 )
            // InternalMachine.g:2923:2: rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2
            {
            pushFollow(FOLLOW_25);
            rule__Peripheral__Group_3_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__1"


    // $ANTLR start "rule__Peripheral__Group_3_1__1__Impl"
    // InternalMachine.g:2930:1: rule__Peripheral__Group_3_1__1__Impl : ( ( rule__Peripheral__Group_3_1_1__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2934:1: ( ( ( rule__Peripheral__Group_3_1_1__0 )? ) )
            // InternalMachine.g:2935:1: ( ( rule__Peripheral__Group_3_1_1__0 )? )
            {
            // InternalMachine.g:2935:1: ( ( rule__Peripheral__Group_3_1_1__0 )? )
            // InternalMachine.g:2936:2: ( rule__Peripheral__Group_3_1_1__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_1()); 
            // InternalMachine.g:2937:2: ( rule__Peripheral__Group_3_1_1__0 )?
            int alt29=2;
            int LA29_0 = input.LA(1);

            if ( (LA29_0==33) ) {
                alt29=1;
            }
            switch (alt29) {
                case 1 :
                    // InternalMachine.g:2937:3: rule__Peripheral__Group_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__2"
    // InternalMachine.g:2945:1: rule__Peripheral__Group_3_1__2 : rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3 ;
    public final void rule__Peripheral__Group_3_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2949:1: ( rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3 )
            // InternalMachine.g:2950:2: rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3
            {
            pushFollow(FOLLOW_26);
            rule__Peripheral__Group_3_1__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__2"


    // $ANTLR start "rule__Peripheral__Group_3_1__2__Impl"
    // InternalMachine.g:2957:1: rule__Peripheral__Group_3_1__2__Impl : ( 'Profiles' ) ;
    public final void rule__Peripheral__Group_3_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2961:1: ( ( 'Profiles' ) )
            // InternalMachine.g:2962:1: ( 'Profiles' )
            {
            // InternalMachine.g:2962:1: ( 'Profiles' )
            // InternalMachine.g:2963:2: 'Profiles'
            {
             before(grammarAccess.getPeripheralAccess().getProfilesKeyword_3_1_2()); 
            match(input,31,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getProfilesKeyword_3_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__3"
    // InternalMachine.g:2972:1: rule__Peripheral__Group_3_1__3 : rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4 ;
    public final void rule__Peripheral__Group_3_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2976:1: ( rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4 )
            // InternalMachine.g:2977:2: rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group_3_1__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__3"


    // $ANTLR start "rule__Peripheral__Group_3_1__3__Impl"
    // InternalMachine.g:2984:1: rule__Peripheral__Group_3_1__3__Impl : ( '(' ) ;
    public final void rule__Peripheral__Group_3_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2988:1: ( ( '(' ) )
            // InternalMachine.g:2989:1: ( '(' )
            {
            // InternalMachine.g:2989:1: ( '(' )
            // InternalMachine.g:2990:2: '('
            {
             before(grammarAccess.getPeripheralAccess().getLeftParenthesisKeyword_3_1_3()); 
            match(input,28,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftParenthesisKeyword_3_1_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__4"
    // InternalMachine.g:2999:1: rule__Peripheral__Group_3_1__4 : rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5 ;
    public final void rule__Peripheral__Group_3_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3003:1: ( rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5 )
            // InternalMachine.g:3004:2: rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5
            {
            pushFollow(FOLLOW_22);
            rule__Peripheral__Group_3_1__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__4"


    // $ANTLR start "rule__Peripheral__Group_3_1__4__Impl"
    // InternalMachine.g:3011:1: rule__Peripheral__Group_3_1__4__Impl : ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) ) ;
    public final void rule__Peripheral__Group_3_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3015:1: ( ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) ) )
            // InternalMachine.g:3016:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) )
            {
            // InternalMachine.g:3016:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) )
            // InternalMachine.g:3017:2: ( rule__Peripheral__ProfilesAssignment_3_1_4 )
            {
             before(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_4()); 
            // InternalMachine.g:3018:2: ( rule__Peripheral__ProfilesAssignment_3_1_4 )
            // InternalMachine.g:3018:3: rule__Peripheral__ProfilesAssignment_3_1_4
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__ProfilesAssignment_3_1_4();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__4__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__5"
    // InternalMachine.g:3026:1: rule__Peripheral__Group_3_1__5 : rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6 ;
    public final void rule__Peripheral__Group_3_1__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3030:1: ( rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6 )
            // InternalMachine.g:3031:2: rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6
            {
            pushFollow(FOLLOW_22);
            rule__Peripheral__Group_3_1__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__5"


    // $ANTLR start "rule__Peripheral__Group_3_1__5__Impl"
    // InternalMachine.g:3038:1: rule__Peripheral__Group_3_1__5__Impl : ( ( rule__Peripheral__Group_3_1_5__0 )* ) ;
    public final void rule__Peripheral__Group_3_1__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3042:1: ( ( ( rule__Peripheral__Group_3_1_5__0 )* ) )
            // InternalMachine.g:3043:1: ( ( rule__Peripheral__Group_3_1_5__0 )* )
            {
            // InternalMachine.g:3043:1: ( ( rule__Peripheral__Group_3_1_5__0 )* )
            // InternalMachine.g:3044:2: ( rule__Peripheral__Group_3_1_5__0 )*
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_5()); 
            // InternalMachine.g:3045:2: ( rule__Peripheral__Group_3_1_5__0 )*
            loop30:
            do {
                int alt30=2;
                int LA30_0 = input.LA(1);

                if ( (LA30_0==27) ) {
                    alt30=1;
                }


                switch (alt30) {
            	case 1 :
            	    // InternalMachine.g:3045:3: rule__Peripheral__Group_3_1_5__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Peripheral__Group_3_1_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop30;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__5__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__6"
    // InternalMachine.g:3053:1: rule__Peripheral__Group_3_1__6 : rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7 ;
    public final void rule__Peripheral__Group_3_1__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3057:1: ( rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7 )
            // InternalMachine.g:3058:2: rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7
            {
            pushFollow(FOLLOW_27);
            rule__Peripheral__Group_3_1__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__6"


    // $ANTLR start "rule__Peripheral__Group_3_1__6__Impl"
    // InternalMachine.g:3065:1: rule__Peripheral__Group_3_1__6__Impl : ( ')' ) ;
    public final void rule__Peripheral__Group_3_1__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3069:1: ( ( ')' ) )
            // InternalMachine.g:3070:1: ( ')' )
            {
            // InternalMachine.g:3070:1: ( ')' )
            // InternalMachine.g:3071:2: ')'
            {
             before(grammarAccess.getPeripheralAccess().getRightParenthesisKeyword_3_1_6()); 
            match(input,29,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightParenthesisKeyword_3_1_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__6__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__7"
    // InternalMachine.g:3080:1: rule__Peripheral__Group_3_1__7 : rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8 ;
    public final void rule__Peripheral__Group_3_1__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3084:1: ( rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8 )
            // InternalMachine.g:3085:2: rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8
            {
            pushFollow(FOLLOW_27);
            rule__Peripheral__Group_3_1__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__7"


    // $ANTLR start "rule__Peripheral__Group_3_1__7__Impl"
    // InternalMachine.g:3092:1: rule__Peripheral__Group_3_1__7__Impl : ( ( rule__Peripheral__Group_3_1_7__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3096:1: ( ( ( rule__Peripheral__Group_3_1_7__0 )? ) )
            // InternalMachine.g:3097:1: ( ( rule__Peripheral__Group_3_1_7__0 )? )
            {
            // InternalMachine.g:3097:1: ( ( rule__Peripheral__Group_3_1_7__0 )? )
            // InternalMachine.g:3098:2: ( rule__Peripheral__Group_3_1_7__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_7()); 
            // InternalMachine.g:3099:2: ( rule__Peripheral__Group_3_1_7__0 )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==34) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalMachine.g:3099:3: rule__Peripheral__Group_3_1_7__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_7__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__7__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__8"
    // InternalMachine.g:3107:1: rule__Peripheral__Group_3_1__8 : rule__Peripheral__Group_3_1__8__Impl ;
    public final void rule__Peripheral__Group_3_1__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3111:1: ( rule__Peripheral__Group_3_1__8__Impl )
            // InternalMachine.g:3112:2: rule__Peripheral__Group_3_1__8__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__8__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__8"


    // $ANTLR start "rule__Peripheral__Group_3_1__8__Impl"
    // InternalMachine.g:3118:1: rule__Peripheral__Group_3_1__8__Impl : ( ( rule__Peripheral__Group_3_1_8__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3122:1: ( ( ( rule__Peripheral__Group_3_1_8__0 )? ) )
            // InternalMachine.g:3123:1: ( ( rule__Peripheral__Group_3_1_8__0 )? )
            {
            // InternalMachine.g:3123:1: ( ( rule__Peripheral__Group_3_1_8__0 )? )
            // InternalMachine.g:3124:2: ( rule__Peripheral__Group_3_1_8__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_8()); 
            // InternalMachine.g:3125:2: ( rule__Peripheral__Group_3_1_8__0 )?
            int alt32=2;
            int LA32_0 = input.LA(1);

            if ( (LA32_0==35) ) {
                alt32=1;
            }
            switch (alt32) {
                case 1 :
                    // InternalMachine.g:3125:3: rule__Peripheral__Group_3_1_8__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_8__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__8__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__0"
    // InternalMachine.g:3134:1: rule__Peripheral__Group_3_1_0__0 : rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1 ;
    public final void rule__Peripheral__Group_3_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3138:1: ( rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1 )
            // InternalMachine.g:3139:2: rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__0__Impl"
    // InternalMachine.g:3146:1: rule__Peripheral__Group_3_1_0__0__Impl : ( 'AxisPositions' ) ;
    public final void rule__Peripheral__Group_3_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3150:1: ( ( 'AxisPositions' ) )
            // InternalMachine.g:3151:1: ( 'AxisPositions' )
            {
            // InternalMachine.g:3151:1: ( 'AxisPositions' )
            // InternalMachine.g:3152:2: 'AxisPositions'
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0()); 
            match(input,32,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__1"
    // InternalMachine.g:3161:1: rule__Peripheral__Group_3_1_0__1 : rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2 ;
    public final void rule__Peripheral__Group_3_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3165:1: ( rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2 )
            // InternalMachine.g:3166:2: rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__1__Impl"
    // InternalMachine.g:3173:1: rule__Peripheral__Group_3_1_0__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3177:1: ( ( '{' ) )
            // InternalMachine.g:3178:1: ( '{' )
            {
            // InternalMachine.g:3178:1: ( '{' )
            // InternalMachine.g:3179:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__2"
    // InternalMachine.g:3188:1: rule__Peripheral__Group_3_1_0__2 : rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3 ;
    public final void rule__Peripheral__Group_3_1_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3192:1: ( rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3 )
            // InternalMachine.g:3193:2: rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_0__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__2__Impl"
    // InternalMachine.g:3200:1: rule__Peripheral__Group_3_1_0__2__Impl : ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3204:1: ( ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* ) )
            // InternalMachine.g:3205:1: ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* )
            {
            // InternalMachine.g:3205:1: ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* )
            // InternalMachine.g:3206:2: ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsAssignment_3_1_0_2()); 
            // InternalMachine.g:3207:2: ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )*
            loop33:
            do {
                int alt33=2;
                int LA33_0 = input.LA(1);

                if ( (LA33_0==RULE_ID) ) {
                    alt33=1;
                }


                switch (alt33) {
            	case 1 :
            	    // InternalMachine.g:3207:3: rule__Peripheral__AxisPositionsAssignment_3_1_0_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__AxisPositionsAssignment_3_1_0_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop33;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getAxisPositionsAssignment_3_1_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__3"
    // InternalMachine.g:3215:1: rule__Peripheral__Group_3_1_0__3 : rule__Peripheral__Group_3_1_0__3__Impl ;
    public final void rule__Peripheral__Group_3_1_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3219:1: ( rule__Peripheral__Group_3_1_0__3__Impl )
            // InternalMachine.g:3220:2: rule__Peripheral__Group_3_1_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__3__Impl"
    // InternalMachine.g:3226:1: rule__Peripheral__Group_3_1_0__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3230:1: ( ( '}' ) )
            // InternalMachine.g:3231:1: ( '}' )
            {
            // InternalMachine.g:3231:1: ( '}' )
            // InternalMachine.g:3232:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__0"
    // InternalMachine.g:3242:1: rule__Peripheral__Group_3_1_1__0 : rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1 ;
    public final void rule__Peripheral__Group_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3246:1: ( rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1 )
            // InternalMachine.g:3247:2: rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__0__Impl"
    // InternalMachine.g:3254:1: rule__Peripheral__Group_3_1_1__0__Impl : ( 'SymbolicPositions' ) ;
    public final void rule__Peripheral__Group_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3258:1: ( ( 'SymbolicPositions' ) )
            // InternalMachine.g:3259:1: ( 'SymbolicPositions' )
            {
            // InternalMachine.g:3259:1: ( 'SymbolicPositions' )
            // InternalMachine.g:3260:2: 'SymbolicPositions'
            {
             before(grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0()); 
            match(input,33,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__1"
    // InternalMachine.g:3269:1: rule__Peripheral__Group_3_1_1__1 : rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2 ;
    public final void rule__Peripheral__Group_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3273:1: ( rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2 )
            // InternalMachine.g:3274:2: rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__1__Impl"
    // InternalMachine.g:3281:1: rule__Peripheral__Group_3_1_1__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3285:1: ( ( '{' ) )
            // InternalMachine.g:3286:1: ( '{' )
            {
            // InternalMachine.g:3286:1: ( '{' )
            // InternalMachine.g:3287:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__2"
    // InternalMachine.g:3296:1: rule__Peripheral__Group_3_1_1__2 : rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3 ;
    public final void rule__Peripheral__Group_3_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3300:1: ( rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3 )
            // InternalMachine.g:3301:2: rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_1__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__2__Impl"
    // InternalMachine.g:3308:1: rule__Peripheral__Group_3_1_1__2__Impl : ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3312:1: ( ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* ) )
            // InternalMachine.g:3313:1: ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* )
            {
            // InternalMachine.g:3313:1: ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* )
            // InternalMachine.g:3314:2: ( rule__Peripheral__PositionsAssignment_3_1_1_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getPositionsAssignment_3_1_1_2()); 
            // InternalMachine.g:3315:2: ( rule__Peripheral__PositionsAssignment_3_1_1_2 )*
            loop34:
            do {
                int alt34=2;
                int LA34_0 = input.LA(1);

                if ( (LA34_0==RULE_ID) ) {
                    alt34=1;
                }


                switch (alt34) {
            	case 1 :
            	    // InternalMachine.g:3315:3: rule__Peripheral__PositionsAssignment_3_1_1_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__PositionsAssignment_3_1_1_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop34;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getPositionsAssignment_3_1_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__3"
    // InternalMachine.g:3323:1: rule__Peripheral__Group_3_1_1__3 : rule__Peripheral__Group_3_1_1__3__Impl ;
    public final void rule__Peripheral__Group_3_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3327:1: ( rule__Peripheral__Group_3_1_1__3__Impl )
            // InternalMachine.g:3328:2: rule__Peripheral__Group_3_1_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__3__Impl"
    // InternalMachine.g:3334:1: rule__Peripheral__Group_3_1_1__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3338:1: ( ( '}' ) )
            // InternalMachine.g:3339:1: ( '}' )
            {
            // InternalMachine.g:3339:1: ( '}' )
            // InternalMachine.g:3340:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__0"
    // InternalMachine.g:3350:1: rule__Peripheral__Group_3_1_5__0 : rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1 ;
    public final void rule__Peripheral__Group_3_1_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3354:1: ( rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1 )
            // InternalMachine.g:3355:2: rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group_3_1_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__0__Impl"
    // InternalMachine.g:3362:1: rule__Peripheral__Group_3_1_5__0__Impl : ( ',' ) ;
    public final void rule__Peripheral__Group_3_1_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3366:1: ( ( ',' ) )
            // InternalMachine.g:3367:1: ( ',' )
            {
            // InternalMachine.g:3367:1: ( ',' )
            // InternalMachine.g:3368:2: ','
            {
             before(grammarAccess.getPeripheralAccess().getCommaKeyword_3_1_5_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getCommaKeyword_3_1_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__1"
    // InternalMachine.g:3377:1: rule__Peripheral__Group_3_1_5__1 : rule__Peripheral__Group_3_1_5__1__Impl ;
    public final void rule__Peripheral__Group_3_1_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3381:1: ( rule__Peripheral__Group_3_1_5__1__Impl )
            // InternalMachine.g:3382:2: rule__Peripheral__Group_3_1_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__1__Impl"
    // InternalMachine.g:3388:1: rule__Peripheral__Group_3_1_5__1__Impl : ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) ) ;
    public final void rule__Peripheral__Group_3_1_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3392:1: ( ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) ) )
            // InternalMachine.g:3393:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) )
            {
            // InternalMachine.g:3393:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) )
            // InternalMachine.g:3394:2: ( rule__Peripheral__ProfilesAssignment_3_1_5_1 )
            {
             before(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_5_1()); 
            // InternalMachine.g:3395:2: ( rule__Peripheral__ProfilesAssignment_3_1_5_1 )
            // InternalMachine.g:3395:3: rule__Peripheral__ProfilesAssignment_3_1_5_1
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__ProfilesAssignment_3_1_5_1();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__0"
    // InternalMachine.g:3404:1: rule__Peripheral__Group_3_1_7__0 : rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1 ;
    public final void rule__Peripheral__Group_3_1_7__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3408:1: ( rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1 )
            // InternalMachine.g:3409:2: rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_7__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__0__Impl"
    // InternalMachine.g:3416:1: rule__Peripheral__Group_3_1_7__0__Impl : ( 'Distances' ) ;
    public final void rule__Peripheral__Group_3_1_7__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3420:1: ( ( 'Distances' ) )
            // InternalMachine.g:3421:1: ( 'Distances' )
            {
            // InternalMachine.g:3421:1: ( 'Distances' )
            // InternalMachine.g:3422:2: 'Distances'
            {
             before(grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0()); 
            match(input,34,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__1"
    // InternalMachine.g:3431:1: rule__Peripheral__Group_3_1_7__1 : rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2 ;
    public final void rule__Peripheral__Group_3_1_7__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3435:1: ( rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2 )
            // InternalMachine.g:3436:2: rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_7__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__1__Impl"
    // InternalMachine.g:3443:1: rule__Peripheral__Group_3_1_7__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_7__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3447:1: ( ( '{' ) )
            // InternalMachine.g:3448:1: ( '{' )
            {
            // InternalMachine.g:3448:1: ( '{' )
            // InternalMachine.g:3449:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__2"
    // InternalMachine.g:3458:1: rule__Peripheral__Group_3_1_7__2 : rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3 ;
    public final void rule__Peripheral__Group_3_1_7__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3462:1: ( rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3 )
            // InternalMachine.g:3463:2: rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_7__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__2__Impl"
    // InternalMachine.g:3470:1: rule__Peripheral__Group_3_1_7__2__Impl : ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_7__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3474:1: ( ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* ) )
            // InternalMachine.g:3475:1: ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* )
            {
            // InternalMachine.g:3475:1: ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* )
            // InternalMachine.g:3476:2: ( rule__Peripheral__DistancesAssignment_3_1_7_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getDistancesAssignment_3_1_7_2()); 
            // InternalMachine.g:3477:2: ( rule__Peripheral__DistancesAssignment_3_1_7_2 )*
            loop35:
            do {
                int alt35=2;
                int LA35_0 = input.LA(1);

                if ( (LA35_0==RULE_ID) ) {
                    alt35=1;
                }


                switch (alt35) {
            	case 1 :
            	    // InternalMachine.g:3477:3: rule__Peripheral__DistancesAssignment_3_1_7_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__DistancesAssignment_3_1_7_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getDistancesAssignment_3_1_7_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__3"
    // InternalMachine.g:3485:1: rule__Peripheral__Group_3_1_7__3 : rule__Peripheral__Group_3_1_7__3__Impl ;
    public final void rule__Peripheral__Group_3_1_7__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3489:1: ( rule__Peripheral__Group_3_1_7__3__Impl )
            // InternalMachine.g:3490:2: rule__Peripheral__Group_3_1_7__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__3__Impl"
    // InternalMachine.g:3496:1: rule__Peripheral__Group_3_1_7__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_7__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3500:1: ( ( '}' ) )
            // InternalMachine.g:3501:1: ( '}' )
            {
            // InternalMachine.g:3501:1: ( '}' )
            // InternalMachine.g:3502:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__0"
    // InternalMachine.g:3512:1: rule__Peripheral__Group_3_1_8__0 : rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1 ;
    public final void rule__Peripheral__Group_3_1_8__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3516:1: ( rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1 )
            // InternalMachine.g:3517:2: rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_8__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__0__Impl"
    // InternalMachine.g:3524:1: rule__Peripheral__Group_3_1_8__0__Impl : ( 'Paths' ) ;
    public final void rule__Peripheral__Group_3_1_8__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3528:1: ( ( 'Paths' ) )
            // InternalMachine.g:3529:1: ( 'Paths' )
            {
            // InternalMachine.g:3529:1: ( 'Paths' )
            // InternalMachine.g:3530:2: 'Paths'
            {
             before(grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0()); 
            match(input,35,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__1"
    // InternalMachine.g:3539:1: rule__Peripheral__Group_3_1_8__1 : rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2 ;
    public final void rule__Peripheral__Group_3_1_8__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3543:1: ( rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2 )
            // InternalMachine.g:3544:2: rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2
            {
            pushFollow(FOLLOW_28);
            rule__Peripheral__Group_3_1_8__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__1__Impl"
    // InternalMachine.g:3551:1: rule__Peripheral__Group_3_1_8__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_8__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3555:1: ( ( '{' ) )
            // InternalMachine.g:3556:1: ( '{' )
            {
            // InternalMachine.g:3556:1: ( '{' )
            // InternalMachine.g:3557:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__2"
    // InternalMachine.g:3566:1: rule__Peripheral__Group_3_1_8__2 : rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3 ;
    public final void rule__Peripheral__Group_3_1_8__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3570:1: ( rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3 )
            // InternalMachine.g:3571:2: rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3
            {
            pushFollow(FOLLOW_28);
            rule__Peripheral__Group_3_1_8__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__2__Impl"
    // InternalMachine.g:3578:1: rule__Peripheral__Group_3_1_8__2__Impl : ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_8__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3582:1: ( ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* ) )
            // InternalMachine.g:3583:1: ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* )
            {
            // InternalMachine.g:3583:1: ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* )
            // InternalMachine.g:3584:2: ( rule__Peripheral__PathsAssignment_3_1_8_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getPathsAssignment_3_1_8_2()); 
            // InternalMachine.g:3585:2: ( rule__Peripheral__PathsAssignment_3_1_8_2 )*
            loop36:
            do {
                int alt36=2;
                int LA36_0 = input.LA(1);

                if ( (LA36_0==RULE_ID||LA36_0==42) ) {
                    alt36=1;
                }


                switch (alt36) {
            	case 1 :
            	    // InternalMachine.g:3585:3: rule__Peripheral__PathsAssignment_3_1_8_2
            	    {
            	    pushFollow(FOLLOW_29);
            	    rule__Peripheral__PathsAssignment_3_1_8_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop36;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getPathsAssignment_3_1_8_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__3"
    // InternalMachine.g:3593:1: rule__Peripheral__Group_3_1_8__3 : rule__Peripheral__Group_3_1_8__3__Impl ;
    public final void rule__Peripheral__Group_3_1_8__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3597:1: ( rule__Peripheral__Group_3_1_8__3__Impl )
            // InternalMachine.g:3598:2: rule__Peripheral__Group_3_1_8__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__3__Impl"
    // InternalMachine.g:3604:1: rule__Peripheral__Group_3_1_8__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_8__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3608:1: ( ( '}' ) )
            // InternalMachine.g:3609:1: ( '}' )
            {
            // InternalMachine.g:3609:1: ( '}' )
            // InternalMachine.g:3610:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__3__Impl"


    // $ANTLR start "rule__Distance__Group__0"
    // InternalMachine.g:3620:1: rule__Distance__Group__0 : rule__Distance__Group__0__Impl rule__Distance__Group__1 ;
    public final void rule__Distance__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3624:1: ( rule__Distance__Group__0__Impl rule__Distance__Group__1 )
            // InternalMachine.g:3625:2: rule__Distance__Group__0__Impl rule__Distance__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__0"


    // $ANTLR start "rule__Distance__Group__0__Impl"
    // InternalMachine.g:3632:1: rule__Distance__Group__0__Impl : ( () ) ;
    public final void rule__Distance__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3636:1: ( ( () ) )
            // InternalMachine.g:3637:1: ( () )
            {
            // InternalMachine.g:3637:1: ( () )
            // InternalMachine.g:3638:2: ()
            {
             before(grammarAccess.getDistanceAccess().getDistanceAction_0()); 
            // InternalMachine.g:3639:2: ()
            // InternalMachine.g:3639:3: 
            {
            }

             after(grammarAccess.getDistanceAccess().getDistanceAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__0__Impl"


    // $ANTLR start "rule__Distance__Group__1"
    // InternalMachine.g:3647:1: rule__Distance__Group__1 : rule__Distance__Group__1__Impl rule__Distance__Group__2 ;
    public final void rule__Distance__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3651:1: ( rule__Distance__Group__1__Impl rule__Distance__Group__2 )
            // InternalMachine.g:3652:2: rule__Distance__Group__1__Impl rule__Distance__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__Distance__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__1"


    // $ANTLR start "rule__Distance__Group__1__Impl"
    // InternalMachine.g:3659:1: rule__Distance__Group__1__Impl : ( ( rule__Distance__NameAssignment_1 ) ) ;
    public final void rule__Distance__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3663:1: ( ( ( rule__Distance__NameAssignment_1 ) ) )
            // InternalMachine.g:3664:1: ( ( rule__Distance__NameAssignment_1 ) )
            {
            // InternalMachine.g:3664:1: ( ( rule__Distance__NameAssignment_1 ) )
            // InternalMachine.g:3665:2: ( rule__Distance__NameAssignment_1 )
            {
             before(grammarAccess.getDistanceAccess().getNameAssignment_1()); 
            // InternalMachine.g:3666:2: ( rule__Distance__NameAssignment_1 )
            // InternalMachine.g:3666:3: rule__Distance__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__1__Impl"


    // $ANTLR start "rule__Distance__Group__2"
    // InternalMachine.g:3674:1: rule__Distance__Group__2 : rule__Distance__Group__2__Impl ;
    public final void rule__Distance__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3678:1: ( rule__Distance__Group__2__Impl )
            // InternalMachine.g:3679:2: rule__Distance__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__2"


    // $ANTLR start "rule__Distance__Group__2__Impl"
    // InternalMachine.g:3685:1: rule__Distance__Group__2__Impl : ( ( rule__Distance__Group_2__0 )? ) ;
    public final void rule__Distance__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3689:1: ( ( ( rule__Distance__Group_2__0 )? ) )
            // InternalMachine.g:3690:1: ( ( rule__Distance__Group_2__0 )? )
            {
            // InternalMachine.g:3690:1: ( ( rule__Distance__Group_2__0 )? )
            // InternalMachine.g:3691:2: ( rule__Distance__Group_2__0 )?
            {
             before(grammarAccess.getDistanceAccess().getGroup_2()); 
            // InternalMachine.g:3692:2: ( rule__Distance__Group_2__0 )?
            int alt37=2;
            int LA37_0 = input.LA(1);

            if ( (LA37_0==24) ) {
                alt37=1;
            }
            switch (alt37) {
                case 1 :
                    // InternalMachine.g:3692:3: rule__Distance__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Distance__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getDistanceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__2__Impl"


    // $ANTLR start "rule__Distance__Group_2__0"
    // InternalMachine.g:3701:1: rule__Distance__Group_2__0 : rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1 ;
    public final void rule__Distance__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3705:1: ( rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1 )
            // InternalMachine.g:3706:2: rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__0"


    // $ANTLR start "rule__Distance__Group_2__0__Impl"
    // InternalMachine.g:3713:1: rule__Distance__Group_2__0__Impl : ( '[' ) ;
    public final void rule__Distance__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3717:1: ( ( '[' ) )
            // InternalMachine.g:3718:1: ( '[' )
            {
            // InternalMachine.g:3718:1: ( '[' )
            // InternalMachine.g:3719:2: '['
            {
             before(grammarAccess.getDistanceAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__0__Impl"


    // $ANTLR start "rule__Distance__Group_2__1"
    // InternalMachine.g:3728:1: rule__Distance__Group_2__1 : rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2 ;
    public final void rule__Distance__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3732:1: ( rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2 )
            // InternalMachine.g:3733:2: rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2
            {
            pushFollow(FOLLOW_30);
            rule__Distance__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__1"


    // $ANTLR start "rule__Distance__Group_2__1__Impl"
    // InternalMachine.g:3740:1: rule__Distance__Group_2__1__Impl : ( ( rule__Distance__SettlingAssignment_2_1 ) ) ;
    public final void rule__Distance__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3744:1: ( ( ( rule__Distance__SettlingAssignment_2_1 ) ) )
            // InternalMachine.g:3745:1: ( ( rule__Distance__SettlingAssignment_2_1 ) )
            {
            // InternalMachine.g:3745:1: ( ( rule__Distance__SettlingAssignment_2_1 ) )
            // InternalMachine.g:3746:2: ( rule__Distance__SettlingAssignment_2_1 )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAssignment_2_1()); 
            // InternalMachine.g:3747:2: ( rule__Distance__SettlingAssignment_2_1 )
            // InternalMachine.g:3747:3: rule__Distance__SettlingAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__SettlingAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getSettlingAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__1__Impl"


    // $ANTLR start "rule__Distance__Group_2__2"
    // InternalMachine.g:3755:1: rule__Distance__Group_2__2 : rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3 ;
    public final void rule__Distance__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3759:1: ( rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3 )
            // InternalMachine.g:3760:2: rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3
            {
            pushFollow(FOLLOW_30);
            rule__Distance__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__2"


    // $ANTLR start "rule__Distance__Group_2__2__Impl"
    // InternalMachine.g:3767:1: rule__Distance__Group_2__2__Impl : ( ( rule__Distance__Group_2_2__0 )* ) ;
    public final void rule__Distance__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3771:1: ( ( ( rule__Distance__Group_2_2__0 )* ) )
            // InternalMachine.g:3772:1: ( ( rule__Distance__Group_2_2__0 )* )
            {
            // InternalMachine.g:3772:1: ( ( rule__Distance__Group_2_2__0 )* )
            // InternalMachine.g:3773:2: ( rule__Distance__Group_2_2__0 )*
            {
             before(grammarAccess.getDistanceAccess().getGroup_2_2()); 
            // InternalMachine.g:3774:2: ( rule__Distance__Group_2_2__0 )*
            loop38:
            do {
                int alt38=2;
                int LA38_0 = input.LA(1);

                if ( (LA38_0==27) ) {
                    alt38=1;
                }


                switch (alt38) {
            	case 1 :
            	    // InternalMachine.g:3774:3: rule__Distance__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Distance__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop38;
                }
            } while (true);

             after(grammarAccess.getDistanceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__2__Impl"


    // $ANTLR start "rule__Distance__Group_2__3"
    // InternalMachine.g:3782:1: rule__Distance__Group_2__3 : rule__Distance__Group_2__3__Impl ;
    public final void rule__Distance__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3786:1: ( rule__Distance__Group_2__3__Impl )
            // InternalMachine.g:3787:2: rule__Distance__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__3"


    // $ANTLR start "rule__Distance__Group_2__3__Impl"
    // InternalMachine.g:3793:1: rule__Distance__Group_2__3__Impl : ( ']' ) ;
    public final void rule__Distance__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3797:1: ( ( ']' ) )
            // InternalMachine.g:3798:1: ( ']' )
            {
            // InternalMachine.g:3798:1: ( ']' )
            // InternalMachine.g:3799:2: ']'
            {
             before(grammarAccess.getDistanceAccess().getRightSquareBracketKeyword_2_3()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getRightSquareBracketKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__3__Impl"


    // $ANTLR start "rule__Distance__Group_2_2__0"
    // InternalMachine.g:3809:1: rule__Distance__Group_2_2__0 : rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1 ;
    public final void rule__Distance__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3813:1: ( rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1 )
            // InternalMachine.g:3814:2: rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__0"


    // $ANTLR start "rule__Distance__Group_2_2__0__Impl"
    // InternalMachine.g:3821:1: rule__Distance__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__Distance__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3825:1: ( ( ',' ) )
            // InternalMachine.g:3826:1: ( ',' )
            {
            // InternalMachine.g:3826:1: ( ',' )
            // InternalMachine.g:3827:2: ','
            {
             before(grammarAccess.getDistanceAccess().getCommaKeyword_2_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__0__Impl"


    // $ANTLR start "rule__Distance__Group_2_2__1"
    // InternalMachine.g:3836:1: rule__Distance__Group_2_2__1 : rule__Distance__Group_2_2__1__Impl ;
    public final void rule__Distance__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3840:1: ( rule__Distance__Group_2_2__1__Impl )
            // InternalMachine.g:3841:2: rule__Distance__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__1"


    // $ANTLR start "rule__Distance__Group_2_2__1__Impl"
    // InternalMachine.g:3847:1: rule__Distance__Group_2_2__1__Impl : ( ( rule__Distance__SettlingAssignment_2_2_1 ) ) ;
    public final void rule__Distance__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3851:1: ( ( ( rule__Distance__SettlingAssignment_2_2_1 ) ) )
            // InternalMachine.g:3852:1: ( ( rule__Distance__SettlingAssignment_2_2_1 ) )
            {
            // InternalMachine.g:3852:1: ( ( rule__Distance__SettlingAssignment_2_2_1 ) )
            // InternalMachine.g:3853:2: ( rule__Distance__SettlingAssignment_2_2_1 )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAssignment_2_2_1()); 
            // InternalMachine.g:3854:2: ( rule__Distance__SettlingAssignment_2_2_1 )
            // InternalMachine.g:3854:3: rule__Distance__SettlingAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__SettlingAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getSettlingAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__0"
    // InternalMachine.g:3863:1: rule__AxisPositionsMapEntry__Group__0 : rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1 ;
    public final void rule__AxisPositionsMapEntry__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3867:1: ( rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1 )
            // InternalMachine.g:3868:2: rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__0__Impl"
    // InternalMachine.g:3875:1: rule__AxisPositionsMapEntry__Group__0__Impl : ( () ) ;
    public final void rule__AxisPositionsMapEntry__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3879:1: ( ( () ) )
            // InternalMachine.g:3880:1: ( () )
            {
            // InternalMachine.g:3880:1: ( () )
            // InternalMachine.g:3881:2: ()
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getAxisPositionsMapEntryAction_0()); 
            // InternalMachine.g:3882:2: ()
            // InternalMachine.g:3882:3: 
            {
            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getAxisPositionsMapEntryAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__1"
    // InternalMachine.g:3890:1: rule__AxisPositionsMapEntry__Group__1 : rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2 ;
    public final void rule__AxisPositionsMapEntry__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3894:1: ( rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2 )
            // InternalMachine.g:3895:2: rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2
            {
            pushFollow(FOLLOW_26);
            rule__AxisPositionsMapEntry__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__1__Impl"
    // InternalMachine.g:3902:1: rule__AxisPositionsMapEntry__Group__1__Impl : ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3906:1: ( ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) ) )
            // InternalMachine.g:3907:1: ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) )
            {
            // InternalMachine.g:3907:1: ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) )
            // InternalMachine.g:3908:2: ( rule__AxisPositionsMapEntry__KeyAssignment_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAssignment_1()); 
            // InternalMachine.g:3909:2: ( rule__AxisPositionsMapEntry__KeyAssignment_1 )
            // InternalMachine.g:3909:3: rule__AxisPositionsMapEntry__KeyAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__KeyAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__2"
    // InternalMachine.g:3917:1: rule__AxisPositionsMapEntry__Group__2 : rule__AxisPositionsMapEntry__Group__2__Impl ;
    public final void rule__AxisPositionsMapEntry__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3921:1: ( rule__AxisPositionsMapEntry__Group__2__Impl )
            // InternalMachine.g:3922:2: rule__AxisPositionsMapEntry__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__2"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__2__Impl"
    // InternalMachine.g:3928:1: rule__AxisPositionsMapEntry__Group__2__Impl : ( ( rule__AxisPositionsMapEntry__Group_2__0 )? ) ;
    public final void rule__AxisPositionsMapEntry__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3932:1: ( ( ( rule__AxisPositionsMapEntry__Group_2__0 )? ) )
            // InternalMachine.g:3933:1: ( ( rule__AxisPositionsMapEntry__Group_2__0 )? )
            {
            // InternalMachine.g:3933:1: ( ( rule__AxisPositionsMapEntry__Group_2__0 )? )
            // InternalMachine.g:3934:2: ( rule__AxisPositionsMapEntry__Group_2__0 )?
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2()); 
            // InternalMachine.g:3935:2: ( rule__AxisPositionsMapEntry__Group_2__0 )?
            int alt39=2;
            int LA39_0 = input.LA(1);

            if ( (LA39_0==28) ) {
                alt39=1;
            }
            switch (alt39) {
                case 1 :
                    // InternalMachine.g:3935:3: rule__AxisPositionsMapEntry__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__AxisPositionsMapEntry__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__2__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__0"
    // InternalMachine.g:3944:1: rule__AxisPositionsMapEntry__Group_2__0 : rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1 ;
    public final void rule__AxisPositionsMapEntry__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3948:1: ( rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1 )
            // InternalMachine.g:3949:2: rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__0__Impl"
    // InternalMachine.g:3956:1: rule__AxisPositionsMapEntry__Group_2__0__Impl : ( '(' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3960:1: ( ( '(' ) )
            // InternalMachine.g:3961:1: ( '(' )
            {
            // InternalMachine.g:3961:1: ( '(' )
            // InternalMachine.g:3962:2: '('
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,28,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__1"
    // InternalMachine.g:3971:1: rule__AxisPositionsMapEntry__Group_2__1 : rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2 ;
    public final void rule__AxisPositionsMapEntry__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3975:1: ( rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2 )
            // InternalMachine.g:3976:2: rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__AxisPositionsMapEntry__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__1__Impl"
    // InternalMachine.g:3983:1: rule__AxisPositionsMapEntry__Group_2__1__Impl : ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3987:1: ( ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) ) )
            // InternalMachine.g:3988:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) )
            {
            // InternalMachine.g:3988:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) )
            // InternalMachine.g:3989:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_1()); 
            // InternalMachine.g:3990:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 )
            // InternalMachine.g:3990:3: rule__AxisPositionsMapEntry__ValueAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__ValueAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__2"
    // InternalMachine.g:3998:1: rule__AxisPositionsMapEntry__Group_2__2 : rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3 ;
    public final void rule__AxisPositionsMapEntry__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4002:1: ( rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3 )
            // InternalMachine.g:4003:2: rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__AxisPositionsMapEntry__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__2"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__2__Impl"
    // InternalMachine.g:4010:1: rule__AxisPositionsMapEntry__Group_2__2__Impl : ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4014:1: ( ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* ) )
            // InternalMachine.g:4015:1: ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* )
            {
            // InternalMachine.g:4015:1: ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* )
            // InternalMachine.g:4016:2: ( rule__AxisPositionsMapEntry__Group_2_2__0 )*
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2_2()); 
            // InternalMachine.g:4017:2: ( rule__AxisPositionsMapEntry__Group_2_2__0 )*
            loop40:
            do {
                int alt40=2;
                int LA40_0 = input.LA(1);

                if ( (LA40_0==27) ) {
                    alt40=1;
                }


                switch (alt40) {
            	case 1 :
            	    // InternalMachine.g:4017:3: rule__AxisPositionsMapEntry__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__AxisPositionsMapEntry__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop40;
                }
            } while (true);

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__2__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__3"
    // InternalMachine.g:4025:1: rule__AxisPositionsMapEntry__Group_2__3 : rule__AxisPositionsMapEntry__Group_2__3__Impl ;
    public final void rule__AxisPositionsMapEntry__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4029:1: ( rule__AxisPositionsMapEntry__Group_2__3__Impl )
            // InternalMachine.g:4030:2: rule__AxisPositionsMapEntry__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__3"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__3__Impl"
    // InternalMachine.g:4036:1: rule__AxisPositionsMapEntry__Group_2__3__Impl : ( ')' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4040:1: ( ( ')' ) )
            // InternalMachine.g:4041:1: ( ')' )
            {
            // InternalMachine.g:4041:1: ( ')' )
            // InternalMachine.g:4042:2: ')'
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getRightParenthesisKeyword_2_3()); 
            match(input,29,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__3__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__0"
    // InternalMachine.g:4052:1: rule__AxisPositionsMapEntry__Group_2_2__0 : rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1 ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4056:1: ( rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1 )
            // InternalMachine.g:4057:2: rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__0__Impl"
    // InternalMachine.g:4064:1: rule__AxisPositionsMapEntry__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4068:1: ( ( ',' ) )
            // InternalMachine.g:4069:1: ( ',' )
            {
            // InternalMachine.g:4069:1: ( ',' )
            // InternalMachine.g:4070:2: ','
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getCommaKeyword_2_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__1"
    // InternalMachine.g:4079:1: rule__AxisPositionsMapEntry__Group_2_2__1 : rule__AxisPositionsMapEntry__Group_2_2__1__Impl ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4083:1: ( rule__AxisPositionsMapEntry__Group_2_2__1__Impl )
            // InternalMachine.g:4084:2: rule__AxisPositionsMapEntry__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__1__Impl"
    // InternalMachine.g:4090:1: rule__AxisPositionsMapEntry__Group_2_2__1__Impl : ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4094:1: ( ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) ) )
            // InternalMachine.g:4095:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) )
            {
            // InternalMachine.g:4095:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) )
            // InternalMachine.g:4096:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_2_1()); 
            // InternalMachine.g:4097:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 )
            // InternalMachine.g:4097:3: rule__AxisPositionsMapEntry__ValueAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__ValueAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__1__Impl"


    // $ANTLR start "rule__Position__Group__0"
    // InternalMachine.g:4106:1: rule__Position__Group__0 : rule__Position__Group__0__Impl rule__Position__Group__1 ;
    public final void rule__Position__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4110:1: ( rule__Position__Group__0__Impl rule__Position__Group__1 )
            // InternalMachine.g:4111:2: rule__Position__Group__0__Impl rule__Position__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Position__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Position__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__0"


    // $ANTLR start "rule__Position__Group__0__Impl"
    // InternalMachine.g:4118:1: rule__Position__Group__0__Impl : ( () ) ;
    public final void rule__Position__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4122:1: ( ( () ) )
            // InternalMachine.g:4123:1: ( () )
            {
            // InternalMachine.g:4123:1: ( () )
            // InternalMachine.g:4124:2: ()
            {
             before(grammarAccess.getPositionAccess().getPositionAction_0()); 
            // InternalMachine.g:4125:2: ()
            // InternalMachine.g:4125:3: 
            {
            }

             after(grammarAccess.getPositionAccess().getPositionAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__0__Impl"


    // $ANTLR start "rule__Position__Group__1"
    // InternalMachine.g:4133:1: rule__Position__Group__1 : rule__Position__Group__1__Impl ;
    public final void rule__Position__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4137:1: ( rule__Position__Group__1__Impl )
            // InternalMachine.g:4138:2: rule__Position__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Position__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__1"


    // $ANTLR start "rule__Position__Group__1__Impl"
    // InternalMachine.g:4144:1: rule__Position__Group__1__Impl : ( ( rule__Position__NameAssignment_1 ) ) ;
    public final void rule__Position__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4148:1: ( ( ( rule__Position__NameAssignment_1 ) ) )
            // InternalMachine.g:4149:1: ( ( rule__Position__NameAssignment_1 ) )
            {
            // InternalMachine.g:4149:1: ( ( rule__Position__NameAssignment_1 ) )
            // InternalMachine.g:4150:2: ( rule__Position__NameAssignment_1 )
            {
             before(grammarAccess.getPositionAccess().getNameAssignment_1()); 
            // InternalMachine.g:4151:2: ( rule__Position__NameAssignment_1 )
            // InternalMachine.g:4151:3: rule__Position__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Position__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPositionAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__0"
    // InternalMachine.g:4160:1: rule__SymbolicPosition__Group__0 : rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1 ;
    public final void rule__SymbolicPosition__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4164:1: ( rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1 )
            // InternalMachine.g:4165:2: rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__0"


    // $ANTLR start "rule__SymbolicPosition__Group__0__Impl"
    // InternalMachine.g:4172:1: rule__SymbolicPosition__Group__0__Impl : ( () ) ;
    public final void rule__SymbolicPosition__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4176:1: ( ( () ) )
            // InternalMachine.g:4177:1: ( () )
            {
            // InternalMachine.g:4177:1: ( () )
            // InternalMachine.g:4178:2: ()
            {
             before(grammarAccess.getSymbolicPositionAccess().getSymbolicPositionAction_0()); 
            // InternalMachine.g:4179:2: ()
            // InternalMachine.g:4179:3: 
            {
            }

             after(grammarAccess.getSymbolicPositionAccess().getSymbolicPositionAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__1"
    // InternalMachine.g:4187:1: rule__SymbolicPosition__Group__1 : rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2 ;
    public final void rule__SymbolicPosition__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4191:1: ( rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2 )
            // InternalMachine.g:4192:2: rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2
            {
            pushFollow(FOLLOW_26);
            rule__SymbolicPosition__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__1"


    // $ANTLR start "rule__SymbolicPosition__Group__1__Impl"
    // InternalMachine.g:4199:1: rule__SymbolicPosition__Group__1__Impl : ( ( rule__SymbolicPosition__NameAssignment_1 ) ) ;
    public final void rule__SymbolicPosition__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4203:1: ( ( ( rule__SymbolicPosition__NameAssignment_1 ) ) )
            // InternalMachine.g:4204:1: ( ( rule__SymbolicPosition__NameAssignment_1 ) )
            {
            // InternalMachine.g:4204:1: ( ( rule__SymbolicPosition__NameAssignment_1 ) )
            // InternalMachine.g:4205:2: ( rule__SymbolicPosition__NameAssignment_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getNameAssignment_1()); 
            // InternalMachine.g:4206:2: ( rule__SymbolicPosition__NameAssignment_1 )
            // InternalMachine.g:4206:3: rule__SymbolicPosition__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__2"
    // InternalMachine.g:4214:1: rule__SymbolicPosition__Group__2 : rule__SymbolicPosition__Group__2__Impl ;
    public final void rule__SymbolicPosition__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4218:1: ( rule__SymbolicPosition__Group__2__Impl )
            // InternalMachine.g:4219:2: rule__SymbolicPosition__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__2"


    // $ANTLR start "rule__SymbolicPosition__Group__2__Impl"
    // InternalMachine.g:4225:1: rule__SymbolicPosition__Group__2__Impl : ( ( rule__SymbolicPosition__Group_2__0 )? ) ;
    public final void rule__SymbolicPosition__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4229:1: ( ( ( rule__SymbolicPosition__Group_2__0 )? ) )
            // InternalMachine.g:4230:1: ( ( rule__SymbolicPosition__Group_2__0 )? )
            {
            // InternalMachine.g:4230:1: ( ( rule__SymbolicPosition__Group_2__0 )? )
            // InternalMachine.g:4231:2: ( rule__SymbolicPosition__Group_2__0 )?
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup_2()); 
            // InternalMachine.g:4232:2: ( rule__SymbolicPosition__Group_2__0 )?
            int alt41=2;
            int LA41_0 = input.LA(1);

            if ( (LA41_0==28) ) {
                alt41=1;
            }
            switch (alt41) {
                case 1 :
                    // InternalMachine.g:4232:3: rule__SymbolicPosition__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__SymbolicPosition__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getSymbolicPositionAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__2__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__0"
    // InternalMachine.g:4241:1: rule__SymbolicPosition__Group_2__0 : rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1 ;
    public final void rule__SymbolicPosition__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4245:1: ( rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1 )
            // InternalMachine.g:4246:2: rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__0"


    // $ANTLR start "rule__SymbolicPosition__Group_2__0__Impl"
    // InternalMachine.g:4253:1: rule__SymbolicPosition__Group_2__0__Impl : ( '(' ) ;
    public final void rule__SymbolicPosition__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4257:1: ( ( '(' ) )
            // InternalMachine.g:4258:1: ( '(' )
            {
            // InternalMachine.g:4258:1: ( '(' )
            // InternalMachine.g:4259:2: '('
            {
             before(grammarAccess.getSymbolicPositionAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,28,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__1"
    // InternalMachine.g:4268:1: rule__SymbolicPosition__Group_2__1 : rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2 ;
    public final void rule__SymbolicPosition__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4272:1: ( rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2 )
            // InternalMachine.g:4273:2: rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__SymbolicPosition__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__1"


    // $ANTLR start "rule__SymbolicPosition__Group_2__1__Impl"
    // InternalMachine.g:4280:1: rule__SymbolicPosition__Group_2__1__Impl : ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) ) ;
    public final void rule__SymbolicPosition__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4284:1: ( ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) ) )
            // InternalMachine.g:4285:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) )
            {
            // InternalMachine.g:4285:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) )
            // InternalMachine.g:4286:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_1()); 
            // InternalMachine.g:4287:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_1 )
            // InternalMachine.g:4287:3: rule__SymbolicPosition__AxisPositionAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__AxisPositionAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__2"
    // InternalMachine.g:4295:1: rule__SymbolicPosition__Group_2__2 : rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3 ;
    public final void rule__SymbolicPosition__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4299:1: ( rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3 )
            // InternalMachine.g:4300:2: rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__SymbolicPosition__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__2"


    // $ANTLR start "rule__SymbolicPosition__Group_2__2__Impl"
    // InternalMachine.g:4307:1: rule__SymbolicPosition__Group_2__2__Impl : ( ( rule__SymbolicPosition__Group_2_2__0 )* ) ;
    public final void rule__SymbolicPosition__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4311:1: ( ( ( rule__SymbolicPosition__Group_2_2__0 )* ) )
            // InternalMachine.g:4312:1: ( ( rule__SymbolicPosition__Group_2_2__0 )* )
            {
            // InternalMachine.g:4312:1: ( ( rule__SymbolicPosition__Group_2_2__0 )* )
            // InternalMachine.g:4313:2: ( rule__SymbolicPosition__Group_2_2__0 )*
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup_2_2()); 
            // InternalMachine.g:4314:2: ( rule__SymbolicPosition__Group_2_2__0 )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);

                if ( (LA42_0==27) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // InternalMachine.g:4314:3: rule__SymbolicPosition__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__SymbolicPosition__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);

             after(grammarAccess.getSymbolicPositionAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__2__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__3"
    // InternalMachine.g:4322:1: rule__SymbolicPosition__Group_2__3 : rule__SymbolicPosition__Group_2__3__Impl ;
    public final void rule__SymbolicPosition__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4326:1: ( rule__SymbolicPosition__Group_2__3__Impl )
            // InternalMachine.g:4327:2: rule__SymbolicPosition__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__3"


    // $ANTLR start "rule__SymbolicPosition__Group_2__3__Impl"
    // InternalMachine.g:4333:1: rule__SymbolicPosition__Group_2__3__Impl : ( ')' ) ;
    public final void rule__SymbolicPosition__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4337:1: ( ( ')' ) )
            // InternalMachine.g:4338:1: ( ')' )
            {
            // InternalMachine.g:4338:1: ( ')' )
            // InternalMachine.g:4339:2: ')'
            {
             before(grammarAccess.getSymbolicPositionAccess().getRightParenthesisKeyword_2_3()); 
            match(input,29,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__3__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__0"
    // InternalMachine.g:4349:1: rule__SymbolicPosition__Group_2_2__0 : rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1 ;
    public final void rule__SymbolicPosition__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4353:1: ( rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1 )
            // InternalMachine.g:4354:2: rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__0"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__0__Impl"
    // InternalMachine.g:4361:1: rule__SymbolicPosition__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__SymbolicPosition__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4365:1: ( ( ',' ) )
            // InternalMachine.g:4366:1: ( ',' )
            {
            // InternalMachine.g:4366:1: ( ',' )
            // InternalMachine.g:4367:2: ','
            {
             before(grammarAccess.getSymbolicPositionAccess().getCommaKeyword_2_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__1"
    // InternalMachine.g:4376:1: rule__SymbolicPosition__Group_2_2__1 : rule__SymbolicPosition__Group_2_2__1__Impl ;
    public final void rule__SymbolicPosition__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4380:1: ( rule__SymbolicPosition__Group_2_2__1__Impl )
            // InternalMachine.g:4381:2: rule__SymbolicPosition__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__1"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__1__Impl"
    // InternalMachine.g:4387:1: rule__SymbolicPosition__Group_2_2__1__Impl : ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) ) ;
    public final void rule__SymbolicPosition__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4391:1: ( ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) ) )
            // InternalMachine.g:4392:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) )
            {
            // InternalMachine.g:4392:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) )
            // InternalMachine.g:4393:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_2_1()); 
            // InternalMachine.g:4394:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 )
            // InternalMachine.g:4394:3: rule__SymbolicPosition__AxisPositionAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__AxisPositionAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__1__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__0"
    // InternalMachine.g:4403:1: rule__AxisPositionMapEntry__Group__0 : rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1 ;
    public final void rule__AxisPositionMapEntry__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4407:1: ( rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1 )
            // InternalMachine.g:4408:2: rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionMapEntry__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__0"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__0__Impl"
    // InternalMachine.g:4415:1: rule__AxisPositionMapEntry__Group__0__Impl : ( () ) ;
    public final void rule__AxisPositionMapEntry__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4419:1: ( ( () ) )
            // InternalMachine.g:4420:1: ( () )
            {
            // InternalMachine.g:4420:1: ( () )
            // InternalMachine.g:4421:2: ()
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getAxisPositionMapEntryAction_0()); 
            // InternalMachine.g:4422:2: ()
            // InternalMachine.g:4422:3: 
            {
            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getAxisPositionMapEntryAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__0__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__1"
    // InternalMachine.g:4430:1: rule__AxisPositionMapEntry__Group__1 : rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2 ;
    public final void rule__AxisPositionMapEntry__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4434:1: ( rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2 )
            // InternalMachine.g:4435:2: rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2
            {
            pushFollow(FOLLOW_31);
            rule__AxisPositionMapEntry__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__1"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__1__Impl"
    // InternalMachine.g:4442:1: rule__AxisPositionMapEntry__Group__1__Impl : ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) ) ;
    public final void rule__AxisPositionMapEntry__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4446:1: ( ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) ) )
            // InternalMachine.g:4447:1: ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) )
            {
            // InternalMachine.g:4447:1: ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) )
            // InternalMachine.g:4448:2: ( rule__AxisPositionMapEntry__KeyAssignment_1 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAssignment_1()); 
            // InternalMachine.g:4449:2: ( rule__AxisPositionMapEntry__KeyAssignment_1 )
            // InternalMachine.g:4449:3: rule__AxisPositionMapEntry__KeyAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__KeyAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__1__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__2"
    // InternalMachine.g:4457:1: rule__AxisPositionMapEntry__Group__2 : rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3 ;
    public final void rule__AxisPositionMapEntry__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4461:1: ( rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3 )
            // InternalMachine.g:4462:2: rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionMapEntry__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__2"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__2__Impl"
    // InternalMachine.g:4469:1: rule__AxisPositionMapEntry__Group__2__Impl : ( '.' ) ;
    public final void rule__AxisPositionMapEntry__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4473:1: ( ( '.' ) )
            // InternalMachine.g:4474:1: ( '.' )
            {
            // InternalMachine.g:4474:1: ( '.' )
            // InternalMachine.g:4475:2: '.'
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getFullStopKeyword_2()); 
            match(input,36,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getFullStopKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__2__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__3"
    // InternalMachine.g:4484:1: rule__AxisPositionMapEntry__Group__3 : rule__AxisPositionMapEntry__Group__3__Impl ;
    public final void rule__AxisPositionMapEntry__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4488:1: ( rule__AxisPositionMapEntry__Group__3__Impl )
            // InternalMachine.g:4489:2: rule__AxisPositionMapEntry__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__3"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__3__Impl"
    // InternalMachine.g:4495:1: rule__AxisPositionMapEntry__Group__3__Impl : ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) ) ;
    public final void rule__AxisPositionMapEntry__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4499:1: ( ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) ) )
            // InternalMachine.g:4500:1: ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) )
            {
            // InternalMachine.g:4500:1: ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) )
            // InternalMachine.g:4501:2: ( rule__AxisPositionMapEntry__ValueAssignment_3 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValueAssignment_3()); 
            // InternalMachine.g:4502:2: ( rule__AxisPositionMapEntry__ValueAssignment_3 )
            // InternalMachine.g:4502:3: rule__AxisPositionMapEntry__ValueAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__ValueAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getValueAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__3__Impl"


    // $ANTLR start "rule__Profile__Group__0"
    // InternalMachine.g:4511:1: rule__Profile__Group__0 : rule__Profile__Group__0__Impl rule__Profile__Group__1 ;
    public final void rule__Profile__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4515:1: ( rule__Profile__Group__0__Impl rule__Profile__Group__1 )
            // InternalMachine.g:4516:2: rule__Profile__Group__0__Impl rule__Profile__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Profile__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Profile__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__0"


    // $ANTLR start "rule__Profile__Group__0__Impl"
    // InternalMachine.g:4523:1: rule__Profile__Group__0__Impl : ( () ) ;
    public final void rule__Profile__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4527:1: ( ( () ) )
            // InternalMachine.g:4528:1: ( () )
            {
            // InternalMachine.g:4528:1: ( () )
            // InternalMachine.g:4529:2: ()
            {
             before(grammarAccess.getProfileAccess().getProfileAction_0()); 
            // InternalMachine.g:4530:2: ()
            // InternalMachine.g:4530:3: 
            {
            }

             after(grammarAccess.getProfileAccess().getProfileAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__0__Impl"


    // $ANTLR start "rule__Profile__Group__1"
    // InternalMachine.g:4538:1: rule__Profile__Group__1 : rule__Profile__Group__1__Impl ;
    public final void rule__Profile__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4542:1: ( rule__Profile__Group__1__Impl )
            // InternalMachine.g:4543:2: rule__Profile__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Profile__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__1"


    // $ANTLR start "rule__Profile__Group__1__Impl"
    // InternalMachine.g:4549:1: rule__Profile__Group__1__Impl : ( ( rule__Profile__NameAssignment_1 ) ) ;
    public final void rule__Profile__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4553:1: ( ( ( rule__Profile__NameAssignment_1 ) ) )
            // InternalMachine.g:4554:1: ( ( rule__Profile__NameAssignment_1 ) )
            {
            // InternalMachine.g:4554:1: ( ( rule__Profile__NameAssignment_1 ) )
            // InternalMachine.g:4555:2: ( rule__Profile__NameAssignment_1 )
            {
             before(grammarAccess.getProfileAccess().getNameAssignment_1()); 
            // InternalMachine.g:4556:2: ( rule__Profile__NameAssignment_1 )
            // InternalMachine.g:4556:3: rule__Profile__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Profile__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getProfileAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__0"
    // InternalMachine.g:4565:1: rule__UnidirectionalPath__Group__0 : rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1 ;
    public final void rule__UnidirectionalPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4569:1: ( rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1 )
            // InternalMachine.g:4570:2: rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__0"


    // $ANTLR start "rule__UnidirectionalPath__Group__0__Impl"
    // InternalMachine.g:4577:1: rule__UnidirectionalPath__Group__0__Impl : ( () ) ;
    public final void rule__UnidirectionalPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4581:1: ( ( () ) )
            // InternalMachine.g:4582:1: ( () )
            {
            // InternalMachine.g:4582:1: ( () )
            // InternalMachine.g:4583:2: ()
            {
             before(grammarAccess.getUnidirectionalPathAccess().getUnidirectionalPathAction_0()); 
            // InternalMachine.g:4584:2: ()
            // InternalMachine.g:4584:3: 
            {
            }

             after(grammarAccess.getUnidirectionalPathAccess().getUnidirectionalPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__1"
    // InternalMachine.g:4592:1: rule__UnidirectionalPath__Group__1 : rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2 ;
    public final void rule__UnidirectionalPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4596:1: ( rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2 )
            // InternalMachine.g:4597:2: rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2
            {
            pushFollow(FOLLOW_32);
            rule__UnidirectionalPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__1"


    // $ANTLR start "rule__UnidirectionalPath__Group__1__Impl"
    // InternalMachine.g:4604:1: rule__UnidirectionalPath__Group__1__Impl : ( ( rule__UnidirectionalPath__SourceAssignment_1 ) ) ;
    public final void rule__UnidirectionalPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4608:1: ( ( ( rule__UnidirectionalPath__SourceAssignment_1 ) ) )
            // InternalMachine.g:4609:1: ( ( rule__UnidirectionalPath__SourceAssignment_1 ) )
            {
            // InternalMachine.g:4609:1: ( ( rule__UnidirectionalPath__SourceAssignment_1 ) )
            // InternalMachine.g:4610:2: ( rule__UnidirectionalPath__SourceAssignment_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceAssignment_1()); 
            // InternalMachine.g:4611:2: ( rule__UnidirectionalPath__SourceAssignment_1 )
            // InternalMachine.g:4611:3: rule__UnidirectionalPath__SourceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__SourceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getSourceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__2"
    // InternalMachine.g:4619:1: rule__UnidirectionalPath__Group__2 : rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3 ;
    public final void rule__UnidirectionalPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4623:1: ( rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3 )
            // InternalMachine.g:4624:2: rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__2"


    // $ANTLR start "rule__UnidirectionalPath__Group__2__Impl"
    // InternalMachine.g:4631:1: rule__UnidirectionalPath__Group__2__Impl : ( '-->' ) ;
    public final void rule__UnidirectionalPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4635:1: ( ( '-->' ) )
            // InternalMachine.g:4636:1: ( '-->' )
            {
            // InternalMachine.g:4636:1: ( '-->' )
            // InternalMachine.g:4637:2: '-->'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getHyphenMinusHyphenMinusGreaterThanSignKeyword_2()); 
            match(input,37,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getHyphenMinusHyphenMinusGreaterThanSignKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__2__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__3"
    // InternalMachine.g:4646:1: rule__UnidirectionalPath__Group__3 : rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4 ;
    public final void rule__UnidirectionalPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4650:1: ( rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4 )
            // InternalMachine.g:4651:2: rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4
            {
            pushFollow(FOLLOW_33);
            rule__UnidirectionalPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__3"


    // $ANTLR start "rule__UnidirectionalPath__Group__3__Impl"
    // InternalMachine.g:4658:1: rule__UnidirectionalPath__Group__3__Impl : ( ( rule__UnidirectionalPath__TargetAssignment_3 ) ) ;
    public final void rule__UnidirectionalPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4662:1: ( ( ( rule__UnidirectionalPath__TargetAssignment_3 ) ) )
            // InternalMachine.g:4663:1: ( ( rule__UnidirectionalPath__TargetAssignment_3 ) )
            {
            // InternalMachine.g:4663:1: ( ( rule__UnidirectionalPath__TargetAssignment_3 ) )
            // InternalMachine.g:4664:2: ( rule__UnidirectionalPath__TargetAssignment_3 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getTargetAssignment_3()); 
            // InternalMachine.g:4665:2: ( rule__UnidirectionalPath__TargetAssignment_3 )
            // InternalMachine.g:4665:3: rule__UnidirectionalPath__TargetAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__TargetAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getTargetAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__3__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__4"
    // InternalMachine.g:4673:1: rule__UnidirectionalPath__Group__4 : rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5 ;
    public final void rule__UnidirectionalPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4677:1: ( rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5 )
            // InternalMachine.g:4678:2: rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5
            {
            pushFollow(FOLLOW_34);
            rule__UnidirectionalPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__4"


    // $ANTLR start "rule__UnidirectionalPath__Group__4__Impl"
    // InternalMachine.g:4685:1: rule__UnidirectionalPath__Group__4__Impl : ( ( rule__UnidirectionalPath__Alternatives_4 ) ) ;
    public final void rule__UnidirectionalPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4689:1: ( ( ( rule__UnidirectionalPath__Alternatives_4 ) ) )
            // InternalMachine.g:4690:1: ( ( rule__UnidirectionalPath__Alternatives_4 ) )
            {
            // InternalMachine.g:4690:1: ( ( rule__UnidirectionalPath__Alternatives_4 ) )
            // InternalMachine.g:4691:2: ( rule__UnidirectionalPath__Alternatives_4 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAlternatives_4()); 
            // InternalMachine.g:4692:2: ( rule__UnidirectionalPath__Alternatives_4 )
            // InternalMachine.g:4692:3: rule__UnidirectionalPath__Alternatives_4
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Alternatives_4();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__4__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__5"
    // InternalMachine.g:4700:1: rule__UnidirectionalPath__Group__5 : rule__UnidirectionalPath__Group__5__Impl ;
    public final void rule__UnidirectionalPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4704:1: ( rule__UnidirectionalPath__Group__5__Impl )
            // InternalMachine.g:4705:2: rule__UnidirectionalPath__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__5"


    // $ANTLR start "rule__UnidirectionalPath__Group__5__Impl"
    // InternalMachine.g:4711:1: rule__UnidirectionalPath__Group__5__Impl : ( ( rule__UnidirectionalPath__Group_5__0 )* ) ;
    public final void rule__UnidirectionalPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4715:1: ( ( ( rule__UnidirectionalPath__Group_5__0 )* ) )
            // InternalMachine.g:4716:1: ( ( rule__UnidirectionalPath__Group_5__0 )* )
            {
            // InternalMachine.g:4716:1: ( ( rule__UnidirectionalPath__Group_5__0 )* )
            // InternalMachine.g:4717:2: ( rule__UnidirectionalPath__Group_5__0 )*
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup_5()); 
            // InternalMachine.g:4718:2: ( rule__UnidirectionalPath__Group_5__0 )*
            loop43:
            do {
                int alt43=2;
                int LA43_0 = input.LA(1);

                if ( (LA43_0==40) ) {
                    alt43=1;
                }


                switch (alt43) {
            	case 1 :
            	    // InternalMachine.g:4718:3: rule__UnidirectionalPath__Group_5__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__UnidirectionalPath__Group_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop43;
                }
            } while (true);

             after(grammarAccess.getUnidirectionalPathAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__5__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__0"
    // InternalMachine.g:4727:1: rule__UnidirectionalPath__Group_4_0__0 : rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1 ;
    public final void rule__UnidirectionalPath__Group_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4731:1: ( rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1 )
            // InternalMachine.g:4732:2: rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__0__Impl"
    // InternalMachine.g:4739:1: rule__UnidirectionalPath__Group_4_0__0__Impl : ( 'profiles' ) ;
    public final void rule__UnidirectionalPath__Group_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4743:1: ( ( 'profiles' ) )
            // InternalMachine.g:4744:1: ( 'profiles' )
            {
            // InternalMachine.g:4744:1: ( 'profiles' )
            // InternalMachine.g:4745:2: 'profiles'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesKeyword_4_0_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesKeyword_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__1"
    // InternalMachine.g:4754:1: rule__UnidirectionalPath__Group_4_0__1 : rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2 ;
    public final void rule__UnidirectionalPath__Group_4_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4758:1: ( rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2 )
            // InternalMachine.g:4759:2: rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2
            {
            pushFollow(FOLLOW_18);
            rule__UnidirectionalPath__Group_4_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__1__Impl"
    // InternalMachine.g:4766:1: rule__UnidirectionalPath__Group_4_0__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4770:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) ) )
            // InternalMachine.g:4771:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) )
            {
            // InternalMachine.g:4771:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) )
            // InternalMachine.g:4772:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_1()); 
            // InternalMachine.g:4773:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 )
            // InternalMachine.g:4773:3: rule__UnidirectionalPath__ProfilesAssignment_4_0_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_0_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__2"
    // InternalMachine.g:4781:1: rule__UnidirectionalPath__Group_4_0__2 : rule__UnidirectionalPath__Group_4_0__2__Impl ;
    public final void rule__UnidirectionalPath__Group_4_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4785:1: ( rule__UnidirectionalPath__Group_4_0__2__Impl )
            // InternalMachine.g:4786:2: rule__UnidirectionalPath__Group_4_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__2"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__2__Impl"
    // InternalMachine.g:4792:1: rule__UnidirectionalPath__Group_4_0__2__Impl : ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* ) ;
    public final void rule__UnidirectionalPath__Group_4_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4796:1: ( ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* ) )
            // InternalMachine.g:4797:1: ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* )
            {
            // InternalMachine.g:4797:1: ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* )
            // InternalMachine.g:4798:2: ( rule__UnidirectionalPath__Group_4_0_2__0 )*
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0_2()); 
            // InternalMachine.g:4799:2: ( rule__UnidirectionalPath__Group_4_0_2__0 )*
            loop44:
            do {
                int alt44=2;
                int LA44_0 = input.LA(1);

                if ( (LA44_0==27) ) {
                    alt44=1;
                }


                switch (alt44) {
            	case 1 :
            	    // InternalMachine.g:4799:3: rule__UnidirectionalPath__Group_4_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__UnidirectionalPath__Group_4_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop44;
                }
            } while (true);

             after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__2__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__0"
    // InternalMachine.g:4808:1: rule__UnidirectionalPath__Group_4_0_2__0 : rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1 ;
    public final void rule__UnidirectionalPath__Group_4_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4812:1: ( rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1 )
            // InternalMachine.g:4813:2: rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__0__Impl"
    // InternalMachine.g:4820:1: rule__UnidirectionalPath__Group_4_0_2__0__Impl : ( ',' ) ;
    public final void rule__UnidirectionalPath__Group_4_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4824:1: ( ( ',' ) )
            // InternalMachine.g:4825:1: ( ',' )
            {
            // InternalMachine.g:4825:1: ( ',' )
            // InternalMachine.g:4826:2: ','
            {
             before(grammarAccess.getUnidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__1"
    // InternalMachine.g:4835:1: rule__UnidirectionalPath__Group_4_0_2__1 : rule__UnidirectionalPath__Group_4_0_2__1__Impl ;
    public final void rule__UnidirectionalPath__Group_4_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4839:1: ( rule__UnidirectionalPath__Group_4_0_2__1__Impl )
            // InternalMachine.g:4840:2: rule__UnidirectionalPath__Group_4_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__1__Impl"
    // InternalMachine.g:4846:1: rule__UnidirectionalPath__Group_4_0_2__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4850:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) )
            // InternalMachine.g:4851:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            {
            // InternalMachine.g:4851:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            // InternalMachine.g:4852:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 
            // InternalMachine.g:4853:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 )
            // InternalMachine.g:4853:3: rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__0"
    // InternalMachine.g:4862:1: rule__UnidirectionalPath__Group_4_1__0 : rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1 ;
    public final void rule__UnidirectionalPath__Group_4_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4866:1: ( rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1 )
            // InternalMachine.g:4867:2: rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__0__Impl"
    // InternalMachine.g:4874:1: rule__UnidirectionalPath__Group_4_1__0__Impl : ( 'profile' ) ;
    public final void rule__UnidirectionalPath__Group_4_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4878:1: ( ( 'profile' ) )
            // InternalMachine.g:4879:1: ( 'profile' )
            {
            // InternalMachine.g:4879:1: ( 'profile' )
            // InternalMachine.g:4880:2: 'profile'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfileKeyword_4_1_0()); 
            match(input,39,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfileKeyword_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__1"
    // InternalMachine.g:4889:1: rule__UnidirectionalPath__Group_4_1__1 : rule__UnidirectionalPath__Group_4_1__1__Impl ;
    public final void rule__UnidirectionalPath__Group_4_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4893:1: ( rule__UnidirectionalPath__Group_4_1__1__Impl )
            // InternalMachine.g:4894:2: rule__UnidirectionalPath__Group_4_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__1__Impl"
    // InternalMachine.g:4900:1: rule__UnidirectionalPath__Group_4_1__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4904:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) ) )
            // InternalMachine.g:4905:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) )
            {
            // InternalMachine.g:4905:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) )
            // InternalMachine.g:4906:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_1_1()); 
            // InternalMachine.g:4907:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 )
            // InternalMachine.g:4907:3: rule__UnidirectionalPath__ProfilesAssignment_4_1_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_1_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__0"
    // InternalMachine.g:4916:1: rule__UnidirectionalPath__Group_5__0 : rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1 ;
    public final void rule__UnidirectionalPath__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4920:1: ( rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1 )
            // InternalMachine.g:4921:2: rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__0__Impl"
    // InternalMachine.g:4928:1: rule__UnidirectionalPath__Group_5__0__Impl : ( '@' ) ;
    public final void rule__UnidirectionalPath__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4932:1: ( ( '@' ) )
            // InternalMachine.g:4933:1: ( '@' )
            {
            // InternalMachine.g:4933:1: ( '@' )
            // InternalMachine.g:4934:2: '@'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getCommercialAtKeyword_5_0()); 
            match(input,40,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getCommercialAtKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__1"
    // InternalMachine.g:4943:1: rule__UnidirectionalPath__Group_5__1 : rule__UnidirectionalPath__Group_5__1__Impl ;
    public final void rule__UnidirectionalPath__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4947:1: ( rule__UnidirectionalPath__Group_5__1__Impl )
            // InternalMachine.g:4948:2: rule__UnidirectionalPath__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__1__Impl"
    // InternalMachine.g:4954:1: rule__UnidirectionalPath__Group_5__1__Impl : ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4958:1: ( ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) ) )
            // InternalMachine.g:4959:1: ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) )
            {
            // InternalMachine.g:4959:1: ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) )
            // InternalMachine.g:4960:2: ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsAssignment_5_1()); 
            // InternalMachine.g:4961:2: ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 )
            // InternalMachine.g:4961:3: rule__UnidirectionalPath__AnnotationsAssignment_5_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__AnnotationsAssignment_5_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsAssignment_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__0"
    // InternalMachine.g:4970:1: rule__BidirectionalPath__Group__0 : rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1 ;
    public final void rule__BidirectionalPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4974:1: ( rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1 )
            // InternalMachine.g:4975:2: rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__0"


    // $ANTLR start "rule__BidirectionalPath__Group__0__Impl"
    // InternalMachine.g:4982:1: rule__BidirectionalPath__Group__0__Impl : ( () ) ;
    public final void rule__BidirectionalPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4986:1: ( ( () ) )
            // InternalMachine.g:4987:1: ( () )
            {
            // InternalMachine.g:4987:1: ( () )
            // InternalMachine.g:4988:2: ()
            {
             before(grammarAccess.getBidirectionalPathAccess().getBidirectionalPathAction_0()); 
            // InternalMachine.g:4989:2: ()
            // InternalMachine.g:4989:3: 
            {
            }

             after(grammarAccess.getBidirectionalPathAccess().getBidirectionalPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__1"
    // InternalMachine.g:4997:1: rule__BidirectionalPath__Group__1 : rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2 ;
    public final void rule__BidirectionalPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5001:1: ( rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2 )
            // InternalMachine.g:5002:2: rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2
            {
            pushFollow(FOLLOW_36);
            rule__BidirectionalPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__1"


    // $ANTLR start "rule__BidirectionalPath__Group__1__Impl"
    // InternalMachine.g:5009:1: rule__BidirectionalPath__Group__1__Impl : ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) ) ;
    public final void rule__BidirectionalPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5013:1: ( ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) ) )
            // InternalMachine.g:5014:1: ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) )
            {
            // InternalMachine.g:5014:1: ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) )
            // InternalMachine.g:5015:2: ( rule__BidirectionalPath__EndPointsAssignment_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_1()); 
            // InternalMachine.g:5016:2: ( rule__BidirectionalPath__EndPointsAssignment_1 )
            // InternalMachine.g:5016:3: rule__BidirectionalPath__EndPointsAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__EndPointsAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__2"
    // InternalMachine.g:5024:1: rule__BidirectionalPath__Group__2 : rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3 ;
    public final void rule__BidirectionalPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5028:1: ( rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3 )
            // InternalMachine.g:5029:2: rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__2"


    // $ANTLR start "rule__BidirectionalPath__Group__2__Impl"
    // InternalMachine.g:5036:1: rule__BidirectionalPath__Group__2__Impl : ( '<->' ) ;
    public final void rule__BidirectionalPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5040:1: ( ( '<->' ) )
            // InternalMachine.g:5041:1: ( '<->' )
            {
            // InternalMachine.g:5041:1: ( '<->' )
            // InternalMachine.g:5042:2: '<->'
            {
             before(grammarAccess.getBidirectionalPathAccess().getLessThanSignHyphenMinusGreaterThanSignKeyword_2()); 
            match(input,41,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getLessThanSignHyphenMinusGreaterThanSignKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__2__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__3"
    // InternalMachine.g:5051:1: rule__BidirectionalPath__Group__3 : rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4 ;
    public final void rule__BidirectionalPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5055:1: ( rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4 )
            // InternalMachine.g:5056:2: rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4
            {
            pushFollow(FOLLOW_33);
            rule__BidirectionalPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__3"


    // $ANTLR start "rule__BidirectionalPath__Group__3__Impl"
    // InternalMachine.g:5063:1: rule__BidirectionalPath__Group__3__Impl : ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) ) ;
    public final void rule__BidirectionalPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5067:1: ( ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) ) )
            // InternalMachine.g:5068:1: ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) )
            {
            // InternalMachine.g:5068:1: ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) )
            // InternalMachine.g:5069:2: ( rule__BidirectionalPath__EndPointsAssignment_3 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_3()); 
            // InternalMachine.g:5070:2: ( rule__BidirectionalPath__EndPointsAssignment_3 )
            // InternalMachine.g:5070:3: rule__BidirectionalPath__EndPointsAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__EndPointsAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__3__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__4"
    // InternalMachine.g:5078:1: rule__BidirectionalPath__Group__4 : rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5 ;
    public final void rule__BidirectionalPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5082:1: ( rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5 )
            // InternalMachine.g:5083:2: rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5
            {
            pushFollow(FOLLOW_34);
            rule__BidirectionalPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__4"


    // $ANTLR start "rule__BidirectionalPath__Group__4__Impl"
    // InternalMachine.g:5090:1: rule__BidirectionalPath__Group__4__Impl : ( ( rule__BidirectionalPath__Alternatives_4 ) ) ;
    public final void rule__BidirectionalPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5094:1: ( ( ( rule__BidirectionalPath__Alternatives_4 ) ) )
            // InternalMachine.g:5095:1: ( ( rule__BidirectionalPath__Alternatives_4 ) )
            {
            // InternalMachine.g:5095:1: ( ( rule__BidirectionalPath__Alternatives_4 ) )
            // InternalMachine.g:5096:2: ( rule__BidirectionalPath__Alternatives_4 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAlternatives_4()); 
            // InternalMachine.g:5097:2: ( rule__BidirectionalPath__Alternatives_4 )
            // InternalMachine.g:5097:3: rule__BidirectionalPath__Alternatives_4
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Alternatives_4();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__4__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__5"
    // InternalMachine.g:5105:1: rule__BidirectionalPath__Group__5 : rule__BidirectionalPath__Group__5__Impl ;
    public final void rule__BidirectionalPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5109:1: ( rule__BidirectionalPath__Group__5__Impl )
            // InternalMachine.g:5110:2: rule__BidirectionalPath__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__5"


    // $ANTLR start "rule__BidirectionalPath__Group__5__Impl"
    // InternalMachine.g:5116:1: rule__BidirectionalPath__Group__5__Impl : ( ( rule__BidirectionalPath__Group_5__0 )* ) ;
    public final void rule__BidirectionalPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5120:1: ( ( ( rule__BidirectionalPath__Group_5__0 )* ) )
            // InternalMachine.g:5121:1: ( ( rule__BidirectionalPath__Group_5__0 )* )
            {
            // InternalMachine.g:5121:1: ( ( rule__BidirectionalPath__Group_5__0 )* )
            // InternalMachine.g:5122:2: ( rule__BidirectionalPath__Group_5__0 )*
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup_5()); 
            // InternalMachine.g:5123:2: ( rule__BidirectionalPath__Group_5__0 )*
            loop45:
            do {
                int alt45=2;
                int LA45_0 = input.LA(1);

                if ( (LA45_0==40) ) {
                    alt45=1;
                }


                switch (alt45) {
            	case 1 :
            	    // InternalMachine.g:5123:3: rule__BidirectionalPath__Group_5__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__BidirectionalPath__Group_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop45;
                }
            } while (true);

             after(grammarAccess.getBidirectionalPathAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__5__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__0"
    // InternalMachine.g:5132:1: rule__BidirectionalPath__Group_4_0__0 : rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1 ;
    public final void rule__BidirectionalPath__Group_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5136:1: ( rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1 )
            // InternalMachine.g:5137:2: rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__0__Impl"
    // InternalMachine.g:5144:1: rule__BidirectionalPath__Group_4_0__0__Impl : ( 'profiles' ) ;
    public final void rule__BidirectionalPath__Group_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5148:1: ( ( 'profiles' ) )
            // InternalMachine.g:5149:1: ( 'profiles' )
            {
            // InternalMachine.g:5149:1: ( 'profiles' )
            // InternalMachine.g:5150:2: 'profiles'
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesKeyword_4_0_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesKeyword_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__1"
    // InternalMachine.g:5159:1: rule__BidirectionalPath__Group_4_0__1 : rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2 ;
    public final void rule__BidirectionalPath__Group_4_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5163:1: ( rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2 )
            // InternalMachine.g:5164:2: rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2
            {
            pushFollow(FOLLOW_18);
            rule__BidirectionalPath__Group_4_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__1__Impl"
    // InternalMachine.g:5171:1: rule__BidirectionalPath__Group_4_0__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5175:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) ) )
            // InternalMachine.g:5176:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) )
            {
            // InternalMachine.g:5176:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) )
            // InternalMachine.g:5177:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_1()); 
            // InternalMachine.g:5178:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 )
            // InternalMachine.g:5178:3: rule__BidirectionalPath__ProfilesAssignment_4_0_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_0_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__2"
    // InternalMachine.g:5186:1: rule__BidirectionalPath__Group_4_0__2 : rule__BidirectionalPath__Group_4_0__2__Impl ;
    public final void rule__BidirectionalPath__Group_4_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5190:1: ( rule__BidirectionalPath__Group_4_0__2__Impl )
            // InternalMachine.g:5191:2: rule__BidirectionalPath__Group_4_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__2"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__2__Impl"
    // InternalMachine.g:5197:1: rule__BidirectionalPath__Group_4_0__2__Impl : ( ( rule__BidirectionalPath__Group_4_0_2__0 )* ) ;
    public final void rule__BidirectionalPath__Group_4_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5201:1: ( ( ( rule__BidirectionalPath__Group_4_0_2__0 )* ) )
            // InternalMachine.g:5202:1: ( ( rule__BidirectionalPath__Group_4_0_2__0 )* )
            {
            // InternalMachine.g:5202:1: ( ( rule__BidirectionalPath__Group_4_0_2__0 )* )
            // InternalMachine.g:5203:2: ( rule__BidirectionalPath__Group_4_0_2__0 )*
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup_4_0_2()); 
            // InternalMachine.g:5204:2: ( rule__BidirectionalPath__Group_4_0_2__0 )*
            loop46:
            do {
                int alt46=2;
                int LA46_0 = input.LA(1);

                if ( (LA46_0==27) ) {
                    alt46=1;
                }


                switch (alt46) {
            	case 1 :
            	    // InternalMachine.g:5204:3: rule__BidirectionalPath__Group_4_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__BidirectionalPath__Group_4_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop46;
                }
            } while (true);

             after(grammarAccess.getBidirectionalPathAccess().getGroup_4_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__2__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__0"
    // InternalMachine.g:5213:1: rule__BidirectionalPath__Group_4_0_2__0 : rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1 ;
    public final void rule__BidirectionalPath__Group_4_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5217:1: ( rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1 )
            // InternalMachine.g:5218:2: rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__0__Impl"
    // InternalMachine.g:5225:1: rule__BidirectionalPath__Group_4_0_2__0__Impl : ( ',' ) ;
    public final void rule__BidirectionalPath__Group_4_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5229:1: ( ( ',' ) )
            // InternalMachine.g:5230:1: ( ',' )
            {
            // InternalMachine.g:5230:1: ( ',' )
            // InternalMachine.g:5231:2: ','
            {
             before(grammarAccess.getBidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__1"
    // InternalMachine.g:5240:1: rule__BidirectionalPath__Group_4_0_2__1 : rule__BidirectionalPath__Group_4_0_2__1__Impl ;
    public final void rule__BidirectionalPath__Group_4_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5244:1: ( rule__BidirectionalPath__Group_4_0_2__1__Impl )
            // InternalMachine.g:5245:2: rule__BidirectionalPath__Group_4_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__1__Impl"
    // InternalMachine.g:5251:1: rule__BidirectionalPath__Group_4_0_2__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5255:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) )
            // InternalMachine.g:5256:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            {
            // InternalMachine.g:5256:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            // InternalMachine.g:5257:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 
            // InternalMachine.g:5258:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 )
            // InternalMachine.g:5258:3: rule__BidirectionalPath__ProfilesAssignment_4_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__0"
    // InternalMachine.g:5267:1: rule__BidirectionalPath__Group_4_1__0 : rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1 ;
    public final void rule__BidirectionalPath__Group_4_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5271:1: ( rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1 )
            // InternalMachine.g:5272:2: rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__0__Impl"
    // InternalMachine.g:5279:1: rule__BidirectionalPath__Group_4_1__0__Impl : ( 'profile' ) ;
    public final void rule__BidirectionalPath__Group_4_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5283:1: ( ( 'profile' ) )
            // InternalMachine.g:5284:1: ( 'profile' )
            {
            // InternalMachine.g:5284:1: ( 'profile' )
            // InternalMachine.g:5285:2: 'profile'
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfileKeyword_4_1_0()); 
            match(input,39,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfileKeyword_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__1"
    // InternalMachine.g:5294:1: rule__BidirectionalPath__Group_4_1__1 : rule__BidirectionalPath__Group_4_1__1__Impl ;
    public final void rule__BidirectionalPath__Group_4_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5298:1: ( rule__BidirectionalPath__Group_4_1__1__Impl )
            // InternalMachine.g:5299:2: rule__BidirectionalPath__Group_4_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__1__Impl"
    // InternalMachine.g:5305:1: rule__BidirectionalPath__Group_4_1__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5309:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) ) )
            // InternalMachine.g:5310:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) )
            {
            // InternalMachine.g:5310:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) )
            // InternalMachine.g:5311:2: ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_1_1()); 
            // InternalMachine.g:5312:2: ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 )
            // InternalMachine.g:5312:3: rule__BidirectionalPath__ProfilesAssignment_4_1_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_1_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_5__0"
    // InternalMachine.g:5321:1: rule__BidirectionalPath__Group_5__0 : rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1 ;
    public final void rule__BidirectionalPath__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5325:1: ( rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1 )
            // InternalMachine.g:5326:2: rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__0"


    // $ANTLR start "rule__BidirectionalPath__Group_5__0__Impl"
    // InternalMachine.g:5333:1: rule__BidirectionalPath__Group_5__0__Impl : ( '@' ) ;
    public final void rule__BidirectionalPath__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5337:1: ( ( '@' ) )
            // InternalMachine.g:5338:1: ( '@' )
            {
            // InternalMachine.g:5338:1: ( '@' )
            // InternalMachine.g:5339:2: '@'
            {
             before(grammarAccess.getBidirectionalPathAccess().getCommercialAtKeyword_5_0()); 
            match(input,40,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getCommercialAtKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_5__1"
    // InternalMachine.g:5348:1: rule__BidirectionalPath__Group_5__1 : rule__BidirectionalPath__Group_5__1__Impl ;
    public final void rule__BidirectionalPath__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5352:1: ( rule__BidirectionalPath__Group_5__1__Impl )
            // InternalMachine.g:5353:2: rule__BidirectionalPath__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__1"


    // $ANTLR start "rule__BidirectionalPath__Group_5__1__Impl"
    // InternalMachine.g:5359:1: rule__BidirectionalPath__Group_5__1__Impl : ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) ) ;
    public final void rule__BidirectionalPath__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5363:1: ( ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) ) )
            // InternalMachine.g:5364:1: ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) )
            {
            // InternalMachine.g:5364:1: ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) )
            // InternalMachine.g:5365:2: ( rule__BidirectionalPath__AnnotationsAssignment_5_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsAssignment_5_1()); 
            // InternalMachine.g:5366:2: ( rule__BidirectionalPath__AnnotationsAssignment_5_1 )
            // InternalMachine.g:5366:3: rule__BidirectionalPath__AnnotationsAssignment_5_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__AnnotationsAssignment_5_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsAssignment_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__0"
    // InternalMachine.g:5375:1: rule__FullMeshPath__Group__0 : rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1 ;
    public final void rule__FullMeshPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5379:1: ( rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1 )
            // InternalMachine.g:5380:2: rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1
            {
            pushFollow(FOLLOW_37);
            rule__FullMeshPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__0"


    // $ANTLR start "rule__FullMeshPath__Group__0__Impl"
    // InternalMachine.g:5387:1: rule__FullMeshPath__Group__0__Impl : ( () ) ;
    public final void rule__FullMeshPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5391:1: ( ( () ) )
            // InternalMachine.g:5392:1: ( () )
            {
            // InternalMachine.g:5392:1: ( () )
            // InternalMachine.g:5393:2: ()
            {
             before(grammarAccess.getFullMeshPathAccess().getFullMeshPathAction_0()); 
            // InternalMachine.g:5394:2: ()
            // InternalMachine.g:5394:3: 
            {
            }

             after(grammarAccess.getFullMeshPathAccess().getFullMeshPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__1"
    // InternalMachine.g:5402:1: rule__FullMeshPath__Group__1 : rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2 ;
    public final void rule__FullMeshPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5406:1: ( rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2 )
            // InternalMachine.g:5407:2: rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__FullMeshPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__1"


    // $ANTLR start "rule__FullMeshPath__Group__1__Impl"
    // InternalMachine.g:5414:1: rule__FullMeshPath__Group__1__Impl : ( 'FullMesh' ) ;
    public final void rule__FullMeshPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5418:1: ( ( 'FullMesh' ) )
            // InternalMachine.g:5419:1: ( 'FullMesh' )
            {
            // InternalMachine.g:5419:1: ( 'FullMesh' )
            // InternalMachine.g:5420:2: 'FullMesh'
            {
             before(grammarAccess.getFullMeshPathAccess().getFullMeshKeyword_1()); 
            match(input,42,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getFullMeshKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__2"
    // InternalMachine.g:5429:1: rule__FullMeshPath__Group__2 : rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3 ;
    public final void rule__FullMeshPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5433:1: ( rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3 )
            // InternalMachine.g:5434:2: rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3
            {
            pushFollow(FOLLOW_33);
            rule__FullMeshPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__2"


    // $ANTLR start "rule__FullMeshPath__Group__2__Impl"
    // InternalMachine.g:5441:1: rule__FullMeshPath__Group__2__Impl : ( '{' ) ;
    public final void rule__FullMeshPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5445:1: ( ( '{' ) )
            // InternalMachine.g:5446:1: ( '{' )
            {
            // InternalMachine.g:5446:1: ( '{' )
            // InternalMachine.g:5447:2: '{'
            {
             before(grammarAccess.getFullMeshPathAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__2__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__3"
    // InternalMachine.g:5456:1: rule__FullMeshPath__Group__3 : rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4 ;
    public final void rule__FullMeshPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5460:1: ( rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4 )
            // InternalMachine.g:5461:2: rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__3"


    // $ANTLR start "rule__FullMeshPath__Group__3__Impl"
    // InternalMachine.g:5468:1: rule__FullMeshPath__Group__3__Impl : ( ( rule__FullMeshPath__Alternatives_3 ) ) ;
    public final void rule__FullMeshPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5472:1: ( ( ( rule__FullMeshPath__Alternatives_3 ) ) )
            // InternalMachine.g:5473:1: ( ( rule__FullMeshPath__Alternatives_3 ) )
            {
            // InternalMachine.g:5473:1: ( ( rule__FullMeshPath__Alternatives_3 ) )
            // InternalMachine.g:5474:2: ( rule__FullMeshPath__Alternatives_3 )
            {
             before(grammarAccess.getFullMeshPathAccess().getAlternatives_3()); 
            // InternalMachine.g:5475:2: ( rule__FullMeshPath__Alternatives_3 )
            // InternalMachine.g:5475:3: rule__FullMeshPath__Alternatives_3
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Alternatives_3();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getAlternatives_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__3__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__4"
    // InternalMachine.g:5483:1: rule__FullMeshPath__Group__4 : rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5 ;
    public final void rule__FullMeshPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5487:1: ( rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5 )
            // InternalMachine.g:5488:2: rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__4"


    // $ANTLR start "rule__FullMeshPath__Group__4__Impl"
    // InternalMachine.g:5495:1: rule__FullMeshPath__Group__4__Impl : ( ( rule__FullMeshPath__Group_4__0 )* ) ;
    public final void rule__FullMeshPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5499:1: ( ( ( rule__FullMeshPath__Group_4__0 )* ) )
            // InternalMachine.g:5500:1: ( ( rule__FullMeshPath__Group_4__0 )* )
            {
            // InternalMachine.g:5500:1: ( ( rule__FullMeshPath__Group_4__0 )* )
            // InternalMachine.g:5501:2: ( rule__FullMeshPath__Group_4__0 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup_4()); 
            // InternalMachine.g:5502:2: ( rule__FullMeshPath__Group_4__0 )*
            loop47:
            do {
                int alt47=2;
                int LA47_0 = input.LA(1);

                if ( (LA47_0==40) ) {
                    alt47=1;
                }


                switch (alt47) {
            	case 1 :
            	    // InternalMachine.g:5502:3: rule__FullMeshPath__Group_4__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__FullMeshPath__Group_4__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__4__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__5"
    // InternalMachine.g:5510:1: rule__FullMeshPath__Group__5 : rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6 ;
    public final void rule__FullMeshPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5514:1: ( rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6 )
            // InternalMachine.g:5515:2: rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__5"


    // $ANTLR start "rule__FullMeshPath__Group__5__Impl"
    // InternalMachine.g:5522:1: rule__FullMeshPath__Group__5__Impl : ( ( rule__FullMeshPath__EndPointsAssignment_5 )* ) ;
    public final void rule__FullMeshPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5526:1: ( ( ( rule__FullMeshPath__EndPointsAssignment_5 )* ) )
            // InternalMachine.g:5527:1: ( ( rule__FullMeshPath__EndPointsAssignment_5 )* )
            {
            // InternalMachine.g:5527:1: ( ( rule__FullMeshPath__EndPointsAssignment_5 )* )
            // InternalMachine.g:5528:2: ( rule__FullMeshPath__EndPointsAssignment_5 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getEndPointsAssignment_5()); 
            // InternalMachine.g:5529:2: ( rule__FullMeshPath__EndPointsAssignment_5 )*
            loop48:
            do {
                int alt48=2;
                int LA48_0 = input.LA(1);

                if ( (LA48_0==RULE_ID) ) {
                    alt48=1;
                }


                switch (alt48) {
            	case 1 :
            	    // InternalMachine.g:5529:3: rule__FullMeshPath__EndPointsAssignment_5
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__FullMeshPath__EndPointsAssignment_5();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop48;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getEndPointsAssignment_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__5__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__6"
    // InternalMachine.g:5537:1: rule__FullMeshPath__Group__6 : rule__FullMeshPath__Group__6__Impl ;
    public final void rule__FullMeshPath__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5541:1: ( rule__FullMeshPath__Group__6__Impl )
            // InternalMachine.g:5542:2: rule__FullMeshPath__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__6"


    // $ANTLR start "rule__FullMeshPath__Group__6__Impl"
    // InternalMachine.g:5548:1: rule__FullMeshPath__Group__6__Impl : ( '}' ) ;
    public final void rule__FullMeshPath__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5552:1: ( ( '}' ) )
            // InternalMachine.g:5553:1: ( '}' )
            {
            // InternalMachine.g:5553:1: ( '}' )
            // InternalMachine.g:5554:2: '}'
            {
             before(grammarAccess.getFullMeshPathAccess().getRightCurlyBracketKeyword_6()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getRightCurlyBracketKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__6__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__0"
    // InternalMachine.g:5564:1: rule__FullMeshPath__Group_3_0__0 : rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1 ;
    public final void rule__FullMeshPath__Group_3_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5568:1: ( rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1 )
            // InternalMachine.g:5569:2: rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__0__Impl"
    // InternalMachine.g:5576:1: rule__FullMeshPath__Group_3_0__0__Impl : ( 'profiles' ) ;
    public final void rule__FullMeshPath__Group_3_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5580:1: ( ( 'profiles' ) )
            // InternalMachine.g:5581:1: ( 'profiles' )
            {
            // InternalMachine.g:5581:1: ( 'profiles' )
            // InternalMachine.g:5582:2: 'profiles'
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesKeyword_3_0_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesKeyword_3_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__1"
    // InternalMachine.g:5591:1: rule__FullMeshPath__Group_3_0__1 : rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2 ;
    public final void rule__FullMeshPath__Group_3_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5595:1: ( rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2 )
            // InternalMachine.g:5596:2: rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2
            {
            pushFollow(FOLLOW_18);
            rule__FullMeshPath__Group_3_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__1__Impl"
    // InternalMachine.g:5603:1: rule__FullMeshPath__Group_3_0__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5607:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) ) )
            // InternalMachine.g:5608:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) )
            {
            // InternalMachine.g:5608:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) )
            // InternalMachine.g:5609:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_1()); 
            // InternalMachine.g:5610:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_1 )
            // InternalMachine.g:5610:3: rule__FullMeshPath__ProfilesAssignment_3_0_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_0_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__2"
    // InternalMachine.g:5618:1: rule__FullMeshPath__Group_3_0__2 : rule__FullMeshPath__Group_3_0__2__Impl ;
    public final void rule__FullMeshPath__Group_3_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5622:1: ( rule__FullMeshPath__Group_3_0__2__Impl )
            // InternalMachine.g:5623:2: rule__FullMeshPath__Group_3_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__2"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__2__Impl"
    // InternalMachine.g:5629:1: rule__FullMeshPath__Group_3_0__2__Impl : ( ( rule__FullMeshPath__Group_3_0_2__0 )* ) ;
    public final void rule__FullMeshPath__Group_3_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5633:1: ( ( ( rule__FullMeshPath__Group_3_0_2__0 )* ) )
            // InternalMachine.g:5634:1: ( ( rule__FullMeshPath__Group_3_0_2__0 )* )
            {
            // InternalMachine.g:5634:1: ( ( rule__FullMeshPath__Group_3_0_2__0 )* )
            // InternalMachine.g:5635:2: ( rule__FullMeshPath__Group_3_0_2__0 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup_3_0_2()); 
            // InternalMachine.g:5636:2: ( rule__FullMeshPath__Group_3_0_2__0 )*
            loop49:
            do {
                int alt49=2;
                int LA49_0 = input.LA(1);

                if ( (LA49_0==27) ) {
                    alt49=1;
                }


                switch (alt49) {
            	case 1 :
            	    // InternalMachine.g:5636:3: rule__FullMeshPath__Group_3_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__FullMeshPath__Group_3_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop49;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getGroup_3_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__2__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__0"
    // InternalMachine.g:5645:1: rule__FullMeshPath__Group_3_0_2__0 : rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1 ;
    public final void rule__FullMeshPath__Group_3_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5649:1: ( rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1 )
            // InternalMachine.g:5650:2: rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__0__Impl"
    // InternalMachine.g:5657:1: rule__FullMeshPath__Group_3_0_2__0__Impl : ( ',' ) ;
    public final void rule__FullMeshPath__Group_3_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5661:1: ( ( ',' ) )
            // InternalMachine.g:5662:1: ( ',' )
            {
            // InternalMachine.g:5662:1: ( ',' )
            // InternalMachine.g:5663:2: ','
            {
             before(grammarAccess.getFullMeshPathAccess().getCommaKeyword_3_0_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getCommaKeyword_3_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__1"
    // InternalMachine.g:5672:1: rule__FullMeshPath__Group_3_0_2__1 : rule__FullMeshPath__Group_3_0_2__1__Impl ;
    public final void rule__FullMeshPath__Group_3_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5676:1: ( rule__FullMeshPath__Group_3_0_2__1__Impl )
            // InternalMachine.g:5677:2: rule__FullMeshPath__Group_3_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__1__Impl"
    // InternalMachine.g:5683:1: rule__FullMeshPath__Group_3_0_2__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5687:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) ) )
            // InternalMachine.g:5688:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) )
            {
            // InternalMachine.g:5688:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) )
            // InternalMachine.g:5689:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_2_1()); 
            // InternalMachine.g:5690:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 )
            // InternalMachine.g:5690:3: rule__FullMeshPath__ProfilesAssignment_3_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__0"
    // InternalMachine.g:5699:1: rule__FullMeshPath__Group_3_1__0 : rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1 ;
    public final void rule__FullMeshPath__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5703:1: ( rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1 )
            // InternalMachine.g:5704:2: rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__0__Impl"
    // InternalMachine.g:5711:1: rule__FullMeshPath__Group_3_1__0__Impl : ( 'profile' ) ;
    public final void rule__FullMeshPath__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5715:1: ( ( 'profile' ) )
            // InternalMachine.g:5716:1: ( 'profile' )
            {
            // InternalMachine.g:5716:1: ( 'profile' )
            // InternalMachine.g:5717:2: 'profile'
            {
             before(grammarAccess.getFullMeshPathAccess().getProfileKeyword_3_1_0()); 
            match(input,39,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfileKeyword_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__1"
    // InternalMachine.g:5726:1: rule__FullMeshPath__Group_3_1__1 : rule__FullMeshPath__Group_3_1__1__Impl ;
    public final void rule__FullMeshPath__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5730:1: ( rule__FullMeshPath__Group_3_1__1__Impl )
            // InternalMachine.g:5731:2: rule__FullMeshPath__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__1__Impl"
    // InternalMachine.g:5737:1: rule__FullMeshPath__Group_3_1__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5741:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) ) )
            // InternalMachine.g:5742:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) )
            {
            // InternalMachine.g:5742:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) )
            // InternalMachine.g:5743:2: ( rule__FullMeshPath__ProfilesAssignment_3_1_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_1_1()); 
            // InternalMachine.g:5744:2: ( rule__FullMeshPath__ProfilesAssignment_3_1_1 )
            // InternalMachine.g:5744:3: rule__FullMeshPath__ProfilesAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_1_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_4__0"
    // InternalMachine.g:5753:1: rule__FullMeshPath__Group_4__0 : rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1 ;
    public final void rule__FullMeshPath__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5757:1: ( rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1 )
            // InternalMachine.g:5758:2: rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__0"


    // $ANTLR start "rule__FullMeshPath__Group_4__0__Impl"
    // InternalMachine.g:5765:1: rule__FullMeshPath__Group_4__0__Impl : ( '@' ) ;
    public final void rule__FullMeshPath__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5769:1: ( ( '@' ) )
            // InternalMachine.g:5770:1: ( '@' )
            {
            // InternalMachine.g:5770:1: ( '@' )
            // InternalMachine.g:5771:2: '@'
            {
             before(grammarAccess.getFullMeshPathAccess().getCommercialAtKeyword_4_0()); 
            match(input,40,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getCommercialAtKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_4__1"
    // InternalMachine.g:5780:1: rule__FullMeshPath__Group_4__1 : rule__FullMeshPath__Group_4__1__Impl ;
    public final void rule__FullMeshPath__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5784:1: ( rule__FullMeshPath__Group_4__1__Impl )
            // InternalMachine.g:5785:2: rule__FullMeshPath__Group_4__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_4__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__1"


    // $ANTLR start "rule__FullMeshPath__Group_4__1__Impl"
    // InternalMachine.g:5791:1: rule__FullMeshPath__Group_4__1__Impl : ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) ) ;
    public final void rule__FullMeshPath__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5795:1: ( ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) ) )
            // InternalMachine.g:5796:1: ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) )
            {
            // InternalMachine.g:5796:1: ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) )
            // InternalMachine.g:5797:2: ( rule__FullMeshPath__AnnotationsAssignment_4_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsAssignment_4_1()); 
            // InternalMachine.g:5798:2: ( rule__FullMeshPath__AnnotationsAssignment_4_1 )
            // InternalMachine.g:5798:3: rule__FullMeshPath__AnnotationsAssignment_4_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__AnnotationsAssignment_4_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getAnnotationsAssignment_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__0"
    // InternalMachine.g:5807:1: rule__PathTargetReference__Group__0 : rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1 ;
    public final void rule__PathTargetReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5811:1: ( rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1 )
            // InternalMachine.g:5812:2: rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__0"


    // $ANTLR start "rule__PathTargetReference__Group__0__Impl"
    // InternalMachine.g:5819:1: rule__PathTargetReference__Group__0__Impl : ( () ) ;
    public final void rule__PathTargetReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5823:1: ( ( () ) )
            // InternalMachine.g:5824:1: ( () )
            {
            // InternalMachine.g:5824:1: ( () )
            // InternalMachine.g:5825:2: ()
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPathTargetReferenceAction_0()); 
            // InternalMachine.g:5826:2: ()
            // InternalMachine.g:5826:3: 
            {
            }

             after(grammarAccess.getPathTargetReferenceAccess().getPathTargetReferenceAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__1"
    // InternalMachine.g:5834:1: rule__PathTargetReference__Group__1 : rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2 ;
    public final void rule__PathTargetReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5838:1: ( rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2 )
            // InternalMachine.g:5839:2: rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__PathTargetReference__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__1"


    // $ANTLR start "rule__PathTargetReference__Group__1__Impl"
    // InternalMachine.g:5846:1: rule__PathTargetReference__Group__1__Impl : ( ( rule__PathTargetReference__PositionAssignment_1 ) ) ;
    public final void rule__PathTargetReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5850:1: ( ( ( rule__PathTargetReference__PositionAssignment_1 ) ) )
            // InternalMachine.g:5851:1: ( ( rule__PathTargetReference__PositionAssignment_1 ) )
            {
            // InternalMachine.g:5851:1: ( ( rule__PathTargetReference__PositionAssignment_1 ) )
            // InternalMachine.g:5852:2: ( rule__PathTargetReference__PositionAssignment_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionAssignment_1()); 
            // InternalMachine.g:5853:2: ( rule__PathTargetReference__PositionAssignment_1 )
            // InternalMachine.g:5853:3: rule__PathTargetReference__PositionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__PositionAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getPositionAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__2"
    // InternalMachine.g:5861:1: rule__PathTargetReference__Group__2 : rule__PathTargetReference__Group__2__Impl ;
    public final void rule__PathTargetReference__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5865:1: ( rule__PathTargetReference__Group__2__Impl )
            // InternalMachine.g:5866:2: rule__PathTargetReference__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__2"


    // $ANTLR start "rule__PathTargetReference__Group__2__Impl"
    // InternalMachine.g:5872:1: rule__PathTargetReference__Group__2__Impl : ( ( rule__PathTargetReference__Group_2__0 )? ) ;
    public final void rule__PathTargetReference__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5876:1: ( ( ( rule__PathTargetReference__Group_2__0 )? ) )
            // InternalMachine.g:5877:1: ( ( rule__PathTargetReference__Group_2__0 )? )
            {
            // InternalMachine.g:5877:1: ( ( rule__PathTargetReference__Group_2__0 )? )
            // InternalMachine.g:5878:2: ( rule__PathTargetReference__Group_2__0 )?
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup_2()); 
            // InternalMachine.g:5879:2: ( rule__PathTargetReference__Group_2__0 )?
            int alt50=2;
            int LA50_0 = input.LA(1);

            if ( (LA50_0==24) ) {
                alt50=1;
            }
            switch (alt50) {
                case 1 :
                    // InternalMachine.g:5879:3: rule__PathTargetReference__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PathTargetReference__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPathTargetReferenceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__2__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__0"
    // InternalMachine.g:5888:1: rule__PathTargetReference__Group_2__0 : rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1 ;
    public final void rule__PathTargetReference__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5892:1: ( rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1 )
            // InternalMachine.g:5893:2: rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__0"


    // $ANTLR start "rule__PathTargetReference__Group_2__0__Impl"
    // InternalMachine.g:5900:1: rule__PathTargetReference__Group_2__0__Impl : ( '[' ) ;
    public final void rule__PathTargetReference__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5904:1: ( ( '[' ) )
            // InternalMachine.g:5905:1: ( '[' )
            {
            // InternalMachine.g:5905:1: ( '[' )
            // InternalMachine.g:5906:2: '['
            {
             before(grammarAccess.getPathTargetReferenceAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__1"
    // InternalMachine.g:5915:1: rule__PathTargetReference__Group_2__1 : rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2 ;
    public final void rule__PathTargetReference__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5919:1: ( rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2 )
            // InternalMachine.g:5920:2: rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2
            {
            pushFollow(FOLLOW_30);
            rule__PathTargetReference__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__1"


    // $ANTLR start "rule__PathTargetReference__Group_2__1__Impl"
    // InternalMachine.g:5927:1: rule__PathTargetReference__Group_2__1__Impl : ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) ) ;
    public final void rule__PathTargetReference__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5931:1: ( ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) ) )
            // InternalMachine.g:5932:1: ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) )
            {
            // InternalMachine.g:5932:1: ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) )
            // InternalMachine.g:5933:2: ( rule__PathTargetReference__SettlingAssignment_2_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_1()); 
            // InternalMachine.g:5934:2: ( rule__PathTargetReference__SettlingAssignment_2_1 )
            // InternalMachine.g:5934:3: rule__PathTargetReference__SettlingAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__SettlingAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__2"
    // InternalMachine.g:5942:1: rule__PathTargetReference__Group_2__2 : rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3 ;
    public final void rule__PathTargetReference__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5946:1: ( rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3 )
            // InternalMachine.g:5947:2: rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3
            {
            pushFollow(FOLLOW_30);
            rule__PathTargetReference__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__2"


    // $ANTLR start "rule__PathTargetReference__Group_2__2__Impl"
    // InternalMachine.g:5954:1: rule__PathTargetReference__Group_2__2__Impl : ( ( rule__PathTargetReference__Group_2_2__0 )* ) ;
    public final void rule__PathTargetReference__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5958:1: ( ( ( rule__PathTargetReference__Group_2_2__0 )* ) )
            // InternalMachine.g:5959:1: ( ( rule__PathTargetReference__Group_2_2__0 )* )
            {
            // InternalMachine.g:5959:1: ( ( rule__PathTargetReference__Group_2_2__0 )* )
            // InternalMachine.g:5960:2: ( rule__PathTargetReference__Group_2_2__0 )*
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup_2_2()); 
            // InternalMachine.g:5961:2: ( rule__PathTargetReference__Group_2_2__0 )*
            loop51:
            do {
                int alt51=2;
                int LA51_0 = input.LA(1);

                if ( (LA51_0==27) ) {
                    alt51=1;
                }


                switch (alt51) {
            	case 1 :
            	    // InternalMachine.g:5961:3: rule__PathTargetReference__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__PathTargetReference__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop51;
                }
            } while (true);

             after(grammarAccess.getPathTargetReferenceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__2__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__3"
    // InternalMachine.g:5969:1: rule__PathTargetReference__Group_2__3 : rule__PathTargetReference__Group_2__3__Impl ;
    public final void rule__PathTargetReference__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5973:1: ( rule__PathTargetReference__Group_2__3__Impl )
            // InternalMachine.g:5974:2: rule__PathTargetReference__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__3"


    // $ANTLR start "rule__PathTargetReference__Group_2__3__Impl"
    // InternalMachine.g:5980:1: rule__PathTargetReference__Group_2__3__Impl : ( ']' ) ;
    public final void rule__PathTargetReference__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5984:1: ( ( ']' ) )
            // InternalMachine.g:5985:1: ( ']' )
            {
            // InternalMachine.g:5985:1: ( ']' )
            // InternalMachine.g:5986:2: ']'
            {
             before(grammarAccess.getPathTargetReferenceAccess().getRightSquareBracketKeyword_2_3()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getRightSquareBracketKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__3__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__0"
    // InternalMachine.g:5996:1: rule__PathTargetReference__Group_2_2__0 : rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1 ;
    public final void rule__PathTargetReference__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6000:1: ( rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1 )
            // InternalMachine.g:6001:2: rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__0"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__0__Impl"
    // InternalMachine.g:6008:1: rule__PathTargetReference__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__PathTargetReference__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6012:1: ( ( ',' ) )
            // InternalMachine.g:6013:1: ( ',' )
            {
            // InternalMachine.g:6013:1: ( ',' )
            // InternalMachine.g:6014:2: ','
            {
             before(grammarAccess.getPathTargetReferenceAccess().getCommaKeyword_2_2_0()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__1"
    // InternalMachine.g:6023:1: rule__PathTargetReference__Group_2_2__1 : rule__PathTargetReference__Group_2_2__1__Impl ;
    public final void rule__PathTargetReference__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6027:1: ( rule__PathTargetReference__Group_2_2__1__Impl )
            // InternalMachine.g:6028:2: rule__PathTargetReference__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__1"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__1__Impl"
    // InternalMachine.g:6034:1: rule__PathTargetReference__Group_2_2__1__Impl : ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) ) ;
    public final void rule__PathTargetReference__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6038:1: ( ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) ) )
            // InternalMachine.g:6039:1: ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) )
            {
            // InternalMachine.g:6039:1: ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) )
            // InternalMachine.g:6040:2: ( rule__PathTargetReference__SettlingAssignment_2_2_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_2_1()); 
            // InternalMachine.g:6041:2: ( rule__PathTargetReference__SettlingAssignment_2_2_1 )
            // InternalMachine.g:6041:3: rule__PathTargetReference__SettlingAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__SettlingAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__1__Impl"


    // $ANTLR start "rule__Machine__ImportsAssignment_1"
    // InternalMachine.g:6050:1: rule__Machine__ImportsAssignment_1 : ( ruleImport ) ;
    public final void rule__Machine__ImportsAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6054:1: ( ( ruleImport ) )
            // InternalMachine.g:6055:2: ( ruleImport )
            {
            // InternalMachine.g:6055:2: ( ruleImport )
            // InternalMachine.g:6056:3: ruleImport
            {
             before(grammarAccess.getMachineAccess().getImportsImportParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getImportsImportParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__ImportsAssignment_1"


    // $ANTLR start "rule__Machine__TypeAssignment_2_1"
    // InternalMachine.g:6065:1: rule__Machine__TypeAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__Machine__TypeAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6069:1: ( ( RULE_ID ) )
            // InternalMachine.g:6070:2: ( RULE_ID )
            {
            // InternalMachine.g:6070:2: ( RULE_ID )
            // InternalMachine.g:6071:3: RULE_ID
            {
             before(grammarAccess.getMachineAccess().getTypeIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getTypeIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__TypeAssignment_2_1"


    // $ANTLR start "rule__Machine__PathAnnotationsAssignment_3_2"
    // InternalMachine.g:6080:1: rule__Machine__PathAnnotationsAssignment_3_2 : ( rulePathAnnotation ) ;
    public final void rule__Machine__PathAnnotationsAssignment_3_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6084:1: ( ( rulePathAnnotation ) )
            // InternalMachine.g:6085:2: ( rulePathAnnotation )
            {
            // InternalMachine.g:6085:2: ( rulePathAnnotation )
            // InternalMachine.g:6086:3: rulePathAnnotation
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsPathAnnotationParserRuleCall_3_2_0()); 
            pushFollow(FOLLOW_2);
            rulePathAnnotation();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getPathAnnotationsPathAnnotationParserRuleCall_3_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__PathAnnotationsAssignment_3_2"


    // $ANTLR start "rule__Machine__PeripheralTypesAssignment_4_0"
    // InternalMachine.g:6095:1: rule__Machine__PeripheralTypesAssignment_4_0 : ( rulePeripheralType ) ;
    public final void rule__Machine__PeripheralTypesAssignment_4_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6099:1: ( ( rulePeripheralType ) )
            // InternalMachine.g:6100:2: ( rulePeripheralType )
            {
            // InternalMachine.g:6100:2: ( rulePeripheralType )
            // InternalMachine.g:6101:3: rulePeripheralType
            {
             before(grammarAccess.getMachineAccess().getPeripheralTypesPeripheralTypeParserRuleCall_4_0_0()); 
            pushFollow(FOLLOW_2);
            rulePeripheralType();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getPeripheralTypesPeripheralTypeParserRuleCall_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__PeripheralTypesAssignment_4_0"


    // $ANTLR start "rule__Machine__ResourcesAssignment_4_1"
    // InternalMachine.g:6110:1: rule__Machine__ResourcesAssignment_4_1 : ( ruleResource ) ;
    public final void rule__Machine__ResourcesAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6114:1: ( ( ruleResource ) )
            // InternalMachine.g:6115:2: ( ruleResource )
            {
            // InternalMachine.g:6115:2: ( ruleResource )
            // InternalMachine.g:6116:3: ruleResource
            {
             before(grammarAccess.getMachineAccess().getResourcesResourceParserRuleCall_4_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResource();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getResourcesResourceParserRuleCall_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__ResourcesAssignment_4_1"


    // $ANTLR start "rule__Import__ImportURIAssignment_1"
    // InternalMachine.g:6125:1: rule__Import__ImportURIAssignment_1 : ( RULE_STRING ) ;
    public final void rule__Import__ImportURIAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6129:1: ( ( RULE_STRING ) )
            // InternalMachine.g:6130:2: ( RULE_STRING )
            {
            // InternalMachine.g:6130:2: ( RULE_STRING )
            // InternalMachine.g:6131:3: RULE_STRING
            {
             before(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__ImportURIAssignment_1"


    // $ANTLR start "rule__PathAnnotation__NameAssignment_1"
    // InternalMachine.g:6140:1: rule__PathAnnotation__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__PathAnnotation__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6144:1: ( ( RULE_ID ) )
            // InternalMachine.g:6145:2: ( RULE_ID )
            {
            // InternalMachine.g:6145:2: ( RULE_ID )
            // InternalMachine.g:6146:3: RULE_ID
            {
             before(grammarAccess.getPathAnnotationAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathAnnotationAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__NameAssignment_1"


    // $ANTLR start "rule__PeripheralType__NameAssignment_2"
    // InternalMachine.g:6155:1: rule__PeripheralType__NameAssignment_2 : ( RULE_ID ) ;
    public final void rule__PeripheralType__NameAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6159:1: ( ( RULE_ID ) )
            // InternalMachine.g:6160:2: ( RULE_ID )
            {
            // InternalMachine.g:6160:2: ( RULE_ID )
            // InternalMachine.g:6161:3: RULE_ID
            {
             before(grammarAccess.getPeripheralTypeAccess().getNameIDTerminalRuleCall_2_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getNameIDTerminalRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__NameAssignment_2"


    // $ANTLR start "rule__PeripheralType__ActionsAssignment_4_2"
    // InternalMachine.g:6170:1: rule__PeripheralType__ActionsAssignment_4_2 : ( ruleActionType ) ;
    public final void rule__PeripheralType__ActionsAssignment_4_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6174:1: ( ( ruleActionType ) )
            // InternalMachine.g:6175:2: ( ruleActionType )
            {
            // InternalMachine.g:6175:2: ( ruleActionType )
            // InternalMachine.g:6176:3: ruleActionType
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsActionTypeParserRuleCall_4_2_0()); 
            pushFollow(FOLLOW_2);
            ruleActionType();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getActionsActionTypeParserRuleCall_4_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__ActionsAssignment_4_2"


    // $ANTLR start "rule__PeripheralType__SetPointsAssignment_5_2"
    // InternalMachine.g:6185:1: rule__PeripheralType__SetPointsAssignment_5_2 : ( ruleSetPoint ) ;
    public final void rule__PeripheralType__SetPointsAssignment_5_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6189:1: ( ( ruleSetPoint ) )
            // InternalMachine.g:6190:2: ( ruleSetPoint )
            {
            // InternalMachine.g:6190:2: ( ruleSetPoint )
            // InternalMachine.g:6191:3: ruleSetPoint
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsSetPointParserRuleCall_5_2_0()); 
            pushFollow(FOLLOW_2);
            ruleSetPoint();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getSetPointsSetPointParserRuleCall_5_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__SetPointsAssignment_5_2"


    // $ANTLR start "rule__PeripheralType__AxesAssignment_5_6"
    // InternalMachine.g:6200:1: rule__PeripheralType__AxesAssignment_5_6 : ( ruleAxis ) ;
    public final void rule__PeripheralType__AxesAssignment_5_6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6204:1: ( ( ruleAxis ) )
            // InternalMachine.g:6205:2: ( ruleAxis )
            {
            // InternalMachine.g:6205:2: ( ruleAxis )
            // InternalMachine.g:6206:3: ruleAxis
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesAxisParserRuleCall_5_6_0()); 
            pushFollow(FOLLOW_2);
            ruleAxis();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getAxesAxisParserRuleCall_5_6_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__AxesAssignment_5_6"


    // $ANTLR start "rule__PeripheralType__ConversionAssignment_5_8_1"
    // InternalMachine.g:6215:1: rule__PeripheralType__ConversionAssignment_5_8_1 : ( RULE_STRING ) ;
    public final void rule__PeripheralType__ConversionAssignment_5_8_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6219:1: ( ( RULE_STRING ) )
            // InternalMachine.g:6220:2: ( RULE_STRING )
            {
            // InternalMachine.g:6220:2: ( RULE_STRING )
            // InternalMachine.g:6221:3: RULE_STRING
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionSTRINGTerminalRuleCall_5_8_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getConversionSTRINGTerminalRuleCall_5_8_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__ConversionAssignment_5_8_1"


    // $ANTLR start "rule__ActionType__NameAssignment_1"
    // InternalMachine.g:6230:1: rule__ActionType__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__ActionType__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6234:1: ( ( RULE_ID ) )
            // InternalMachine.g:6235:2: ( RULE_ID )
            {
            // InternalMachine.g:6235:2: ( RULE_ID )
            // InternalMachine.g:6236:3: RULE_ID
            {
             before(grammarAccess.getActionTypeAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getActionTypeAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__NameAssignment_1"


    // $ANTLR start "rule__SetPoint__NameAssignment_1"
    // InternalMachine.g:6245:1: rule__SetPoint__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__SetPoint__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6249:1: ( ( RULE_ID ) )
            // InternalMachine.g:6250:2: ( RULE_ID )
            {
            // InternalMachine.g:6250:2: ( RULE_ID )
            // InternalMachine.g:6251:3: RULE_ID
            {
             before(grammarAccess.getSetPointAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__NameAssignment_1"


    // $ANTLR start "rule__SetPoint__UnitAssignment_2_1"
    // InternalMachine.g:6260:1: rule__SetPoint__UnitAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__SetPoint__UnitAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6264:1: ( ( RULE_ID ) )
            // InternalMachine.g:6265:2: ( RULE_ID )
            {
            // InternalMachine.g:6265:2: ( RULE_ID )
            // InternalMachine.g:6266:3: RULE_ID
            {
             before(grammarAccess.getSetPointAccess().getUnitIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getUnitIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__UnitAssignment_2_1"


    // $ANTLR start "rule__Axis__NameAssignment_1"
    // InternalMachine.g:6275:1: rule__Axis__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Axis__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6279:1: ( ( RULE_ID ) )
            // InternalMachine.g:6280:2: ( RULE_ID )
            {
            // InternalMachine.g:6280:2: ( RULE_ID )
            // InternalMachine.g:6281:3: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__NameAssignment_1"


    // $ANTLR start "rule__Axis__UnitAssignment_2_1"
    // InternalMachine.g:6290:1: rule__Axis__UnitAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__Axis__UnitAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6294:1: ( ( RULE_ID ) )
            // InternalMachine.g:6295:2: ( RULE_ID )
            {
            // InternalMachine.g:6295:2: ( RULE_ID )
            // InternalMachine.g:6296:3: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getUnitIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getUnitIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__UnitAssignment_2_1"


    // $ANTLR start "rule__Axis__SetPointsAssignment_3_1"
    // InternalMachine.g:6305:1: rule__Axis__SetPointsAssignment_3_1 : ( ( RULE_ID ) ) ;
    public final void rule__Axis__SetPointsAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6309:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6310:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6310:2: ( ( RULE_ID ) )
            // InternalMachine.g:6311:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_1_0()); 
            // InternalMachine.g:6312:3: ( RULE_ID )
            // InternalMachine.g:6313:4: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_1_0_1()); 

            }

             after(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__SetPointsAssignment_3_1"


    // $ANTLR start "rule__Axis__SetPointsAssignment_3_2_1"
    // InternalMachine.g:6324:1: rule__Axis__SetPointsAssignment_3_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Axis__SetPointsAssignment_3_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6328:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6329:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6329:2: ( ( RULE_ID ) )
            // InternalMachine.g:6330:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_2_1_0()); 
            // InternalMachine.g:6331:3: ( RULE_ID )
            // InternalMachine.g:6332:4: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_2_1_0_1()); 

            }

             after(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__SetPointsAssignment_3_2_1"


    // $ANTLR start "rule__ResourceItem__NameAssignment_1"
    // InternalMachine.g:6343:1: rule__ResourceItem__NameAssignment_1 : ( ruleIID ) ;
    public final void rule__ResourceItem__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6347:1: ( ( ruleIID ) )
            // InternalMachine.g:6348:2: ( ruleIID )
            {
            // InternalMachine.g:6348:2: ( ruleIID )
            // InternalMachine.g:6349:3: ruleIID
            {
             before(grammarAccess.getResourceItemAccess().getNameIIDParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleIID();

            state._fsp--;

             after(grammarAccess.getResourceItemAccess().getNameIIDParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__NameAssignment_1"


    // $ANTLR start "rule__Resource__ResourceTypeAssignment_0"
    // InternalMachine.g:6358:1: rule__Resource__ResourceTypeAssignment_0 : ( ruleResourceType ) ;
    public final void rule__Resource__ResourceTypeAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6362:1: ( ( ruleResourceType ) )
            // InternalMachine.g:6363:2: ( ruleResourceType )
            {
            // InternalMachine.g:6363:2: ( ruleResourceType )
            // InternalMachine.g:6364:3: ruleResourceType
            {
             before(grammarAccess.getResourceAccess().getResourceTypeResourceTypeEnumRuleCall_0_0()); 
            pushFollow(FOLLOW_2);
            ruleResourceType();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getResourceTypeResourceTypeEnumRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__ResourceTypeAssignment_0"


    // $ANTLR start "rule__Resource__NameAssignment_1"
    // InternalMachine.g:6373:1: rule__Resource__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Resource__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6377:1: ( ( RULE_ID ) )
            // InternalMachine.g:6378:2: ( RULE_ID )
            {
            // InternalMachine.g:6378:2: ( RULE_ID )
            // InternalMachine.g:6379:3: RULE_ID
            {
             before(grammarAccess.getResourceAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__NameAssignment_1"


    // $ANTLR start "rule__Resource__ItemsAssignment_2_1"
    // InternalMachine.g:6388:1: rule__Resource__ItemsAssignment_2_1 : ( ruleResourceItem ) ;
    public final void rule__Resource__ItemsAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6392:1: ( ( ruleResourceItem ) )
            // InternalMachine.g:6393:2: ( ruleResourceItem )
            {
            // InternalMachine.g:6393:2: ( ruleResourceItem )
            // InternalMachine.g:6394:3: ruleResourceItem
            {
             before(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__ItemsAssignment_2_1"


    // $ANTLR start "rule__Resource__ItemsAssignment_2_2_1"
    // InternalMachine.g:6403:1: rule__Resource__ItemsAssignment_2_2_1 : ( ruleResourceItem ) ;
    public final void rule__Resource__ItemsAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6407:1: ( ( ruleResourceItem ) )
            // InternalMachine.g:6408:2: ( ruleResourceItem )
            {
            // InternalMachine.g:6408:2: ( ruleResourceItem )
            // InternalMachine.g:6409:3: ruleResourceItem
            {
             before(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__ItemsAssignment_2_2_1"


    // $ANTLR start "rule__Resource__PeripheralsAssignment_4"
    // InternalMachine.g:6418:1: rule__Resource__PeripheralsAssignment_4 : ( rulePeripheral ) ;
    public final void rule__Resource__PeripheralsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6422:1: ( ( rulePeripheral ) )
            // InternalMachine.g:6423:2: ( rulePeripheral )
            {
            // InternalMachine.g:6423:2: ( rulePeripheral )
            // InternalMachine.g:6424:3: rulePeripheral
            {
             before(grammarAccess.getResourceAccess().getPeripheralsPeripheralParserRuleCall_4_0()); 
            pushFollow(FOLLOW_2);
            rulePeripheral();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getPeripheralsPeripheralParserRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__PeripheralsAssignment_4"


    // $ANTLR start "rule__Peripheral__NameAssignment_0"
    // InternalMachine.g:6433:1: rule__Peripheral__NameAssignment_0 : ( RULE_ID ) ;
    public final void rule__Peripheral__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6437:1: ( ( RULE_ID ) )
            // InternalMachine.g:6438:2: ( RULE_ID )
            {
            // InternalMachine.g:6438:2: ( RULE_ID )
            // InternalMachine.g:6439:3: RULE_ID
            {
             before(grammarAccess.getPeripheralAccess().getNameIDTerminalRuleCall_0_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getNameIDTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__NameAssignment_0"


    // $ANTLR start "rule__Peripheral__TypeAssignment_2"
    // InternalMachine.g:6448:1: rule__Peripheral__TypeAssignment_2 : ( ( RULE_ID ) ) ;
    public final void rule__Peripheral__TypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6452:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6453:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6453:2: ( ( RULE_ID ) )
            // InternalMachine.g:6454:3: ( RULE_ID )
            {
             before(grammarAccess.getPeripheralAccess().getTypePeripheralTypeCrossReference_2_0()); 
            // InternalMachine.g:6455:3: ( RULE_ID )
            // InternalMachine.g:6456:4: RULE_ID
            {
             before(grammarAccess.getPeripheralAccess().getTypePeripheralTypeIDTerminalRuleCall_2_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getTypePeripheralTypeIDTerminalRuleCall_2_0_1()); 

            }

             after(grammarAccess.getPeripheralAccess().getTypePeripheralTypeCrossReference_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__TypeAssignment_2"


    // $ANTLR start "rule__Peripheral__AxisPositionsAssignment_3_1_0_2"
    // InternalMachine.g:6467:1: rule__Peripheral__AxisPositionsAssignment_3_1_0_2 : ( ruleAxisPositionsMapEntry ) ;
    public final void rule__Peripheral__AxisPositionsAssignment_3_1_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6471:1: ( ( ruleAxisPositionsMapEntry ) )
            // InternalMachine.g:6472:2: ( ruleAxisPositionsMapEntry )
            {
            // InternalMachine.g:6472:2: ( ruleAxisPositionsMapEntry )
            // InternalMachine.g:6473:3: ruleAxisPositionsMapEntry
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsAxisPositionsMapEntryParserRuleCall_3_1_0_2_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionsMapEntry();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getAxisPositionsAxisPositionsMapEntryParserRuleCall_3_1_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__AxisPositionsAssignment_3_1_0_2"


    // $ANTLR start "rule__Peripheral__PositionsAssignment_3_1_1_2"
    // InternalMachine.g:6482:1: rule__Peripheral__PositionsAssignment_3_1_1_2 : ( ruleSymbolicPosition ) ;
    public final void rule__Peripheral__PositionsAssignment_3_1_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6486:1: ( ( ruleSymbolicPosition ) )
            // InternalMachine.g:6487:2: ( ruleSymbolicPosition )
            {
            // InternalMachine.g:6487:2: ( ruleSymbolicPosition )
            // InternalMachine.g:6488:3: ruleSymbolicPosition
            {
             before(grammarAccess.getPeripheralAccess().getPositionsSymbolicPositionParserRuleCall_3_1_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleSymbolicPosition();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getPositionsSymbolicPositionParserRuleCall_3_1_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__PositionsAssignment_3_1_1_2"


    // $ANTLR start "rule__Peripheral__ProfilesAssignment_3_1_4"
    // InternalMachine.g:6497:1: rule__Peripheral__ProfilesAssignment_3_1_4 : ( ruleProfile ) ;
    public final void rule__Peripheral__ProfilesAssignment_3_1_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6501:1: ( ( ruleProfile ) )
            // InternalMachine.g:6502:2: ( ruleProfile )
            {
            // InternalMachine.g:6502:2: ( ruleProfile )
            // InternalMachine.g:6503:3: ruleProfile
            {
             before(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_4_0()); 
            pushFollow(FOLLOW_2);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__ProfilesAssignment_3_1_4"


    // $ANTLR start "rule__Peripheral__ProfilesAssignment_3_1_5_1"
    // InternalMachine.g:6512:1: rule__Peripheral__ProfilesAssignment_3_1_5_1 : ( ruleProfile ) ;
    public final void rule__Peripheral__ProfilesAssignment_3_1_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6516:1: ( ( ruleProfile ) )
            // InternalMachine.g:6517:2: ( ruleProfile )
            {
            // InternalMachine.g:6517:2: ( ruleProfile )
            // InternalMachine.g:6518:3: ruleProfile
            {
             before(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_5_1_0()); 
            pushFollow(FOLLOW_2);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__ProfilesAssignment_3_1_5_1"


    // $ANTLR start "rule__Peripheral__DistancesAssignment_3_1_7_2"
    // InternalMachine.g:6527:1: rule__Peripheral__DistancesAssignment_3_1_7_2 : ( ruleDistance ) ;
    public final void rule__Peripheral__DistancesAssignment_3_1_7_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6531:1: ( ( ruleDistance ) )
            // InternalMachine.g:6532:2: ( ruleDistance )
            {
            // InternalMachine.g:6532:2: ( ruleDistance )
            // InternalMachine.g:6533:3: ruleDistance
            {
             before(grammarAccess.getPeripheralAccess().getDistancesDistanceParserRuleCall_3_1_7_2_0()); 
            pushFollow(FOLLOW_2);
            ruleDistance();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getDistancesDistanceParserRuleCall_3_1_7_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__DistancesAssignment_3_1_7_2"


    // $ANTLR start "rule__Peripheral__PathsAssignment_3_1_8_2"
    // InternalMachine.g:6542:1: rule__Peripheral__PathsAssignment_3_1_8_2 : ( rulePath ) ;
    public final void rule__Peripheral__PathsAssignment_3_1_8_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6546:1: ( ( rulePath ) )
            // InternalMachine.g:6547:2: ( rulePath )
            {
            // InternalMachine.g:6547:2: ( rulePath )
            // InternalMachine.g:6548:3: rulePath
            {
             before(grammarAccess.getPeripheralAccess().getPathsPathParserRuleCall_3_1_8_2_0()); 
            pushFollow(FOLLOW_2);
            rulePath();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getPathsPathParserRuleCall_3_1_8_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__PathsAssignment_3_1_8_2"


    // $ANTLR start "rule__Distance__NameAssignment_1"
    // InternalMachine.g:6557:1: rule__Distance__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Distance__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6561:1: ( ( RULE_ID ) )
            // InternalMachine.g:6562:2: ( RULE_ID )
            {
            // InternalMachine.g:6562:2: ( RULE_ID )
            // InternalMachine.g:6563:3: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__NameAssignment_1"


    // $ANTLR start "rule__Distance__SettlingAssignment_2_1"
    // InternalMachine.g:6572:1: rule__Distance__SettlingAssignment_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Distance__SettlingAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6576:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6577:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6577:2: ( ( RULE_ID ) )
            // InternalMachine.g:6578:3: ( RULE_ID )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_1_0()); 
            // InternalMachine.g:6579:3: ( RULE_ID )
            // InternalMachine.g:6580:4: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__SettlingAssignment_2_1"


    // $ANTLR start "rule__Distance__SettlingAssignment_2_2_1"
    // InternalMachine.g:6591:1: rule__Distance__SettlingAssignment_2_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Distance__SettlingAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6595:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6596:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6596:2: ( ( RULE_ID ) )
            // InternalMachine.g:6597:3: ( RULE_ID )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_2_1_0()); 
            // InternalMachine.g:6598:3: ( RULE_ID )
            // InternalMachine.g:6599:4: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 

            }

             after(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__SettlingAssignment_2_2_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__KeyAssignment_1"
    // InternalMachine.g:6610:1: rule__AxisPositionsMapEntry__KeyAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionsMapEntry__KeyAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6614:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6615:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6615:2: ( ( RULE_ID ) )
            // InternalMachine.g:6616:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisCrossReference_1_0()); 
            // InternalMachine.g:6617:3: ( RULE_ID )
            // InternalMachine.g:6618:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__KeyAssignment_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__ValueAssignment_2_1"
    // InternalMachine.g:6629:1: rule__AxisPositionsMapEntry__ValueAssignment_2_1 : ( rulePosition ) ;
    public final void rule__AxisPositionsMapEntry__ValueAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6633:1: ( ( rulePosition ) )
            // InternalMachine.g:6634:2: ( rulePosition )
            {
            // InternalMachine.g:6634:2: ( rulePosition )
            // InternalMachine.g:6635:3: rulePosition
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__ValueAssignment_2_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__ValueAssignment_2_2_1"
    // InternalMachine.g:6644:1: rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 : ( rulePosition ) ;
    public final void rule__AxisPositionsMapEntry__ValueAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6648:1: ( ( rulePosition ) )
            // InternalMachine.g:6649:2: ( rulePosition )
            {
            // InternalMachine.g:6649:2: ( rulePosition )
            // InternalMachine.g:6650:3: rulePosition
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__ValueAssignment_2_2_1"


    // $ANTLR start "rule__Position__NameAssignment_1"
    // InternalMachine.g:6659:1: rule__Position__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Position__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6663:1: ( ( RULE_ID ) )
            // InternalMachine.g:6664:2: ( RULE_ID )
            {
            // InternalMachine.g:6664:2: ( RULE_ID )
            // InternalMachine.g:6665:3: RULE_ID
            {
             before(grammarAccess.getPositionAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPositionAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__NameAssignment_1"


    // $ANTLR start "rule__SymbolicPosition__NameAssignment_1"
    // InternalMachine.g:6674:1: rule__SymbolicPosition__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__SymbolicPosition__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6678:1: ( ( RULE_ID ) )
            // InternalMachine.g:6679:2: ( RULE_ID )
            {
            // InternalMachine.g:6679:2: ( RULE_ID )
            // InternalMachine.g:6680:3: RULE_ID
            {
             before(grammarAccess.getSymbolicPositionAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__NameAssignment_1"


    // $ANTLR start "rule__SymbolicPosition__AxisPositionAssignment_2_1"
    // InternalMachine.g:6689:1: rule__SymbolicPosition__AxisPositionAssignment_2_1 : ( ruleAxisPositionMapEntry ) ;
    public final void rule__SymbolicPosition__AxisPositionAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6693:1: ( ( ruleAxisPositionMapEntry ) )
            // InternalMachine.g:6694:2: ( ruleAxisPositionMapEntry )
            {
            // InternalMachine.g:6694:2: ( ruleAxisPositionMapEntry )
            // InternalMachine.g:6695:3: ruleAxisPositionMapEntry
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__AxisPositionAssignment_2_1"


    // $ANTLR start "rule__SymbolicPosition__AxisPositionAssignment_2_2_1"
    // InternalMachine.g:6704:1: rule__SymbolicPosition__AxisPositionAssignment_2_2_1 : ( ruleAxisPositionMapEntry ) ;
    public final void rule__SymbolicPosition__AxisPositionAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6708:1: ( ( ruleAxisPositionMapEntry ) )
            // InternalMachine.g:6709:2: ( ruleAxisPositionMapEntry )
            {
            // InternalMachine.g:6709:2: ( ruleAxisPositionMapEntry )
            // InternalMachine.g:6710:3: ruleAxisPositionMapEntry
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__AxisPositionAssignment_2_2_1"


    // $ANTLR start "rule__AxisPositionMapEntry__KeyAssignment_1"
    // InternalMachine.g:6719:1: rule__AxisPositionMapEntry__KeyAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionMapEntry__KeyAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6723:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6724:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6724:2: ( ( RULE_ID ) )
            // InternalMachine.g:6725:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisCrossReference_1_0()); 
            // InternalMachine.g:6726:3: ( RULE_ID )
            // InternalMachine.g:6727:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__KeyAssignment_1"


    // $ANTLR start "rule__AxisPositionMapEntry__ValueAssignment_3"
    // InternalMachine.g:6738:1: rule__AxisPositionMapEntry__ValueAssignment_3 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionMapEntry__ValueAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6742:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6743:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6743:2: ( ( RULE_ID ) )
            // InternalMachine.g:6744:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionCrossReference_3_0()); 
            // InternalMachine.g:6745:3: ( RULE_ID )
            // InternalMachine.g:6746:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionIDTerminalRuleCall_3_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionIDTerminalRuleCall_3_0_1()); 

            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionCrossReference_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__ValueAssignment_3"


    // $ANTLR start "rule__Profile__NameAssignment_1"
    // InternalMachine.g:6757:1: rule__Profile__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Profile__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6761:1: ( ( RULE_ID ) )
            // InternalMachine.g:6762:2: ( RULE_ID )
            {
            // InternalMachine.g:6762:2: ( RULE_ID )
            // InternalMachine.g:6763:3: RULE_ID
            {
             before(grammarAccess.getProfileAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getProfileAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__NameAssignment_1"


    // $ANTLR start "rule__UnidirectionalPath__SourceAssignment_1"
    // InternalMachine.g:6772:1: rule__UnidirectionalPath__SourceAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__SourceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6776:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6777:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6777:2: ( ( RULE_ID ) )
            // InternalMachine.g:6778:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionCrossReference_1_0()); 
            // InternalMachine.g:6779:3: ( RULE_ID )
            // InternalMachine.g:6780:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__SourceAssignment_1"


    // $ANTLR start "rule__UnidirectionalPath__TargetAssignment_3"
    // InternalMachine.g:6791:1: rule__UnidirectionalPath__TargetAssignment_3 : ( rulePathTargetReference ) ;
    public final void rule__UnidirectionalPath__TargetAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6795:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6796:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6796:2: ( rulePathTargetReference )
            // InternalMachine.g:6797:3: rulePathTargetReference
            {
             before(grammarAccess.getUnidirectionalPathAccess().getTargetPathTargetReferenceParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getUnidirectionalPathAccess().getTargetPathTargetReferenceParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__TargetAssignment_3"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_0_1"
    // InternalMachine.g:6806:1: rule__UnidirectionalPath__ProfilesAssignment_4_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6810:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6811:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6811:2: ( ( RULE_ID ) )
            // InternalMachine.g:6812:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 
            // InternalMachine.g:6813:3: ( RULE_ID )
            // InternalMachine.g:6814:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_0_1"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1"
    // InternalMachine.g:6825:1: rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6829:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6830:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6830:2: ( ( RULE_ID ) )
            // InternalMachine.g:6831:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 
            // InternalMachine.g:6832:3: ( RULE_ID )
            // InternalMachine.g:6833:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_1_1"
    // InternalMachine.g:6844:1: rule__UnidirectionalPath__ProfilesAssignment_4_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6848:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6849:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6849:2: ( ( RULE_ID ) )
            // InternalMachine.g:6850:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 
            // InternalMachine.g:6851:3: ( RULE_ID )
            // InternalMachine.g:6852:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_1_1"


    // $ANTLR start "rule__UnidirectionalPath__AnnotationsAssignment_5_1"
    // InternalMachine.g:6863:1: rule__UnidirectionalPath__AnnotationsAssignment_5_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__AnnotationsAssignment_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6867:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6868:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6868:2: ( ( RULE_ID ) )
            // InternalMachine.g:6869:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 
            // InternalMachine.g:6870:3: ( RULE_ID )
            // InternalMachine.g:6871:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__AnnotationsAssignment_5_1"


    // $ANTLR start "rule__BidirectionalPath__EndPointsAssignment_1"
    // InternalMachine.g:6882:1: rule__BidirectionalPath__EndPointsAssignment_1 : ( rulePathTargetReference ) ;
    public final void rule__BidirectionalPath__EndPointsAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6886:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6887:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6887:2: ( rulePathTargetReference )
            // InternalMachine.g:6888:3: rulePathTargetReference
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__EndPointsAssignment_1"


    // $ANTLR start "rule__BidirectionalPath__EndPointsAssignment_3"
    // InternalMachine.g:6897:1: rule__BidirectionalPath__EndPointsAssignment_3 : ( rulePathTargetReference ) ;
    public final void rule__BidirectionalPath__EndPointsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6901:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6902:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6902:2: ( rulePathTargetReference )
            // InternalMachine.g:6903:3: rulePathTargetReference
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__EndPointsAssignment_3"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_0_1"
    // InternalMachine.g:6912:1: rule__BidirectionalPath__ProfilesAssignment_4_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6916:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6917:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6917:2: ( ( RULE_ID ) )
            // InternalMachine.g:6918:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 
            // InternalMachine.g:6919:3: ( RULE_ID )
            // InternalMachine.g:6920:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_0_1"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_0_2_1"
    // InternalMachine.g:6931:1: rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6935:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6936:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6936:2: ( ( RULE_ID ) )
            // InternalMachine.g:6937:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 
            // InternalMachine.g:6938:3: ( RULE_ID )
            // InternalMachine.g:6939:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_0_2_1"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_1_1"
    // InternalMachine.g:6950:1: rule__BidirectionalPath__ProfilesAssignment_4_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6954:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6955:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6955:2: ( ( RULE_ID ) )
            // InternalMachine.g:6956:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 
            // InternalMachine.g:6957:3: ( RULE_ID )
            // InternalMachine.g:6958:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_1_1"


    // $ANTLR start "rule__BidirectionalPath__AnnotationsAssignment_5_1"
    // InternalMachine.g:6969:1: rule__BidirectionalPath__AnnotationsAssignment_5_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__AnnotationsAssignment_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6973:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6974:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6974:2: ( ( RULE_ID ) )
            // InternalMachine.g:6975:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 
            // InternalMachine.g:6976:3: ( RULE_ID )
            // InternalMachine.g:6977:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__AnnotationsAssignment_5_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_0_1"
    // InternalMachine.g:6988:1: rule__FullMeshPath__ProfilesAssignment_3_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6992:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6993:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6993:2: ( ( RULE_ID ) )
            // InternalMachine.g:6994:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_1_0()); 
            // InternalMachine.g:6995:3: ( RULE_ID )
            // InternalMachine.g:6996:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_0_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_0_2_1"
    // InternalMachine.g:7007:1: rule__FullMeshPath__ProfilesAssignment_3_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7011:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7012:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7012:2: ( ( RULE_ID ) )
            // InternalMachine.g:7013:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_2_1_0()); 
            // InternalMachine.g:7014:3: ( RULE_ID )
            // InternalMachine.g:7015:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_2_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_0_2_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_1_1"
    // InternalMachine.g:7026:1: rule__FullMeshPath__ProfilesAssignment_3_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7030:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7031:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7031:2: ( ( RULE_ID ) )
            // InternalMachine.g:7032:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_1_1_0()); 
            // InternalMachine.g:7033:3: ( RULE_ID )
            // InternalMachine.g:7034:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_1_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_1_1"


    // $ANTLR start "rule__FullMeshPath__AnnotationsAssignment_4_1"
    // InternalMachine.g:7045:1: rule__FullMeshPath__AnnotationsAssignment_4_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__AnnotationsAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7049:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7050:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7050:2: ( ( RULE_ID ) )
            // InternalMachine.g:7051:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationCrossReference_4_1_0()); 
            // InternalMachine.g:7052:3: ( RULE_ID )
            // InternalMachine.g:7053:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_4_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_4_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationCrossReference_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__AnnotationsAssignment_4_1"


    // $ANTLR start "rule__FullMeshPath__EndPointsAssignment_5"
    // InternalMachine.g:7064:1: rule__FullMeshPath__EndPointsAssignment_5 : ( rulePathTargetReference ) ;
    public final void rule__FullMeshPath__EndPointsAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7068:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:7069:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:7069:2: ( rulePathTargetReference )
            // InternalMachine.g:7070:3: rulePathTargetReference
            {
             before(grammarAccess.getFullMeshPathAccess().getEndPointsPathTargetReferenceParserRuleCall_5_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getFullMeshPathAccess().getEndPointsPathTargetReferenceParserRuleCall_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__EndPointsAssignment_5"


    // $ANTLR start "rule__PathTargetReference__PositionAssignment_1"
    // InternalMachine.g:7079:1: rule__PathTargetReference__PositionAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__PositionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7083:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7084:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7084:2: ( ( RULE_ID ) )
            // InternalMachine.g:7085:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionCrossReference_1_0()); 
            // InternalMachine.g:7086:3: ( RULE_ID )
            // InternalMachine.g:7087:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__PositionAssignment_1"


    // $ANTLR start "rule__PathTargetReference__SettlingAssignment_2_1"
    // InternalMachine.g:7098:1: rule__PathTargetReference__SettlingAssignment_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__SettlingAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7102:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7103:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7103:2: ( ( RULE_ID ) )
            // InternalMachine.g:7104:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_1_0()); 
            // InternalMachine.g:7105:3: ( RULE_ID )
            // InternalMachine.g:7106:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__SettlingAssignment_2_1"


    // $ANTLR start "rule__PathTargetReference__SettlingAssignment_2_2_1"
    // InternalMachine.g:7117:1: rule__PathTargetReference__SettlingAssignment_2_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__SettlingAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7121:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7122:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7122:2: ( ( RULE_ID ) )
            // InternalMachine.g:7123:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_2_1_0()); 
            // InternalMachine.g:7124:3: ( RULE_ID )
            // InternalMachine.g:7125:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__SettlingAssignment_2_2_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x00000000000CF800L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000040002L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000000083802L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000020020L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000022L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000320000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000005000000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000008000000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000010010000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000028000000L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x0000000380020000L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x0000000380000000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000C00000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000040000020020L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000040000000022L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x000000000A000000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000001000000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000002000000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x000000C000000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000010000000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000010000000002L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000020000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000040000000020L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000010000020020L});

}